// -------------------------------------------------------------------------
// BALDUR - Der laeuft schon mal 
// -------------------------------------------------------------------------

package baldur;
import java.lang.Math;
import algds.c2002.Hamster2;

public class Baldur extends Hamster2 {

// -------------------------------------------------------------------------

// EINSTELLUNGEN //
boolean DROP               = true;    // Koerner zwischendurch ablegen
boolean DEEP_INTRUSION     = true;    // 'hohe' Exits bevorzugen
boolean DISTANCE_UPDATE    = true;    // Entfernung schneller aktualisieren
boolean LOWEST_IF_FULL     = true;    // Zum Nest zurueck wenn Voll
boolean FETCH_NEARBY_CORNS = false;   // Exits mit Koernern bevorzugen
boolean DONT_JUMP_CLIFFS   = true;    // Keine Klippen runterspringen

boolean finished           = false;   // Abbruchbedingung
int orientierung           = 0;       // Die Richtung in die er schaut
int entfernung             = 0;       // Entfernung zum Nest

Feld   hier  = new Feld();            // Das aktuelle Feld
Memory MyMem = new Memory();          // Baldur's Gedaechtnis

// -------------------------------------------------------------------------

public void run() 
{
  finished = false;

  while (!finished) 
    makeitso();
}

// -------------------------------------------------------------------------

// Hauptroutine

private void makeitso() 
{
  /* --- Informationen sammeln --- */

  int exits[];
  int exit = -1;

  exits = get_exit_list();		// holt sich alle Ausgaenge
  exits = avoid_taboos(exits);		// von Ausgaengen Taboos rausloeschen

  if ( exits.length == 1 )		// Wenn Sackgasse
    if ( getAvailableCorn() == 0 )      // und leer
      add_taboo(hier);			// zur Tabooliste hinzufuegen

  if ( exits.length == 0 )		// Wenn es keinen Ausgang gibt
    finished = true;			// (alle auf Taboo) aufhoeren!

  if ( loop_detection(exits) )
    if ( getAvailableCorn() == 0 )
      add_taboo(hier);

  /* --- Aktionen Vor Ort --- */

  if (!finished)
  {
    if (FETCH_NEARBY_CORNS)
      exits = find_corned_exits(exits);

    exit = choose_exit(exits);

    if (DEEP_INTRUSION && getCarriedCorn() < CORNCARRY_MAX)
      exit = get_highest_exit(exits);

    if (LOWEST_IF_FULL && getCarriedCorn() == CORNCARRY_MAX)
      exit = get_lowest_exit(exits);

    if ( exit == -1 )
      finished = true;
    turn_to(exit);

    if ( DROP && get_exit_height(exit) > MyMem.Get_Distance(hier.X, hier.Y) )
      dropAll();    

  /* --- Bewegung --- */

    go();
    entfernung++;
    MyMem.Add_Distance(hier.X, hier.Y, entfernung);

    if (DISTANCE_UPDATE && MyMem.Get_Distance(hier.X, hier.Y) < entfernung) 
      entfernung = MyMem.Get_Distance(hier.X, hier.Y);
  }


  /* --- Koerner nehmen oder Zuhause ablegen --- */

  if (atHome())
  {
    if (verbose())  log ("Ich bin Zuhause!\n");
    dropAll();
    entfernung = 0;
  } 
  else
    take(CORNCARRY_MAX);
}    

// -------------------------------------------------------------------------

// laesst Hamster vorwaertsgehen und aktualisiert Koordinaten

private void go()
{
  hier.move(orientierung);
  forward();
}

// -------------------------------------------------------------------------

// Drehung nach links oder rechts mit Aktualisierung der Orientierung

private void turn_left()
{
  orientierung = (6+orientierung-1) % 6;
  turn(TURN_LEFT);
}

private void turn_right()
{
  orientierung = (orientierung+1) % 6;
  turn(TURN_RIGHT);
}

// Von beliebiger Ausrichtung in Richtung "dir" Drehen

private void turn_to(int dir)
{
  while (orientierung!=dir)
    turn_right();
}

// -------------------------------------------------------------------------

// Erstellt eine Liste der Ausgaenge

private int[] get_exit_list()
{
  int exit_list[] = new int[6];
  int i, counter=0;
  for (i=0;i<6;i++)   exit_list[i] = -1;

  for (i=0;i<6;i++)
  {
    turn_right();
    if (!wall())
    {
      exit_list[counter] = orientierung;
      counter++;
    }
  }

  int output[] = new int[counter];
  for (i=0;i<counter;i++)
    output[i] = exit_list[i];

  return (output);
}

// -------------------------------------------------------------------------

// Feld zum Taboo erklaeren, ausser Startfeld

private void add_taboo(Feld mypos)
{
  if ( mypos.X == 0  && mypos.Y == 0 )
    return;

  MyMem.Add2TabooList(mypos.X, mypos.Y); 
}

// Nachgucken ob Feld taboo ist

private boolean is_taboo(int myX, int myY)
{
  if ( MyMem.IsOnTabooList(myX, myY) )
    return (true);

  return (false);
}

// -------------------------------------------------------------------------

// Aus Ausgangsliste alle Tabooausgaenge rausloeschen

private int[] avoid_taboos(int arr[])
{
  Feld agent = new Feld();
  int exit_list[] = new int[6];
  int i, counter=0;

  for (i=0; i<6; i++)   exit_list[i] = -1;

  for (i=0; i<arr.length; i++)
  {
    agent.X = hier.X;
    agent.Y = hier.Y;
    agent.move( arr[i] );
    if ( !is_taboo( agent.X, agent.Y ) )
    {
      exit_list[counter] = arr[i];
      counter++;
    }  
  }

  int output[] = new int[counter];
  for (i=0; i<counter; i++)
    output[i] = exit_list[i];

  return (output);
}

// -------------------------------------------------------------------------

// Wenn alle angrenzenden Felder naeher am Nest sind, als das aktuelle,
// dann befinden wir uns in einer Schleife -> entsprechender Return

private boolean loop_detection(int arr[])
{
  Feld agent = new Feld();
  int i;

  int aktuelle_hoehe = MyMem.Get_Distance(hier.X, hier.Y);
  boolean loop_detected = true;

  for (i=0; i<arr.length; i++)
  {
    agent.X = hier.X;
    agent.Y = hier.Y;
    agent.move( arr[i] );

    int tmp_hoehe = MyMem.Get_Distance(agent.X, agent.Y);

    if ( tmp_hoehe == -1 || tmp_hoehe > aktuelle_hoehe )
      loop_detected = false;
  }
 
  if (loop_detected)
    return (true);
  return (false);
}

// -------------------------------------------------------------------------

// Guckt wie weit der Nachbarraum vom Nest entfernt ist

private int get_exit_height (int myExit)
{
  Feld agent = new Feld();

  agent.X = hier.X;
  agent.Y = hier.Y;
  agent.move( myExit );

  int myHeight = MyMem.Get_Distance(agent.X, agent.Y);

  return (myHeight);
}

// -------------------------------------------------------------------------

// Zufaellige Richtungsauswahl (vermeidet vorhergehenden Raum)

private int choose_exit(int arr[])
{
  int rnd = -1;

  if ( arr.length == 1 )
    return (arr[0]);

  if ( arr.length == 0 )
    return (-1);

  rnd = random(arr.length);
  rnd = arr[rnd];

  if ( rnd == ((orientierung+3)%6) )
    rnd = choose_exit(arr);

  return (rnd);
}

// -------------------------------------------------------------------------

// Sucht sich von den Nachbarraeumen den niedrigsten aus
// niedrigster = dem Nest am naechsten

private int get_lowest_exit(int arr[])
{
  Feld agent = new Feld();
  int lowest_exit  = 9999;
  int exit_depth   = 9999;

  if ( arr.length == 1 )
    return (arr[0]);

  if ( arr.length == 0 )
    return (-1);

  for (int i=0; i<arr.length; i++)
  {
    agent.X = hier.X;
    agent.Y = hier.Y;
    agent.move( arr[i] );

    int tmp_hoehe = MyMem.Get_Distance(agent.X, agent.Y);
    if ( tmp_hoehe < 0 )      tmp_hoehe = 9999;

    if ( tmp_hoehe < exit_depth )
    {
      lowest_exit = arr[i];
      exit_depth   = tmp_hoehe;
    }  
  }

  return(lowest_exit);
}

// -------------------------------------------------------------------------

// Sucht sich von den Nachbarraeumen den hoechsten aus
// hoechster = vom Nest am weitesten entfernter Raum

private int get_highest_exit(int arr[])
{
  Feld agent = new Feld();
  int highest_exit = -1;
  int exit_depth   = 0;

  if ( arr.length == 1 )
    return (arr[0]);

  if ( arr.length == 0 )
    return (-1);

  for (int i=0; i<arr.length; i++)
  {
    agent.X = hier.X;
    agent.Y = hier.Y;
    agent.move( arr[i] );

    int tmp_hoehe = MyMem.Get_Distance(agent.X, agent.Y);
    if ( tmp_hoehe < 0 )
      tmp_hoehe = 9999;

    if ( tmp_hoehe > exit_depth )
    { 
      highest_exit = arr[i];
      exit_depth   = tmp_hoehe;
    }  
  }

  return(highest_exit);
}

// -------------------------------------------------------------------------

// Falls es Ausgaenge mit Koernern gibt, loescht Hamster alle Ausgaenge ohne
// Koerner aus der Ausgaenge-Liste raus

private int[] find_corned_exits(int arr[])
{
  Feld agent = new Feld();
  int exit_list[] = new int[6];
  int i,counter = 0;
  int Old_orientierung = orientierung;

  for (i=0; i<6; i++)   exit_list[i] = -1;

  for (i=0; i<arr.length; i++)
  {
    agent.X = hier.X;
    agent.Y = hier.Y;
    agent.move( arr[i] );

    if ( MyMem.Get_Distance(agent.X, agent.Y) < 0 )
    {
      turn_to( arr[i] );
      if ( (lookForward() & CORNMASK) == CORN )
      {
        exit_list[counter] = arr[i];
        counter++;
      } 
    }   
  }

  turn_to(Old_orientierung);

  int output[] = new int[counter];
  for (i=0; i<counter; i++)
    output[i] = exit_list[i];

  if ( counter>0 )
    return (output);
  return (arr);
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

// Ueberpruefung ob in Blickrichtung eine Wand liegt
// (Klippen werden beruecksichtigt)

private boolean wall()
{
  boolean my_wall = false;

  if ( (lookForward() & WALLMASK) == WALL )
    my_wall = true;

  if ( (lookForward() & WALLMASK) == CLIFFUP )
    my_wall = true;

  if ( (lookForward() & WALLMASK) == CLIFFDOWN && DONT_JUMP_CLIFFS)
    my_wall = true;

  return (my_wall);
}

// -------------------------------------------------------------------------

public void dropAll()             { dropHere(CORNCARRY_MAX); }
public String getHamsterAuthor()  { return "Simone Motzkau"; }
public String getHamsterDate()    { return "19.01.2002"; }
public String getHamsterVersion() { return "3.8"; }

// -------------------------------------------------------------------------

// Wandelt Int-Array in String im
// Nur fuers Debuggen notwendig

private String print_array(int arr[])
{
  String str="";

  for (int i=0; i<arr.length; i++)
    str += (arr[i]+" ");

  return (str);
}

// -------------------------------------------------------------------------

// Zufallsgenerator

private int random(int max)
{
  int out = -1;
  out = (int) (Math.random() * max);
  return (out); 
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// -------------------------------------------------------------------------

}
