package bommel;
import algds.c2002.Hamster2;
import bommel.Const;
/**
 * Bommel
 */

/**
 * Hier beginnt die eigentliche Bommel_Klasse
 */
public class Bommel extends Hamster2 implements Const{

/**
 * Markierung, ob der Lauf beendet werden soll oder nicht.
 */
boolean finished = false;
/**
 * Markierung, ob es Klippen gibt oder nicht.
 */
boolean cliff = false;
/**
 * Erstellen einer Koordinate, die auf zu Hause zeigt.
 */
Coordinate c_Home = new Coordinate();

/**
 * Hauptmethode.
 * Geht sammeln, kehrt nach Hause zurueck und legt allen Mais ab,
 * bis er das Heimatfeld auf dem Hinweg wieder erreicht.
 */
public void run() {
    c_Home.set_Home();
    finished = false;
    while (!finished) {
        // neue Coordinate
        Coordinate c = new Coordinate();
        c.set_Home();
        // neues Array       
        Map map = new Map(ARRAY_MAX_X, ARRAY_MAX_Y, ARRAY_MAX_Z);
        map.init_Map();
        // HomeFeld ist visit
        map.set_value_Map(MAZELENGTH_MAX, MAZELENGTH_MAX, SEE, VISIT);  
        // HomeFeld distance ist 0
        map.set_value_Map(MAZELENGTH_MAX, MAZELENGTH_MAX, DIST, 0);     
        // neue Richtung (setzt auf N)
        Direction dir = new Direction();
        goShopping(dir, map, c);
    }//while (!finished)
}// run

/**
 * - Dreht sich im Kreis und schaut in alle Richtungen, 
 *   um Aufzeichnungen zu machen
 * - aber nur, wenn Feld nicht nicht VISIT oder zu Hause 
 */
public void lookAround(Direction dir, Map map, Coordinate c){
    if((lookHere() & CORNMASK) == CORN)
        map.set_value_Map(c.get_x(), c.get_y(), CO, getAvailableCorn());
    else
        map.set_value_Map(c.get_x(), c.get_y(), CO, -5);
    
    if(map.get_value_Map(c.get_x(), c.get_y(), SEE) != VISIT || c_Home.equals(c)){
        for(int x = 0; x <= 5; x++){
            turn(TURN_RIGHT);
            dir.right_Dir();
            if ((lookForward() & WALLMASK) != WALL){
                // in welche Richting kann ich schauen
                // setzt ins Array [x][y][0 .. 5] = 1
                // wenn Mauer setzt er 0 dort rein
                if ((lookForward() & WALLMASK) == CLIFFDOWN){
                    cliff = true;
                    map.set_value_Map(c.get_x(), c.get_y(), dir.get_Dir(), CLIFF_DOWN);
                    if ((lookForward() & CORNMASK) == CORN)
                        map.set_visit_Map(dir.get_Dir(), c.get_x(), c.get_y(), CORNFIELD_MAX);
                    else
                        map.set_visit_Map(dir.get_Dir(), c.get_x(), c.get_y(), WALL_YES);
                }
                if ((lookForward() & WALLMASK) == CLIFFUP){
                    cliff = true;
                    map.set_value_Map(c.get_x(), c.get_y(), dir.get_Dir(), CLIFF_UP);
                }
                if ((lookForward() & WALLMASK) != CLIFFDOWN &&
                    (lookForward() & WALLMASK) != CLIFFUP){
                        map.set_value_Map(c.get_x(), c.get_y(), dir.get_Dir(), WALL_NO);
                        if ((lookForward() & WALLMASK) != SLOPEUP){
                            if ((lookForward() & CORNMASK) == CORN)
                                map.set_visit_Map(dir.get_Dir(), c.get_x(), c.get_y(), CORNFIELD_MAX);
                            else
                                map.set_visit_Map(dir.get_Dir(), c.get_x(), c.get_y(), WALL_YES);
                        }else{     
                            map.set_visit_Map(dir.get_Dir(), c.get_x(), c.get_y(), WALL_YES);
                        }
                        map.check_INDIZ_Field(dir.get_Dir(), c.get_x(), c.get_y());
                }
            }
            else{
                map.set_value_Map(c.get_x(), c.get_y(), dir.get_Dir(), WALL_YES);
                map.check_INDIZ_Field(dir.get_Dir(), c.get_x(), c.get_y());
            }
        }
    }
}// lookAround

/**
 * Geht Corn sammeln, bis das Maul voll ist oder
 * zum nchsten INDIZ Feld.
 * Je nachdem, welches nher ist.
 */
private void goShopping(Direction dir, Map map, Coordinate c) {
    String s1 = "";
    int cli;
    boolean ende = false;
    lookAround(dir, map ,c);
    Coordinate c_Ziel = new Coordinate();
    Coordinate c_Corn = new Coordinate();
    
    while(!finished){
        while(!ende){
            if(cliff == false)
                cli = 0;
            else
                cli = 1;
            switch (cli){
// ------------------------es gibt keine Klippen-------------------------- //                
                case 0:
            // berechnet alle Wege neu        
            search_next_Field_Ext(dir, map, c);
            c_Ziel = map.get_minIndiz_Ext_Map();
            c_Corn = map.get_minCorn_Ext_Map();
            // es gibt keine neuen Felder mehr
            if(map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) == MAX_VALUE){
                // es gibt keine Felder mit Korn mehr -> Ende
                if(map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), CO) <= 0)
                    ende = true;
                else{
                    // es gibt noch Felder mit Korn
                    c_Ziel = c_Corn;
                    // wenn es noch Korn gibt, aber es lohnt sich nicht mehr -> Ende
                    if(c.equals(c_Home) && 
                        (map.get_Corn_Sum_Map() * POINTS_CORN < 
                         map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) * 2)){
                            ende = true;
                    }
                    else if(c.equals(c_Home) && 
                            map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) > MAX_WAY){
                                // wenn der Weg weiter ist, als ich an Pkt mache -> Ende
                                ende = true;
                    }
                    else{
                        if((map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) < 
                            map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST)) && 
                            getCarriedCorn() > 16){
                                goHome(dir, search_next_ZField(dir, map, c_Home, c), c);
                                dropAll();
                        }
                        else{
                            goZiel(dir, search_next_ZField(dir, map, c_Ziel, c), c, c_Ziel);
                            if((lookHere() & CORNMASK) == CORN){
                                take(CORNCARRY_MAX);
                                if((lookHere() & CORNMASK) == CORN)
                                    map.set_value_Map(c.get_x(), c.get_y(), CO, getAvailableCorn());
                                else
                                    map.set_value_Map(c.get_x(), c.get_y(), CO, -5);
                            }
                        }
                        if(CORNCARRY_MAX == getCarriedCorn()){
                            goHome(dir, search_next_ZField(dir, map, c_Home, c), c);
                            dropAll();
                        }
                    }
                }
            }
            // es gibt noch neue Felder zu entdecken
            else{
                // wenn ein Kornfeld gleich oder nher dran, dann lieber da hin
                if(map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) != MAX_VALUE && 
                    map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), DIST) != MAX_VALUE)
                    if(map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), DIST) <= 
                        map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST))
                        c_Ziel = c_Corn;
                // ist das Ziel dann weiter weg, als der gegebene maximalste Weg -> Ende
                if(c.equals(c_Home) && 
                    map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) > MAX_WAY){
                    ende = true;
                }
                else{
                    // wenn ich Korn(mehr als 16 Krener) dabei hab und das 
                    // HOME Feld ist in der Nhe -> geh ich mal abladen
                    if((map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) < 
                        map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST)) && 
                        getCarriedCorn() > 16){
                            goHome(dir, search_next_ZField(dir, map, c_Home, c), c);
                            dropAll();
                    }
                    else{
                        // sonst geht Bommel zum Ziel und sammelt
                        goZiel(dir, search_next_ZField(dir, map, c_Ziel, c), c, c_Ziel);
                        if((lookHere() & CORNMASK) == CORN){
                            take(CORNCARRY_MAX);
                            if((lookHere() & CORNMASK) == CORN)
                                map.set_value_Map(c.get_x(), c.get_y(), CO, getAvailableCorn());
                            else
                                map.set_value_Map(c.get_x(), c.get_y(), CO, -5);
                        }
                        // Bommel hat genug und geht nach Hause zum abladen
                        if(CORNCARRY_MAX == getCarriedCorn()){
                            goHome(dir, search_next_ZField(dir, map, c_Home, c), c);
                            dropAll();
                        }
                    }
                }
            }
            break;
// ------------------------es gibt Klippen-------------------------- //
                case 1:
            //---------------------------------------------------------------
            // von der Laufmethode genau so, wie "es gibt keine Klippen"
            // - es wird eine zustzliche Methoden verwendet
            //   search_next_Field_Ext(dir, map, c);        
            //   - es wird vorab geprft, welche Felder erreichbar sind
            //   - dieses geschiet auch, bevor Bommel nach Hause luft        
            //---------------------------------------------------------------        
            search_next_Field_Ext(dir, map, c);
            c_Ziel = map.get_minIndiz_Ext_Map();
            c_Corn = map.get_minCorn_Ext_Map();
            if(map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) == MAX_VALUE){
                if(map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), CO) <= 0)
                    ende = true;
                else{
                    c_Ziel = c_Corn;
                    if(map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) > MAX_WAY_EXT)
                        ende = true;
                    else{
                        if((map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) <
                            map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), DIST)) && 
                                getCarriedCorn() > 16)
                                    c_Ziel = c_Home;
                        goZiel(dir, search_next_ZField(dir, map, c_Ziel, c), c, c_Ziel);
                        if((lookHere() & CORNMASK) == CORN){
                            take(CORNCARRY_MAX);
                            if((lookHere() & CORNMASK) == CORN)
                                map.set_value_Map(c.get_x(), c.get_y(), CO, getAvailableCorn());
                            else
                                map.set_value_Map(c.get_x(), c.get_y(), CO, -5);
                        }
                    }
                    if(CORNCARRY_MAX == getCarriedCorn()){
                        search_next_ZField_Ext(dir, map, c, c_Home);
                        if(map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) != MAX_VALUE){
                            goHome_Ext(dir, search_next_ZField(dir, map, c_Home, c), c);
                            if(map.get_value_Map(c.get_x(), c.get_y(), DIST) == 1)
                                dropForward(CORNCARRY_MAX);
                            else
                                dropAll();
                        }
                    }
                }
            }
            else{ 
                if((map.get_value_Map(c_Corn.get_x(), c_Corn.get_y(), DIST) <
                    map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST)) && 
                    getCarriedCorn() != CORNCARRY_MAX){
                    c_Ziel = c_Corn;
                }
                if(map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST) > MAX_WAY_EXT)
                    ende = true;
                else{
                    if((map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) <
                        map.get_value_Map(c_Ziel.get_x(), c_Ziel.get_y(), DIST)) && 
                            getCarriedCorn() >= 16)
                            c_Ziel = c_Home;
                    goZiel(dir, search_next_ZField(dir, map, c_Ziel, c), c, c_Ziel);
                    if((lookHere() & CORNMASK) == CORN){
                        take(CORNCARRY_MAX);
                        if((lookHere() & CORNMASK) == CORN)
                            map.set_value_Map(c.get_x(), c.get_y(), CO, getAvailableCorn());
                        else
                            map.set_value_Map(c.get_x(), c.get_y(), CO, -5);
                    }
                    if(CORNCARRY_MAX == getCarriedCorn()){
                        search_next_ZField_Ext(dir, map, c, c_Home);
                        // kann home sehen?
                        if(map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) != MAX_VALUE){
                            goHome_Ext(dir, search_next_ZField(dir, map, c_Home, c), c);
                            if(map.get_value_Map(c.get_x(), c.get_y(), DIST) == 1)
                                dropForward(CORNCARRY_MAX);
                            else
                                dropAll();			    
                        }
                    }
                }
            }        
            break;
            }// switch
        }// while (!ende)
        // zum Schluss will Bommel nur noch nach Hause zum Winterschlaf
        goHome(dir, search_next_ZField(dir, map, c_Home, c), c);
        dropAll();
        finished = true;
    }// while (!finished)
}// goShopping

/**
 * Geht nach Hause.
 */
private void goHome(Direction dir, Map map, Coordinate c) {
    int home;
    Infopoint inf = new Infopoint();

    while(!atHome()){
        home = inf.bestWay_Info(c.get_x(), c.get_y(), map);
        while(home != dir.get_Dir()){
            turn(TURN_RIGHT);
            dir.right_Dir();
        }
        if(home == dir.get_Dir()){
            forward();
            switch (dir.get_Dir()){
                case 0:
                    c.go_N();
                    break;
                case 1:
                    c.go_NE();
                    break;
                case 2:
                    c.go_SE();
                    break;
                case 3:
                    c.go_S();
                    break;
                case 4:
                    c.go_SW();
                    break;
                case 5:
                    c.go_NW();
                    break;
                }// switch
            lookAround(dir, map ,c);
        }
    }
}// goHome

/**
 * Geht nach Hause, fr erweitete Labyrinthe.
 */
private void goHome_Ext(Direction dir, Map map, Coordinate c) {
    boolean ok = false;
    int home;
    Infopoint inf = new Infopoint();

    while(!atHome() && !ok){
        home = inf.bestWay_Info(c.get_x(), c.get_y(), map);
        while(home != dir.get_Dir()){
            turn(TURN_RIGHT);
            dir.right_Dir();
        }
        if(map.get_value_Map(c.get_x(), c.get_y(), DIST) == 1 &&
           map.get_value_Map(c_Home.get_x(), c_Home.get_y(), DIST) == 0 &&
           (lookForward() & WALLMASK) == CLIFFDOWN){
                ok = true;
        }else{
            if(home == dir.get_Dir()){
                forward();
                switch (dir.get_Dir()){
                    case 0:
                        c.go_N();
                        break;
                    case 1:
                        c.go_NE();
                        break;
                    case 2:
                        c.go_SE();
                        break;
                    case 3:
                        c.go_S();
                        break;
                    case 4:
                        c.go_SW();
                        break;
                    case 5:
                        c.go_NW();
                        break;
                }// switch
            }
            lookAround(dir, map ,c);
        }
    }
}// goHome_Ext

/**
 * Geht zum Ziel.
 */
private void goZiel(Direction dir, Map map, Coordinate c, Coordinate c_Z) {
    int home;
    Infopoint inf = new Infopoint();

    while(! c.equals(c_Z)){
        home = inf.bestWay_Info(c.get_x(), c.get_y(), map);
        while(home != dir.get_Dir()){
            turn(TURN_RIGHT);
            dir.right_Dir();
        }
        if(home == dir.get_Dir()){
            forward();
            switch (dir.get_Dir()){
                case 0:
                    c.go_N();
                    break;
                case 1:
                    c.go_NE();
                    break;
                case 2:
                    c.go_SE();
                    break;
                case 3:
                    c.go_S();
                    break;
                case 4:
                    c.go_SW();
                    break;
                case 5:
                    c.go_NW();
                    break;
                }// switch
            lookAround(dir, map, c);
            if(c_Home.equals(c))
                if(getCarriedCorn() >= 0)
                    dropAll();
        }// if(home == dir.get_Dir())
    }// while(! c.equals(c_Z))
}// goZiel

/**
 * sucht den krzeseten Weg -> ohne Klippen -> vom Zielfeld aus berechnet
 */
public Map search_next_ZField(Direction dir, Map map, Coordinate c_h, Coordinate c){
    map.calc_new_distance_ZMap(c_h, c);
    return map;
}// search_next_ZField

/**
 * sucht den krzeseten Weg -> mit Klippen -> vom Zielfeld aus berechnet
 */
public Map search_next_ZField_Ext(Direction dir, Map map, Coordinate c_h, Coordinate c){
    map.calc_new_distance_Ext_ZMap(c_h, c);
    return map;
}// search_next_ZField_Ext

/**
 * sucht den krzeseten Weg -> mit Klippen -> ob er Zielfeld erreicht
 * vom HOME Feld aus berechnet
 */
public Map search_next_Field_Ext(Direction dir, Map map, Coordinate c_h){
    map.calc_new_distance_Ext_Map(c_h);
    return map;
}// search_next_Field_Ext

/**
 * Legt alles ab, was er an Mais hat.
 */
public void dropAll() {
	int dropped = dropHere(CORNCARRY_MAX);
	if (verbose()) log(dropped + " corn dropped.\n");
}

/** Autor(en) des Hamsters. */
public String getHamsterAuthor() { return "Mirko Otto"; }

/** Datum der Hamsterversion. */
public String getHamsterDate() { return "06.03.2002"; }

/** Hamsterversion. */
public String getHamsterVersion() { return "Beta 0.07"; }

} // Bommel