package bommel;
import bommel.Const;
import algds.c2002.Hamster2;
import java.util.LinkedList;
/**
 * Klasse um das komplette Feld in einem Array 
 * darstellen zu knnen
 */
class Map implements Const{
    public int[][][] m;
    
    /**
     * Konstruktor
     * erzeugt ein leeres Feld mit der Gre, die ich brauche
     */
    public Map(){
        this.m = new int[ARRAY_MAX_X][ARRAY_MAX_Y][ARRAY_MAX_Z];
    }
    
    /**
     * Konstruktor
     * erzeugt ein leeres Feld mit bergebener Gre
     */
    public Map(int x, int y, int z){
        this.m = new int[x][y][z];
    }
    
    /**
     * das Feld wird mit Standartwerten initialisiert
     */
    public void init_Map(){
        for(int y = 0; y < this.m.length; y++)
            for (int x = 0; x < this.m[0].length; x++){
                for (int z = 0; z < this.m[0][0].length -1; z++)
                    set_value_Map(x, y, z, -5);
                set_value_Map(x, y, DIST, MAX_VALUE);
            }
    }// init_Map()
    
    /**
     * - alle Felder die VISIT oder INDIZ und Corn, 
     *   werden auf MAX_INDIZ gesetzt
     * - alle Felder die INDIZ --> check_Field
     */
    public void initDIST_Map(){
        for(int y = 0; y < this.m.length; y++)
            for (int x = 0; x < this.m[0].length; x++){
                if(get_value_Map(x, y, SEE) == INDIZ ||
                   (get_value_Map(x, y, SEE) == VISIT && 
                    get_value_Map(x, y, CO) > 0))
                        set_value_Map(x, y, DIST, MAX_INDIZ);
                if(get_value_Map(x, y, SEE) == INDIZ)
                    check_Field(x, y);	    
                else
                    set_value_Map(x, y, DIST, MAX_VALUE);
            }
    }// initDIST_Map
    
    /**
     * gibt das INDIZ Feld zurck, welches am wenigsten weit weg ist
     */
    public Coordinate get_minIndiz_Ext_Map(){
        Coordinate c_h = new Coordinate(0, 0);
        int i = MAX_VALUE;
        for(int y = 0; y < this.m.length; y++){
            for (int x = 0; x < this.m[0].length; x++){
                if(get_value_Map(x, y, SEE) == INDIZ)
                    if(get_value_Map(x, y, DIST) < i &&
                       get_value_Map(x, y, DIST) > 0 ){
                        if(calc_pot_ZField(x, y)){
                            i = get_value_Map(x, y, DIST);
                            c_h = new Coordinate(x, y);
                        }
                    }
            }
        }
        return c_h;
    }// get_minIndiz_Ext_Map
    /**
     * gibt das CO Feld zurck, welches am wenigsten weit weg ist
     */    
    public Coordinate get_minCorn_Ext_Map(){
        Coordinate c_h = new Coordinate(0, 0);
        int i = -5;
        int j = MAX_VALUE;
        for(int y = 0; y < this.m.length; y++){
            for (int x = 0; x < this.m[0].length; x++){
                if(get_value_Map(x, y, DIST) < j &&
                   get_value_Map(x, y, DIST) > 0){
                    if(get_value_Map(x, y, CO) > 0){
                        if(x != HOME_X || y != HOME_Y){
                            i = get_value_Map(x, y, CO);
                            j = get_value_Map(x, y, DIST);
                            c_h = new Coordinate(x, y);
                        }
                    }
                }
            }
        }
        return c_h;
    }// get_minCorn_Ext_Map
    
    /**
     * - gibt die Summe der Koerner zurueck, 
     *   die noch auf dem Feld liegen
     */    
    public int get_Corn_Sum_Map(){
        int Corn = 0;
        for(int y = 0; y < this.m.length; y++){
            for (int x = 0; x < this.m[0].length; x++){
                if(x != HOME_X || y != HOME_Y){
                    if(get_value_Map(x, y, CO) > 0) 
                        Corn = Corn + get_value_Map(x, y, CO);
                }
            }
        }
        return Corn;
    }// get_Corn_Sum_Map
        
    /**
     * setzt Werte an Positionen im Array
     */
    public void set_value_Map(int x, int y, int z, int k){
        this.m[x][y][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - N-Feld von hier
     */
    public void set_N(int x, int y, int z, int k){
        this.m[x][y-1][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - NE-Feld von hier
     */
    public void set_NE(int x, int y, int z, int k){
        this.m[x+1][y][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - SE-Feld von hier
     */
    public void set_SE(int x, int y, int z, int k){
        this.m[x+1][y+1][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - S-Feld von hier
     */
    public void set_S(int x, int y, int z, int k){
        this.m[x][y+1][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - SW-Feld von hier
     */
    public void set_SW(int x, int y, int z, int k){
        this.m[x-1][y][z] = k;
    }
    /**
     * - setzt Wert in das Array
     * - NW-Feld von hier
     */
    public void set_NW(int x, int y, int z, int k){
        this.m[x-1][y-1][z] = k;
    }
        
    /**
     * gibt Wert aus dem Array zurck
     */
    public int get_value_Map(int x, int y, int z){
        return this.m[x][y][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - N-Feld von hier
     */
    public int get_N(int x, int y, int z){
        return this.m[x][y-1][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - NE-Feld von hier
     */
    public int get_NE(int x, int y, int z){
        return this.m[x+1][y][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - SE-Feld von hier
     */
    public int get_SE(int x, int y, int z){
        return this.m[x+1][y+1][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - S-Feld von hier
     */
    public int get_S(int x, int y, int z){
        return this.m[x][y+1][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - SW-Feld von hier
     */
    public int get_SW(int x, int y, int z){
        return this.m[x-1][y][z];
    }
    /**
     * - gibt Wert aus dem Array zurck
     * - NW-Feld von hier
     */
    public int get_NW(int x, int y, int z){
        return this.m[x-1][y-1][z];
    }
    
    /**
     * - muss ich wirklich zu dem Feld ???
     * - rechnet Felder nebeneinander raus, die nicht 
     *   potenzielle Zielfelder sind
     */
    public boolean calc_pot_ZField(int x, int y){
        // wenn hier Korn, dann muss ich hin
	if(get_value_Map(x, y, CO) > 0)
            return true;
        
        int anz_INDIZ = 0;
	int anz_VISIT = 0;

        if(get_N(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
	if(get_N(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;

        if(get_NE(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
	if(get_NE(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;

        if(get_SE(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
	if(get_SE(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;
		
	if(get_S(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
	if(get_S(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;
	
        if(get_SW(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
        if(get_SW(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;
	
        if(get_NW(x, y, SEE) == INDIZ)
            anz_INDIZ = anz_INDIZ + 1;
        if(get_NW(x, y, SEE) == VISIT)
            anz_VISIT = anz_VISIT + 1;
	
        if(anz_INDIZ == 1 && anz_VISIT == 5){
            // - wo liegt das INDIZ Feld
            // - beachte ein paar Wnde und Korn, will
            //   mir den Weg ja nicht verbauen
            if(get_N(x, y, SEE) == INDIZ){
                if(get_N(x, y, CO) > 0)
                    return true;	
            if(get_N (x, y-1, SEE) == VISIT &&
                get_NE(x, y-1, SEE) == VISIT &&
                get_SE(x, y-1, SEE) == VISIT &&
                get_SW(x, y-1, SEE) == VISIT &&
                get_NW(x, y-1, SEE) == VISIT)
                if((get_NW(x, y, SE) == WALL_YES &&
                    get_NW(x, y, NE) == WALL_YES)   ||
                    (get_NE(x, y, SW) == WALL_YES &&
                    get_NE(x, y, NW) == WALL_YES))
                    return false;
                else
                    return true;
            }
            if(get_NE(x, y, SEE) == INDIZ){
                if(get_NE(x, y, CO) > 0)
                    return true;
                if(get_N (x+1, y, SEE) == VISIT &&
                    get_NE(x+1, y, SEE) == VISIT &&
                    get_SE(x+1, y, SEE) == VISIT &&
                    get_S (x+1, y, SEE) == VISIT &&
                    get_NW(x+1, y, SEE) == VISIT)
                    if((get_N(x, y, S) == WALL_YES &&
                        get_N(x, y, SE) == WALL_YES)    ||
                       (get_SE(x, y, N) == WALL_YES &&
                        get_SE(x, y, NW) == WALL_YES))
                        return false;
                    else
                        return true;
            }
            if(get_SE(x, y, SEE) == INDIZ){
                if(get_SE(x, y, CO) > 0)
                    return true;
                if(get_N (x+1, y+1, SEE) == VISIT &&
                    get_NE(x+1, y+1, SEE) == VISIT &&
                    get_SE(x+1, y+1, SEE) == VISIT &&
                    get_S (x+1, y+1, SEE) == VISIT &&
                    get_SW(x+1, y+1, SEE) == VISIT)
                    if((get_NE(x, y, SW) == WALL_YES &&
                        get_NE(x, y, S) == WALL_YES)    ||
                       (get_S(x, y, N) == WALL_YES &&
                        get_S(x, y, NE) == WALL_YES))
                        return false;
                    else
                        return true;
            }
            if(get_S(x, y, SEE) == INDIZ){
                if(get_S(x, y, CO) > 0)
                    return true;
                if(get_NE(x, y+1, SEE) == VISIT &&
                    get_SE(x, y+1, SEE) == VISIT &&
                    get_S (x, y+1, SEE) == VISIT &&
                    get_SW(x, y+1, SEE) == VISIT &&
                    get_NW(x, y+1, SEE) == VISIT)
                    if((get_SW(x, y, NE) == WALL_YES &&
                    	get_SW(x, y, SE) == WALL_YES)   ||
                       (get_SE(x, y, NW) == WALL_YES &&
                        get_SE(x, y, SW) == WALL_YES))
                        return false;
                    else
                        return true;
                }
            if(get_SW(x, y, SEE) == INDIZ){
                if(get_SW(x, y, CO) > 0)
                    return true;
                if(get_N (x-1, y, SEE) == VISIT &&
                    get_SE(x-1, y, SEE) == VISIT &&
                    get_S (x-1, y, SEE) == VISIT &&
                    get_SW(x-1, y, SEE) == VISIT &&
                    get_NW(x-1, y, SEE) == VISIT)
                    if((get_NW(x, y, SE) == WALL_YES &&
                        get_NW(x, y, S) == WALL_YES)    ||
                       (get_S(x, y, N) == WALL_YES &&
                        get_S(x, y, NW) == WALL_YES))
                        return false;
                    else
                        return true;
                }
            if(get_NW(x, y, SEE) == INDIZ){
                if(get_NW(x, y, CO) > 0)
                    return true;
                if(get_N (x-1, y-1, SEE) == VISIT &&
                    get_NE(x-1, y-1, SEE) == VISIT &&
                    get_S (x-1, y-1, SEE) == VISIT &&
                    get_SW(x-1, y-1, SEE) == VISIT &&
                    get_NW(x-1, y-1, SEE) == VISIT)
                    if((get_N(x, y, S) == WALL_YES &&
                        get_N(x, y, SW) == WALL_YES)    ||
                       (get_SW(x, y, N) == WALL_YES &&
                        get_SW(x, y, NE) == WALL_YES))
                        return false;
                    else
                        return true;
                }
            }// if(anz_INDIZ == 1 && anz_VISIT == 5)
            return true;
    }// calc_pot_ZField
        
    /**
     * - prft, ob ein INDIZ-Feld berhaupt noch angelaufen werden muss
     * - setzt es dann gleich visit und fllt es mit entsprechenden Werten
     */
    public void check_Field(int x, int y){
        if(get_N(x, y, SEE) == VISIT    &&
           get_NE(x,y, SEE) == VISIT    &&
           get_SE(x,y, SEE) == VISIT    &&
           get_S(x, y, SEE) == VISIT    &&
           get_SW(x,y, SEE) == VISIT    &&
           get_NW(x,y, SEE) == VISIT) {
                // setze auf visit
                set_value_Map(x, y, SEE, VISIT);
                // schaut nach N
                if(get_N(x, y, S) == WALL_NO)
                    set_value_Map(x, y, N, WALL_NO);
                if(get_N(x, y, S) == WALL_YES)
                    set_value_Map(x, y, N, WALL_YES);
                if(get_N(x, y, S) == CLIFF_UP)
                    set_value_Map(x, y, N, CLIFF_DOWN);
                if(get_N(x, y, S) == CLIFF_DOWN)
                    set_value_Map(x, y, N, CLIFF_UP);
                // schaut nach NE
                if(get_NE(x, y, SW) == WALL_NO)		 
                    set_value_Map(x, y, NE, WALL_NO);
                if(get_NE(x, y, SW) == WALL_YES)		   
                    set_value_Map(x, y, NE, WALL_YES);
                if(get_NE(x, y, SW) == CLIFF_UP)		   
                    set_value_Map(x, y, NE, CLIFF_DOWN);
                if(get_NE(x, y, SW) == CLIFF_DOWN)		   
                    set_value_Map(x, y, NE, CLIFF_UP);
                // schaut nach SE
                if(get_SE(x, y, NW) == WALL_NO)
                    set_value_Map(x, y, SE, WALL_NO);
                if(get_SE(x, y, NW) == WALL_YES)
                    set_value_Map(x, y, SE, WALL_YES);
                if(get_SE(x, y, NW) == CLIFF_UP)
                    set_value_Map(x, y, SE, CLIFF_DOWN);
                if(get_SE(x, y, NW) == CLIFF_DOWN)
                    set_value_Map(x, y, SE, CLIFF_UP);
                // schaut nach S
                if(get_S(x, y, N) == WALL_NO)
                    set_value_Map(x, y, S, WALL_NO);
                if(get_S(x, y, N) == WALL_YES)
                    set_value_Map(x, y, S, WALL_YES);
                if(get_S(x, y, N) == CLIFF_UP)
                    set_value_Map(x, y, S, CLIFF_DOWN);
                if(get_S(x, y, N) == CLIFF_DOWN)
                    set_value_Map(x, y, S, CLIFF_UP);
                // schaut nach SW
                if(get_SW(x, y, NE) == WALL_NO)
                    set_value_Map(x, y, SW, WALL_NO);
                if(get_SW(x, y, NE) == WALL_YES)
                    set_value_Map(x, y, SW, WALL_YES);
                if(get_SW(x, y, NE) == CLIFF_UP)
                    set_value_Map(x, y, SW, CLIFF_DOWN);
                if(get_SW(x, y, NE) == CLIFF_DOWN)
                    set_value_Map(x, y, SW, CLIFF_UP);
                // schaut nach NW
                if(get_NW(x, y, SE) == WALL_NO)
                    set_value_Map(x, y, NW, WALL_NO);
                if(get_NW(x, y, SE) == WALL_YES)
                    set_value_Map(x, y, NW, WALL_YES);
                if(get_NW(x, y, SE) == CLIFF_UP)
                    set_value_Map(x, y, NW, CLIFF_DOWN);
                if(get_NW(x, y, SE) == CLIFF_DOWN)
                    set_value_Map(x, y, NW, CLIFF_UP);
            }// if(get_N(x, y, SEE) == VISIT    &&
    }// check_Field
    
    /**
     * prft die Felder um mich rum, ob ich sie noch betreten muss
     */
    public void check_INDIZ_Field(int d, int x, int y){
        switch (d){
            case 0:
                if(get_N(x, y, SEE) == INDIZ)
                    check_Field(x, y-1);
                break;
            case 1:
                if(get_NE(x, y, SEE) == INDIZ)
                    check_Field(x+1, y);
                break;
            case 2:
                if(get_SE(x, y, SEE) == INDIZ)
                    check_Field(x+1, y+1);
                break;
            case 3:
                if(get_S(x, y, SEE) == INDIZ)
                    check_Field(x, y+1);
                break;
            case 4:
                if(get_SW(x, y, SEE) == INDIZ)
                    check_Field(x-1, y);
                break;
            case 5:
                if(get_NW(x, y, SEE) == INDIZ)
                    check_Field(x-1, y-1);
                break;
        }// switch
    }// check_INDIZ_Field
    
    /**
     * vom Standpunkt des Zielfeldes aus gesehen
     *
     * berechnet alle Werte neu, fr Zielfelder
     * bricht ab, wenn in Berechnung mein Feld erreicht 
     */
    public void calc_new_distance_ZMap(Coordinate c, Coordinate c_here){
        // Karte wird teilweise neu initialisiert
        initDIST_Map();
        // ZielFeld DIST wird auf Null gesetzt
        set_value_Map(c.get_x(),c.get_y(), DIST, 0);
        
        boolean ende = false;
        Coordinate c_h = new Coordinate();
        LinkedList list = new LinkedList();
        list.addLast(c);
        int x;
        int y;
        while(! list.isEmpty() || !ende){
            c_h = (Coordinate)list.removeFirst();
            x = c_h.get_x();
            y = c_h.get_y();
            // 1. falls das Feld INDIZ ist, kann ich nur
            //    in Felder sehen, die VISIT sind
            // 2. und von da aus nur in mein Feld, wenn
            //    kein WALL
            if(this.get_value_Map(x, y, SEE) == INDIZ){
                for(int i = 0; i < 6; i++){
                        switch (i){
                case 0:
                    if((get_N(x, y, SEE) == VISIT &&
                        get_N(x, y, S) != WALL_YES &&
                        get_N(x, y, S) != CLIFF_UP) &&
                        get_N(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_N(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y-1));
                    }
                    break;
                case 1:
                    if((get_NE(x, y, SEE) == VISIT &&
                        get_NE(x, y, SW) != WALL_YES &&
                        get_NE(x, y, SW) != CLIFF_UP) &&
                        get_NE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y));
                    }
                    break;
                case 2:
                    if((get_SE(x, y, SEE) == VISIT &&
                        get_SE(x, y, NW) != WALL_YES &&
                        get_SE(x, y, NW) != CLIFF_UP) &&
                        get_SE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y+1));
                    }
                    break;
                case 3:
                    if((get_S(x, y, SEE) == VISIT &&
                        get_S(x, y, N) != WALL_YES &&
                        get_S(x, y, N) != CLIFF_UP) &&
                        get_S(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_S(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y+1));
                    }
                    break;
                case 4:
                    if((get_SW(x, y, SEE) == VISIT &&
                        get_SW(x, y, NE) != WALL_YES &&
                        get_SW(x, y, NE) != CLIFF_UP) &&
                        get_SW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y));
                    }
                    break;
                case 5:
                    if((get_NW(x, y, SEE) == VISIT &&
                        get_NW(x, y, SE) != WALL_YES &&
                        get_NW(x, y, SE) != CLIFF_UP) &&
                        get_NW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y-1));
                    }
                    break;
                        }//switch
                }// for(int i = 0 ...)
                // vorzeitiges Ende, wenn mein jetziger Standort erreicht
                if(get_value_Map(c_here.x, c_here.y, SEE) < MAX_INDIZ && 
                   get_value_Map(c_here.x, c_here.y, SEE) > 0){
                        ende = true;
                }
            }// if(get_value_Map(x, y, SEE) == INDIZ)
            /*
             * das selbe noch mit visit Felder
             */
            if(get_value_Map(x, y, SEE) == VISIT){
                for(int i = 0; i < 6; i++){
                    if(get_value_Map(x, y, i) != WALL_YES &&
                       get_value_Map(x, y, i) != CLIFF_DOWN){
                            switch (i){
                case 0:
                    if(get_N(x, y, DIST) == MAX_VALUE || 
                       get_N(x, y, DIST) == MAX_INDIZ || 
                       get_N(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_N(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y-1));
                    }
                    break;
                case 1:
                    if(get_NE(x, y, DIST) == MAX_VALUE || 
                       get_NE(x, y, DIST) == MAX_INDIZ || 
                       get_NE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y));
                    }                  
                    break;
                case 2:
                    if(get_SE(x, y, DIST) == MAX_VALUE || 
                       get_SE(x, y, DIST) == MAX_INDIZ || 
                       get_SE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y+1));
                    }
                    break;
                case 3:
                    if(get_S(x, y, DIST) == MAX_VALUE || 
                       get_S(x, y, DIST) == MAX_INDIZ || 
                       get_S(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_S(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y+1));
                    }
                    break;
                case 4:
                    if(get_SW(x, y, DIST) == MAX_VALUE || 
                       get_SW(x, y, DIST) == MAX_INDIZ || 
                       get_SW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y));
                    }
                    break;
                case 5:
                    if(get_NW(x, y, DIST) == MAX_VALUE || 
                       get_NW(x, y, DIST) == MAX_INDIZ || 
                       get_NW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y-1));
                    }
                    break;
                        }
                    }// switch
                }// for(int i = 0 ...)
                // vorzeitiges Ende, wenn mein jetziger Standort erreicht
                if(get_value_Map(c_here.x, c_here.y, SEE) < MAX_INDIZ && 
                   get_value_Map(c_here.x, c_here.y, SEE) > 0){
                    ende = true;
                }
            }// if(get_value_Map(x, y, SEE) == VISIT)
        }// while
    }// calc_new_distance_ZMap
    
    /**
     * vom jetzigen Standpunkt aus gesehen
     *
     * berechnet alle erreichbaren Felder neu mit Abstandswerten, 
     * bis ich ein nchstes INDIZ-Feld oder CO-Feld sehe 
     */
    public void calc_new_distance_Ext_Map(Coordinate c){
        // Karte wird teilweise neu initialisiert
        initDIST_Map();
        // ZielFeld DIST wird auf Null gesetzt
        set_value_Map(c.get_x(),c.get_y(), DIST, 0);
        
        boolean In = false;
        boolean Co = false;
        boolean ende = false;
        Coordinate c_h = new Coordinate();
        LinkedList list = new LinkedList();
        list.addLast(c);
        int x;
        int y;
        while(! list.isEmpty()){
            c_h = (Coordinate)list.removeFirst();
            x = c_h.get_x();
            y = c_h.get_y();
            /*
             * nur fr visit Felder
             */
            if(get_value_Map(x, y, SEE) == VISIT){
                for(int i = 0; i < 6; i++){
                    if(get_value_Map(x, y, i) != WALL_YES &&
                       get_value_Map(x, y, i) != CLIFF_UP){
                        switch (i){
                case 0:
                    if(get_N(x, y, DIST) == MAX_VALUE ||
                       get_N(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_N(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y-1));
                    }
                    break;
                case 1:
                    if(get_NE(x, y, DIST) == MAX_VALUE ||
                       get_NE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y));
                    }                  
                    break;
                case 2:
                    if(get_SE(x, y, DIST) == MAX_VALUE ||
                       get_SE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y+1));
                    }
                    break;
                case 3:
                    if(get_S(x, y, DIST) == MAX_VALUE ||
                       get_S(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_S(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y+1));
                    }
                    break;
                case 4:
                    if(get_SW(x, y, DIST) == MAX_VALUE ||
                       get_SW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y));
                    }
                    break;
                case 5:
                    if(get_NW(x, y, DIST) == MAX_VALUE ||
                       get_NW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y-1));
                    }
                    break;
                        }
                    }// switch
                }// for(int i = 0 ...)
            }// if(get_value_Map(x, y, SEE) == VISIT)
            if(get_value_Map(x, y, SEE) == INDIZ &&
               get_value_Map(x, y, DIST) < MAX_INDIZ &&
               get_value_Map(x, y, DIST) > 0)
                In = true;
            if(get_value_Map(x, y, SEE) == VISIT &&
               get_value_Map(x, y, CO) > 0 &&
               (x != HOME_X && y != HOME_Y))
                Co = true;
            if(In || Co)
                ende = true;
        }// while
    }// calc_new_distance_Ext_Map
    
    /**
     * fr erweiterte Labyrinthe
     * vom jetzigen Standpunkt aus gesehen
     * 
     * es wird geprft, ob ich das Zielfeld erreichen kann?
     */         
    public void calc_new_distance_Ext_ZMap(Coordinate c, Coordinate c_z){
        // Karte wird teilweise neu initialisiert
        initDIST_Map();
        // ZielFeld DIST wird auf Null gesetzt
        set_value_Map(c.get_x(),c.get_y(), DIST, 0);
        
        boolean ende = false;
        Coordinate c_h = new Coordinate();
        LinkedList list = new LinkedList();
        list.addLast(c);
        int x;
        int y;
        while(! list.isEmpty() || !ende){
            c_h = (Coordinate)list.removeFirst();
            x = c_h.get_x();
            y = c_h.get_y();
            if(get_value_Map(x, y, SEE) == VISIT){
                for(int i = 0; i < 6; i++){
                    if(get_value_Map(x, y, i) != WALL_YES &&
                       get_value_Map(x, y, i) != CLIFF_UP){
                            switch (i){
                case 0:
                    if(get_N(x, y, DIST) == MAX_VALUE ||
                       get_N(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_N(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y-1));
                    }
                    break;
                case 1:
                    if(get_NE(x, y, DIST) == MAX_VALUE ||
                       get_NE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y));
                    }                  
                    break;
                case 2:
                    if(get_SE(x, y, DIST) == MAX_VALUE ||
                       get_SE(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x+1, y+1));
                    }
                    break;
                case 3:
                    if(get_S(x, y, DIST) == MAX_VALUE ||
                       get_S(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_S(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x, y+1));
                    }
                    break;
                case 4:
                    if(get_SW(x, y, DIST) == MAX_VALUE ||
                       get_SW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_SW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y));
                    }
                    break;
                case 5:
                    if(get_NW(x, y, DIST) == MAX_VALUE ||
                       get_NW(x, y, DIST) > get_value_Map(x, y, DIST) + 1){
                            set_NW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                            list.addLast(new Coordinate(x-1, y-1));
                    }
                    break;
                        }
                    }// switch
                }// for(int i = 0 ...)
                if(get_value_Map(c_z.get_x(), c_z.get_y(), SEE) < MAX_INDIZ && 
                   get_value_Map(c_z.get_x(), c_z.get_y(), SEE) > 0){
                    ende = true;
                }
            }// if(get_value_Map(x, y, SEE) == VISIT)
        }// while
    }// calc_new_distance_Ext_Map
        
    /**
     * diese Methode indiziert beim Laufen
     * 
     * indiziert alle Felder ringsherum, die ich sehen kann, 
     * aber noch nicht betreten habe
     */
    public void set_visit_Map(int d, int x, int y, int z){
        if(get_value_Map(x, y, SEE) == INDIZ)
           set_value_Map(x, y, SEE, VISIT);
        switch (d){
            case 0:
                if(get_N(x, y, SEE) == -5)
                    set_N(x, y, SEE, INDIZ);
                if(get_N(x, y, DIST) == MAX_VALUE ||
                   get_N(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_N(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_N(x, y, SEE) == INDIZ)
                        set_N(x, y, CO, z);
                break;
            case 1:
                if(get_NE(x, y, SEE) == -5)
                    set_NE(x, y, SEE, INDIZ);
                if(get_NE(x, y, DIST) == MAX_VALUE ||
                   get_NE(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_NE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_NE(x, y, SEE) == INDIZ)
                        set_NE(x, y, CO, z);
                break;
            case 2:
                if(get_SE(x, y, SEE) == -5)
                    set_SE(x, y, SEE, INDIZ);
                if(get_SE(x, y, DIST) == MAX_VALUE ||
                   get_SE(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_SE(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_SE(x, y, SEE) == INDIZ)
                        set_SE(x, y, CO, z);
                break;
            case 3:
                if(get_S(x, y, SEE) == -5)
                    set_S(x, y, SEE, INDIZ);
                if(get_S(x, y, DIST) == MAX_VALUE ||
                   get_S(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_S(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_S(x, y, SEE) == INDIZ)
                        set_S(x, y, CO, z);
                break;
            case 4:
                if(get_SW(x, y, SEE) == -5)
                    set_SW(x, y, SEE, INDIZ);
                if(get_SW(x, y, DIST) == MAX_VALUE ||
                   get_SW(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_SW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_SW(x, y, SEE) == INDIZ)
                        set_SW(x, y, CO, z);
                break;
            case 5:
                if(get_NW(x, y, SEE) == -5)
                    set_NW(x, y, SEE, INDIZ);
                if(get_NW(x, y, DIST) == MAX_VALUE ||
                   get_NW(x, y, DIST) > get_value_Map(x, y, DIST) + 1)
                        set_NW(x, y, DIST, get_value_Map(x, y, DIST) + 1);
                if(z > 0)
                    if(get_NW(x, y, SEE) == INDIZ)
                        set_NW(x, y, CO, z);
                break;
        }// switch
    }// set_visit_Map
}// Map