package carson;
import algds.c2002.*;
import java.awt.*;
import java.util.*;
/**
Strategie:<br>
Carson besitzt exakt dieselbe Strategie wie {@link warhamster.Warhamster Warhamster}, bis auf die
Tatsache, dass er sich bei der entscheidung, welches feld als naechstes zu betreten ist, immer fuer das
feld mit dem hoechsten wert entscheidet. Sollten zwei felder identische Werte haben, entscheidet er sich
zufaellig fuer ein feld, wobei der zufallszahlengenarator mit einem festen seed initialisiert wird, um
reproduzierbare ergebnisse zu liefern.
*/
public class	Carson
extends 	Hamster2
implements 	Constants,Hexfield_Constants{
    //********************MemberFunctions*********************
    /**siehe {@link warhamster.Warhamster#forward()}.*/
    public boolean  forward(){
        if ((Current.Border[Looking]==WALL)||
            (Current.Border[Looking]==CLIFFUP)||
            ((Current.Border[Looking]==CLIFFDOWN)&&!GoHome&&(!Current.get(Looking).Visited)
            ))
            return false;
        if (verbose()&&(Current.Border[Looking]==CLIFFDOWN))
            logln("Jumped to death.");
        if (!super.forward()) throw new Error("Forward buggy!");
        Steps++;
        //if (verbose()) logln("Stepped forward towards: "+Current);
        Current=Current.get(Looking).explore();
        return true;
    }
    /**Selbsterklaerend.*/
    public String   getHamsterAuthor() {return "HerbaCasipulensisGigantis und des Pudels Kern";}
    /**Selbsterklaerend.*/
    public String   getHamsterVersion(){return "0.000000... RC1";}
    /**siehe {@link warhamster.Warhamster#goHome()}.*/
    public boolean  goHome(){
        if (Stop) GoHome=true;
        logln("Going home.");
        if (Stop) logln("Stopping!");
        while (GoHome) stepTowards(Current.Homepath);
        logln("Reached home.");
        return true;
    }
    /**
    Herzstueck des hamsters. Initialiesiert alle wichtigen noch nicht initialisierten variablen,
    welche nicht bei instanziierung initialisiert werden.Arbeitsweise der haptnachrichtenschleife in
    Strategieerklaerung erlaeutert.<br>
    */
    public void     run(){
    try{
        Hexfield.Map    = new HexfieldHash(3000,.95f);
        Hexfield.Home   = new Hexfield();
        Hexfield.Soldier= this;
        Current         = Hexfield.Home;
        Home            = Hexfield.Home;
        Map             = Current.Map;
        Current.explore();
        
        do{
            Hexfield NextField=null;
            double BigValue=0;
            //Decide where to go
            for (byte i=0;i<6;i++){
                if ((Current.get(i)==null)||
                    (Current.Border[i]==WALL)||
                    (Current.Border[i]==CLIFFUP)||
                    ((Current.Border[i]==CLIFFDOWN)&&!Current.get(i).Visited)||
                    (i==Current.invert(Looking)))
                    continue;
                BigValue=(Current.get(i).Value>BigValue)?
                         (Current.get(i).Value):(BigValue);
            }
            for (byte i=0;i<6;i++){
                if ((Current.get(i)==null)||
                    (Current.Border[i]==WALL)||
                    (Current.Border[i]==CLIFFUP)||
                    ((Current.Border[i]==CLIFFDOWN)&&!Current.get(i).Visited)||
                    (i==Current.invert(Looking)))
                    continue;
                if ((BigValue==Current.get(i).Value)&&(NextField==null))
                    NextField=Current.get(i);
                else if (BigValue==Current.get(i).Value)
                    NextField=(CEO.nextBoolean())?(Current.get(i)):(NextField);
            }
            NextField=(BigValue==0)?(Current.get(Current.invert(Looking))):
                                    (NextField);
            if (verbose()) logln("Attempting to go to :"+NextField);
            if (!stepTowards(NextField))
                throw new Error("Basic Decision buggy!");
            if (GoHome||Stop) goHome();
        }while(!Stop);
        //while ((Current!=Home));
    }
    catch (Throwable X){
       logln("\nRun :"+X.getClass()+" thrown. ->"+X.getMessage());
       X.printStackTrace();
       Stop=true;goHome();
    }
    }

    /**siehe {@link warhamster.Warhamster#stepTowards(Hexfield toGoTo)}.*/
    public boolean  stepTowards(Hexfield toGoTo){
        for (byte i=0;i<6;i++){
            if (Current.get(i)==toGoTo) break;
            if (i==5) return false;
        }
        for (byte i=0;i<6;i++){
            turn(TURN_RIGHT);
            if (Current.get(Looking)==toGoTo) break;
        }
        return forward();
    }
    /**siehe {@link warhamster.Warhamster#turn(int Direction)}.*/
    public void     turn(int Direction){
        //if (verbose()) logln("Turning towards: "+Direction+"\nLooking before turn: "+Looking);
        switch(Looking){
        case NORTH:
            if (Direction==TURN_LEFT) Looking=6;
            break;
        case NWEST:
            if (Direction==TURN_RIGHT) Looking=-1;
            break;
        }
        if (Direction==TURN_LEFT) --Looking;
        else ++Looking;
        super.turn(Direction);
        //if (verbose()) logln("Looking after  turn: "+Looking);
    }

    //*************************Fields*************************
    /**Speichert himmelsrichtung, in welche hamster gerade schaut.*/
    public byte         Looking = NORTH;
    /**Zaehlt gelaufene schritte seit hamster das letzte mal korn aufgehoben, oder heimatfeld besucht hat.*/
    public long         Steps   = 0;
    /**Chief Executive Officer. Zufallsgenerator, der darueber entscheidet, welches feld carson betritt,
    falls zwei felder den gleichen wert haben. wird mit festem wert initialisiert.*/
    public Random       CEO     = new Random(667187);
    /**Flagge die gesetzt wird, um carson nach hause zu schicken.*/
    public boolean      GoHome  = false;
    /**Flagge die gesetzt wird, um carson zu stoppen.*/
    public boolean      Stop    = false;
    /**Speichert hexfeld, auf dem sich der hamster gerade befindet.*/
    public Hexfield     Current = null;
    /**Speichert heimatfeld.*/
    public Hexfield     Home    = null;
    /**Hash, in dem sich alle hexfelder befinden, von denen gewiss ist, dass sie existieren.
    Als schluessel werden punkte mit Koordinaten des Hexfelds benutzt.*/
    public HexfieldHash Map     = null;
}