package cch;
import algds.c2002.Hamster;

public class CCH extends Hamster{
      
// Aktuelle Position auf interer Karte
protected int xpos;
protected int ypos;

// Interne Variable fr Blickrichtung
protected int direction;

// Interne Karte 60x60
Field xyfield[][] = new Field[60][60];

Movestack movestack = new Movestack();

boolean finished = false;


// Heimatfeld wird initialisiert und Startrichtung festgelegt
public CCH() {
        xpos = 29;      	       	       	      
        ypos = 29;
        xyfield[xpos][ypos] = new Field();
        direction = 0;
        }

public void run() {
        while (!finished) {
		lookandmove();
		//logln("Koordinaten: " + xpos + "," + ypos);
                }
	dropHere(getCarriedCorn());
        }   

// Methode fr das Sehen und die Bewegung des Hamsters
void lookandmove() {
      boolean move = false;
      
      if (xpos == 29 && ypos == 29) dropHere(getCarriedCorn());
      
      // 1. Durchlauf, Wnde setzen
      // 2. Durchlauf, bewegen
      for (byte j = 0; j < 2; j++) {
	      // Falls Korn auf Feld > 20
	      if (j == 1) {
		      while (getAvailableCorn() > 0 && !(xpos == 29 && ypos == 29)) {
			      take(getAvailableCorn());
			      xyfield[xpos][ypos].setCorn(getAvailableCorn());
			      if (getCarriedCorn() == 20) bringHome();
	      	      	      }
	      	      }
      for (byte i = 0; i < 6; i++) {
      if (move) continue; 
      byte y = 0;
      byte x = 0;
      if (((lookForward() & WALLMASK) == WALL) == true) {
	      xyfield[xpos][ypos].setWall(direction);
	      turnright();
              }
      else {
	      // Falls keine Wand, berprfen, welche Felder schon gesehen wurden
              try {
                    switch(direction) {
                                case 0: y = 1;
                                        x = 1;
                                        xyfield[xpos + x][ypos + y].getVisited(); 
                                        break;
                                case 1: x = 1;
                                        xyfield[xpos + x][ypos].getVisited();
                                        break;
                                case 2: y = -1;
                                        xyfield[xpos][ypos + y].getVisited();
                                        break;
                                case 3: y = -1;
                                        x = -1;
                                        xyfield[xpos + x][ypos + y].getVisited();
                                        break;
                                case 4: x = -1;
                                        xyfield[xpos + x][ypos].getVisited();
                                        break;
                                case 5: y = 1;
                                        xyfield[xpos][ypos + y].getVisited();
                                        break;
                                        }
			turnright();  
                        }
	      // Feld wurde noch nicht gesehen -> intitialisieren -> besuchen
              catch (NullPointerException e) {
		      	       	       	      if (j == 0) {
						      turnright();
					              }
					      if (j == 1) {
					           xyfield[xpos][ypos].setVisited();
                                                   xpos = xpos + x;
                                                   ypos = ypos + y;
                                                   xyfield[xpos][ypos] = new Field();
						   movestack.push(xpos,ypos);
                                                   forward();
                                                   move = true;
					           }
                                              }
             }
             }
             }
	     // keine unbesuchten Felder -> zurck
	     if (!move) goback();
        }

// unbesuchte Felder im Umfeld?
boolean look(int x1, int y1) {
	 byte y = 0;
         byte x = 0;
	 for (int dir = 0; dir < 6; dir++) {
         if (!xyfield[x1][y1].getWall(dir)) {
	 try {
	 switch(dir) {
                                case 0: y = 1;
                                        x = 1;
                                        xyfield[x1 + x][y1 + y].getVisited(); 
                                        break;
                                case 1: x = 1;
                                        xyfield[x1 + x][y1].getVisited();
                                        break;
                                case 2: y = -1;
                                        xyfield[x1][y1 + y].getVisited();
                                        break;
                                case 3: y = -1;
                                        x = -1;
                                        xyfield[x1 + x][y1 + y].getVisited();
                                        break;
                                case 4: x = -1;
                                        xyfield[x1 + x][y1].getVisited();
                                        break;
                                case 5: y = 1;
                                        xyfield[x1][y1 + y].getVisited();
                                        break;
                                        }
	 }
	 catch (NullPointerException e) { return false; }
	 }
	 }
	 return true;
	}

// geht zurck bis zu einem Feld, wo unbesichtigte Felder angrenzen	
void goback() {
	int i = movestack.getMovecount();
	Point lastfield = movestack.getPoint(i);
	while(look(lastfield.x,lastfield.y) && (i > -2)) {
		i--;
		if (i > -1) lastfield = movestack.getPoint(i);
		}
	if (i < -1) { lastfield = movestack.getPoint(0); i = 1; finished = true; }
	while (xpos != lastfield.x || ypos != lastfield.y) {
		int j = i;
		Point movefield = lastfield;
		// Optimierung, gibt es Felder im Stack, die vor dem vorletzen liegen und angrenzen?
		while (!isnearfield(xpos, ypos, movefield.x, movefield.y)) movefield = movestack.getPoint(j++);
		int dir = calcDirection(xpos, ypos, movefield.x, movefield.y);
		while (dir != direction) turnright();
		xpos = movefield.x;
		ypos = movefield.y;
		forward();
		}
	//Movestack abtragen
	while (movestack.getPoint(movestack.getMovecount()) != lastfield) movestack.pop();
	}

// berprft ob zwei Felder nebeneinanderliegen und ob keine Wand dazwischen ist	
boolean isnearfield(int x1, int y1, int x2, int y2) {
	int xdiff = x2 - x1;
	int ydiff = y2 - y1;
	if (xdiff == 1 && ydiff == 1 && !xyfield[x1][y1].getWall(0)) return true; 
	if (xdiff == 1 && ydiff == 0 && !xyfield[x1][y1].getWall(1)) return true;
	if (xdiff == 0 && ydiff == -1 && !xyfield[x1][y1].getWall(2)) return true; 
	if (xdiff == -1 && ydiff == -1 && !xyfield[x1][y1].getWall(3)) return true; 
	if (xdiff == -1 && ydiff == 0 && !xyfield[x1][y1].getWall(4)) return true;
	if (xdiff == 0 && ydiff == 1 && !xyfield[x1][y1].getWall(5)) return true;
	return false;
	}
	 	

// Methode zum Rechtsdrehen (Aktualisierung der Blickrichtung)
void turnright() {
	turn(TURN_RIGHT);
	setDirection(++direction);
	}

// Berechnet Richtung von einem Punkt zum andern
int calcDirection(int x1, int y1, int x2, int y2) {
	int xdiff = x2 - x1;
	int ydiff = y2 - y1;
	switch (xdiff) {
		case 1: if (ydiff == 1) return 0; if (ydiff == 0) return 1; break;
		case -1: if (ydiff == -1) return 3; if (ydiff == 0) return 4; break;
		case 0: if (ydiff == -1) return 2; if (ydiff == 1) return 5; break;
		}
	return direction;
	}

// Methode um Richtung korrekt zu setzen
void setDirection(int dir) {
        direction = dir;
        if (dir > 5) direction = 0;
        if (dir < 0) direction = 5;
        }

// Falls 20 Krner im Maul -> Nachhause bringen
void bringHome() {
	//temporrer Stack fr optimalen Home-Weg
	Movestack tempstack = movestack;
	Point movefield = new Point(0, 0);
	int j = 0;
	while (!(xpos == 29 && ypos == 29)) {
		while (!isnearfield(xpos, ypos, movefield.x, movefield.y)) movefield = tempstack.getPoint(j++);
		j = 0;
		int dir = calcDirection(xpos, ypos, movefield.x, movefield.y);
		while (dir != direction) turnright();
		xpos = movefield.x;
		ypos = movefield.y;
		forward();
		}
	dropHere(getCarriedCorn());
	
	// ging es auf dem letzten Feld noch weiter?
	int k = movestack.getMovecount();
	Point lastfield = movestack.getPoint(k);
	if (xyfield[lastfield.x][lastfield.y].getCorn() == 0) {
		while(look(lastfield.x,lastfield.y) && k > -1) {
			lastfield = movestack.getPoint(k);
			k--;
			}
		}
	// Movestack bis zu diesem Feld abtragen
	while (movestack.getPoint(movestack.getMovecount()) != lastfield) movestack.pop();
			
	movefield = tempstack.getPoint(0);
	while (movefield != tempstack.getPoint(tempstack.getMovecount())) {
		j = tempstack.getMovecount();
		while (!isnearfield(xpos, ypos, movefield.x, movefield.y)) movefield = tempstack.getPoint(j--);
		int dir = calcDirection(xpos, ypos, movefield.x, movefield.y);
		while (dir != direction) turnright();
		xpos = movefield.x;
		ypos = movefield.y;
		forward();
		}
	}
	
  public String getHamsterAuthor() { return "Norbert Siegmund und Sebastian Weinhold"; }
  public String getHamsterVersion() { return "PreBeta 0.2.1 ;)"; }
  public String getHamsterDate() { return "29.04.2002"; }
  
	
         
}
