package ckp;

import algds.c2002.Hamster;
import algds.c2002.Constants;

public class ck extends Hamster {

/** Autor(en) des Hamsters. */
public String getHamsterAuthor() { return "Jan Koserski"; }

/** Datum der Hamsterversion. */
public String getHamsterDate() { return "28.04.2002"; }

/** Hamsterversion. */
public String getHamsterVersion() { return "1.01"; }

/** In wie weit ist der Lauf abgeschlossen? */
boolean allebesucht=false;		// Alle Felder erkundet (auer die von ck ausgeschlossenen)
boolean fertig=false;			// Alle Felder erkundet sowie kein "rentabler" Mais mehr vorhanden	

/** Virtuelle Hamsterkarte */
public static feld map [] [] = new feld [201] [201];

/** Hamster X- und Y-Koordinate sowie Richtung */
public static int hx=100;
public static int hy=100;
public static int hr=0;

/** Wieviele Felder geht man in Richtung x vorwrts? */
public static int deltax []= {0,1,1,0,-1,-1};
public static int deltay []= {-2,-1,1,2,1,-1};


public static double waende [] = new double[20];	// Speicherung der Anzahl der Wnde der letzen 20 besuchten Felder
public static int waendehier =0;					// Anzahl der Wnde des aktuellen Feldes
public static double w=0;							// gewichteter Mittelwert des arrays waende []
public boolean narrow=true;							// enges oder offenes Labyrinth??

/** Weg in linkedlist Form */
public static weg2 bestweg = new weg2();
public int bestrating = 0;		// Bewertung des besten gefundenen Weges
public int bestdistance = 0;	//Entfernung des besten gefunden Weges in Schritten
public int bestx = 0;			//x-Koordinate des Ziels
public int besty = 0;			//y-Koordinate des Ziels

/** 2D Array mit Distanzen von der aktuellen Position */
public static int distmap [] [] = new int [201] [201];

public int sr=0;

public void init_waende(){		//Array waende initialisieren
	for (int i=0;i<20;i++){
		waende[i]=1.25;
	}
}

public void init_map(){         // Karte zum Anfang initialisieren
	for (int x=1;x<201;x++){
		for (int y=1;y<201;y++){
			map[x][y]=new feld();
		}
	}
	map[100][100].besucht =true;
}
	

public void waendeschnitt (){	//gewichteter Mittelwert des arrays waende [] berechnen und in w speichern
	double summe=0;
	for (int i=0;i<19;i++){
		waende[i]=waende[i+1];
		summe=summe+(double) (waende[i]* (double)i/19);
	}
	waende[19]=waendehier;
	summe=summe+waende[19];
	w=(double) summe/20;
	return;
}


public void dreherechts(){		// ck dreht sich nach rechts
	turn(TURN_RIGHT);
	hr++;						
	if (hr==6) hr=0;
}


public void drehelinks(){		// ck dreht sich nach links
	turn(TURN_LEFT);
	hr--;
	if (hr==-1) hr=5;
}


public void gehe(){				// ck geht ein Feld nach vorn
	hx=hx+deltax[hr];
	hy=hy+deltay[hr];
	forward();
    map[hx][hy].besucht =true;	// beim neuen Feld wird besucht auf true gesetzt
}


public int gegenrichtung(int r){// gibt die Gegenrichtung einer bergebenen Richtung zurck
    r=r-3;
	if (r<0) r=r+6;
	return r;
}


public void erkunde(){			// ck schaut sich in alle Richtungen um, um Informationen zu gewinnen
	waendehier=0;
	for (int i=0; i<6; i++){
		if ((lookForward() & WALLMASK) == WALL) { // Ist eine Wand voraus?
			map [hx] [hy].rand[hr]=2;
			map [hx+deltax[hr]] [hy+deltay[hr]].rand[gegenrichtung(hr)]=2;
			waendehier++;
		}
		if ((lookForward() & WALLMASK) != WALL){ // Ist der Weg frei?
			map [hx] [hy].rand[hr]=1;
			map [hx+deltax[hr]] [hy+deltay[hr]].rand[gegenrichtung(hr)]=1;
		}
		if ((lookForward() & CORNMASK) == CORN) map [hx+deltax[hr]] [hy+deltay[hr]].maisda=true;  // Ist Mais voraus?
		dreherechts();
	}
work_map();						// Kann ck ein benachbartes Feld als besucht betrachten, ohne tatschlich dort gewesen zu sein?
}


public boolean zugaenglich (feld f){	// Ist das bergebene Feld fr ck zugnglich?
	for (int i=0;i<6;i++){
		if (f.rand[i]==1) return true;
	}
	return false;
}


public void work_map(){			// Kann ck ein benachbartes Feld als besucht betrachten, ohne tatschlich dort gewesen zu sein?

	for (int x=hx-4;x<hx+4;x++){		// Betrachte die umgebenen Felder
		for (int y=hy-4;y<hy+4;y++){	
		if ((map[x][y].rand[0]!=0) &&	// sind alle Rnder des Feldes bekannt und...
		 (map[x][y].rand[1]!=0) &&
		 (map[x][y].rand[2]!=0) &&
		 (map[x][y].rand[3]!=0) &&
		 (map[x][y].rand[4]!=0) &&
		 (map[x][y].rand[5]!=0) &&
		 (map[x][y].maisda==false) &&	// ...liegt kein Mais drauf...
		 (map[x][y].besucht==false)){	// ...und war ck noch nicht da?
		  map[x][y].besucht=true;		// dann kann ck das Feld als erkundet betrachten	
		 }
		}
	}
return;
}


public weg2 umkehren(weg2 alt){		// Dreht die Reihenfolge der Schritte des als LinkedList bergebenen Weges um
		weg2 neu = new weg2();
		while (alt.head.direction != -1){
			neu = new weg2(alt.head.direction,alt.head.distance,alt.head.x,alt.head.y,neu);  
			alt.kuerzen();
		}
		return neu;	
	}


public void suche_Weg(int hierx, int hiery, int zx, int zy){ // sucht krzesten Weg zum Ziel
	for (int m=0;m<201;m++){ // Initialisiere Distanzkarte mit jeweils 99999
		for (int n=0;n<201;n++){
			distmap [m] [n] = 99999;
		}
	}
	bestweg = new weg2(-1,-1,-1,-1,null); // Reset Bestweg
	bestrating = 0;						  	
		
	milestone2 hier=new milestone2(-1,0,hierx,hiery,null); // Initialisiere startwegliste:
	weg2 hierweg=new weg2(hier);
	wegknoten hierknoten= new wegknoten(hierweg,null);
	wegliste list=new wegliste(hierknoten);
	
	if (narrow==false){
		sr++;if (sr==6)sr=0;
		
	}
	else{
	sr=2;
	
	}
	while (bestweg.head.direction == -1){  //solange noch kein bestweg gefunden wurde
		
		list = vertiefe(list,zx,zy); // Ersetze die aktuelle Wegliste durch eine Liste der nchsten Suchtiefe und suche weiter nach bestweg
	}
		
	bestdistance=bestweg.head.distance;		// Distanz zum Ziel in Schritten
	bestx=bestweg.head.x;					// X-Koordinate des Ziels
	besty=bestweg.head.y;					// Y-Koordinate des Ziels	
		
	bestweg=umkehren(bestweg);				// Liste umkehren, damit der erste zu gehende Schritt "obenauf" liegt
	return;
}
	
public wegliste vertiefe(wegliste alt,int zx, int zy){	// Erzeuge die eine Suchebenene tiefer gelegene Wegliste
	
	// Fr zx=zy=-1 wird nach dem nchsten zu erkunden Feld gesucht, ansonsten wird ein Weg zum genannten Ziel gesucht
	
	int rating;	// Bewertung des gefunden Weges (1: normal, 2: zustzlich wird ein Feld ausgeschlossen
	int temp; // Temporrer Speicher fr Wandinformation
	int nx; //x-Koordinate des zu untersuchenden Feldes
	int ny; //y-Koordinate des zu untersuchenden Feldes
	int i;		
	int x;
	int y;
	int direction;
	int distance;
	
	weg2 neuweg= new weg2();
	wegliste neuliste= new wegliste();
	
	do
		{
		x=alt.head.weg.head.x;
		y=alt.head.weg.head.y;
		direction=alt.head.weg.head.direction;
		distance=alt.head.weg.head.distance;
			
		if (distance < distmap [x] [y]){ //weiter nur dann, wenn hier noch keiner schneller war
			distmap [x] [y] = distance;
	
			
	 if ((map[x][y].besucht==false && zx==-1)||(x==zx && y ==zy) || (map[x][y].maisda==true && zx==-1 && (x!=100 || y!=100) && map[x][y].mais > -1)) { //zu besuchendes Feld entdeckt - bestweg gesetzt
		rating =1;						 // Bewertung des Ziels mit 1	
		
		for (int richtung=0;richtung <6; richtung++){ // kann durch Wahl genau dieses Ziels im folgenden ein anderes Weld durch workmap ausgeschlossen werden?
			nx=x+deltax[richtung];
			ny=y+deltay[richtung];
			
			temp = map[nx][ny].rand[gegenrichtung(richtung)];
			map[nx][ny].rand[gegenrichtung(richtung)]=1;
					
				if ((map[nx][ny].rand[0]!=0) &&
				(map[nx][ny].rand[1]!=0) &&
				(map[nx][ny].rand[2]!=0) &&
				(map[nx][ny].rand[3]!=0) &&
				(map[nx][ny].rand[4]!=0) &&
				(map[nx][ny].rand[5]!=0) &&
				(map[nx][ny].maisda==false) &&
				(map[nx][ny].besucht==false)){
					rating=2;			// Bewertung des Ziels mit 2, da zustzlich ein Feld ausgeschlossen werden kann
				}
		
			map[nx][ny].rand[gegenrichtung(richtung)]=temp;
		}
			
		if (rating>bestrating){			// Ist der soeben gefundene Weg der bislang beste?
			bestweg = alt.head.weg;
			bestrating=rating;
		}
			
		}
			else {						// noch nicht am Ziel? Dann 
	
				for (int m=0;m<6;m++){			//Vertiefe in alle Richtungen
					i=m+sr;if(i>5)i=i-6;			// Welche Richtung wird zuerst erzeugt? Bestimmt "Lieblingsrichtung"
					if (map[x][y].rand[i]==1){	// Rand passierbar?
	
						neuweg= new weg2(gegenrichtung(i),distance +1, x+deltax[i],y+deltay[i],alt.head.weg);	
						neuliste = new wegliste(neuweg,neuliste);
						
					}
				}
			}
		}
	
		if (alt.head.next !=null)alt.kuerzen(); // obersten Weg entfernen, falls das nicht schon der letzte verbleibende ist
	}
	while (alt.head.next != null); 	//solange bis das Ende der Liste erreicht ist
					
	return neuliste;				//Gib die erzeugte neue LinkedList zurck
}


public void gehe_Weg(weg2 way){		//lsst ck den bergebenen Weg abgehen
	int x;
	int y;
			
	while (way.head.getdirection()!=-1){ // noch nicht am Ziel angekommen?
		while (hr!=gegenrichtung(way.head.getdirection())) drehelinks(); //ck dreht sich nach links, bis er in die richtige Richtung schaut
		gehe();						// ck geht einen Schritt..
		erkunde();					// und erkundet.
		if(hx==100 && hy==100)dropAll(); // Zufllig auf Startfeld? Alles abladen!
		way.kuerzen();				// Weg um gegangenen Schritt krzen - "obenauf" liegt der nchste Schritt 
	}
return;
};
					

public boolean fertigcheck(){		// Wie weit ist ck?

	for (int x=1;x<201;x++){
		for (int y=1;y<201;y++){
			if (map[x][y].besucht ==false && zugaenglich(map[x][y])) {fertig=false;return false;}; // es sind noch Felder zu erkunden
	
			}
		}
	allebesucht=true;		
	for (int x=1;x<201;x++){		// Es ist zwar schon alles erkundet, aber liegt noch "rentabler" Mais herum?		
		for (int y=1;y<201;y++){
			if (map[x][y].maisda ==true && map[x][y].mais>0 && zugaenglich(map[x][y])&& (x!=100 || y!=100) && map[x][y].mais>0) {fertig=false; return false;};				
			}
		}
	fertig=true;					// j'ai fini
	return true;					 
}


public void dropAll() {							// Backen leeren
	int dropped = dropHere(CORNCARRY_MAX);
}


public void run() {					// Hauptroutine
int preis=0;						// "Preis", der fr das Erreichen des Mais auf einem Feld in Schritten zu bezahlen ist
	init_map();						// initialisiert die Karte
	init_waende();					// initialisiert das waende-array
	erkunde();						// ck schaut sich um 
	narrow=true;	
	while (fertigcheck()==false){	// Hast Du fertig?	
		waendeschnitt();			// ermittle w
		if (w<0.5 && narrow==true)narrow=false;		// Labyrinth eher weitlufig
		if (w>0.5 && narrow==false)narrow=true;		// Labyrinth eher eng
		for (int x=1;x<201;x++){	// Kalkuliere die Rentabilitt von bekannten Maisfeldern
			for (int y=1;y<201;y++){
				if (((x!=hx)||(y!=hy))&&(fertig==false)){
					if (map[x][y].mais!=0){ // Feld mit Mais entdeckt
						if (map[x][y].mais<0) map[x][y].mais=map[x][y].mais*-1; 
						map[x][y].maisda=true;
						preis=0;
						suche_Weg(x,y,100,100); // Entfernung von Zentrum
						preis=preis+bestdistance;
						
						map[x][y].maisda=false; // wenn hier kein mais mehr zu holen wre, wre ck dann fertig?...
						if (fertigcheck()==false){ //nein
							suche_Weg(x,y,-1,-1);  // Entfernung zum nchsten Ziel
							map[x][y].maisda=true; // zurck auf den realen Wert
							preis=preis+bestdistance;
							suche_Weg(100,100,-1,-1); // Entfernung zur Alternative, wenn ck wieder im Zentrum steht
							preis=preis-bestdistance; // preis wird um die Kosten der Alternative vermindert
						}
						else						  // das hier ist das letzte zu betretende Feld
							if (hx==100 & hy==100)preis=preis*2; // falls ck gerade zu Hause ist, dann ist das die Distanz
							else 
							{if (hx==x & hy==hy) preis=0;	//ck steht auf dem Maisfeld. 
								else
								{suche_Weg(hx,hy,x,y);
								 preis=preis+bestdistance;
								}
							}
									
						map[x][y].maisda=true;
						if (preis> 10 * map[x][y].mais){  // zu teuer - Feld wird voerst ignoriert
							map[x][y].maisda=false;
							map[x][y].mais=-1*map[x][y].mais;
							fertig=fertigcheck();
				
						}	
					}
				}
			}
		}
	
			
		
	if ((fertigcheck()==false)) {	// noch nicht fertig ?? dann such Dir ein Ziel und gehe hin
		
	suche_Weg(hx,hy,-1,-1);
	
	
	if (hx==100 && hy==100 && bestdistance>99){ // ist das nchste zu erkunden Feld weiter als 99 Schritte vom Heimatfeld weg und bist Du auf dem Heimatfeld?
		for (int x1=1;x1<200; x1++){			// ja: betrachte das gesamte Labyrinth als erkundet
			for (int y1=1;y1<200;y1++){
				map[x1][y1].besucht=true;
				map[x1][y1].mais=0;
				map[x1][y1].maisda=false;
			}
		}
	}
	else										// nein: erkunde weiter
	{
	gehe_Weg(bestweg);
	while (getAvailableCorn()>0 && (atHome()==false)){	// Ist Mais da?
		take(CORNCARRY_MAX); 
		map[hx][hy].maisda=false; 
		map[hx][hy].mais=0;	
		if (getCarriedCorn() == CORNCARRY_MAX ) { // Sind die Backen voll?
		
			if (getAvailableCorn()>0){			// Komm nochmal zurck, es ist noch Mais da
				erkunde();
				map[hx][hy].maisda=true;
				map[hx][hy].mais=getAvailableCorn();
			}
			suche_Weg(hx,hy,100,100);			// Weg zum Lager suchen
			gehe_Weg(bestweg);					// Weg gehen
			dropAll();							// alles abladen
			}
		}
		}
	}
	}
	 
	if (hx!=100 || hy !=100){					// fertig? dann ab nach Hause
		suche_Weg(hx,hy,100,100);
		gehe_Weg(bestweg);
	}
	dropAll();									// Backen ein letztes mal leeren
}	
	
	
}
