package corncadger.search;

import corncadger.Map;
import corncadger.Field;
import corncadger.Path;

import java.util.Enumeration;

/*
 * this will be the fastest search 
 * use it to get the shortest ditance between to fields for example
 *
 */

class Distance {
    static private Path _anyMatching(PathSet _paths, Field _f) {
        Enumeration e = _paths.paths();
        Path        one;
        while (e.hasMoreElements()) {
            one = (Path)e.nextElement();
            if (one.end() == _f) return one;
        }
        return null;
    }

    static int shortestDistance(Map _m, Field _a, Field _b) {
        int aCrawlID, bCrawlID;
        FieldPathCrawl a;
        FieldPathCrawl b;
        aCrawlID = PathSearch.nextCrawlID();
        bCrawlID = PathSearch.nextCrawlID();
        a        = new FastestPathCrawl(_m, _a, aCrawlID);
        b        = new InverseFastestPathCrawl(_m, _b, bCrawlID);
        a.setTargetCrawlID(bCrawlID);
        b.setTargetCrawlID(aCrawlID);
	
        PathSet 
            aPaths = a.currentPaths(),
            bPaths = b.currentPaths();

        while (true) {
            aPaths = a.extendPathsByOneStep(false); // non deep search
            if (aPaths.count() == 0) return -1;

            if (a.targetReached()) {
                // reached targetCrawlID
                aPaths = aPaths.pathsWithCrawlIDAtEnd(bCrawlID, _m);
                Path fastest = aPaths.firstPath();
                Path match   = _anyMatching(bPaths, fastest.end());
                return fastest.length()+match.length()-1;
            }

            bPaths = b.extendPathsByOneStep(false);

            if (b.targetReached()) {
                // reached targetCrawlID
                bPaths = bPaths.pathsWithCrawlIDAtEnd(aCrawlID, _m);
		
                Path fastest = bPaths.firstPath();
                Path match   = _anyMatching(aPaths, fastest.end());
                return fastest.length()+match.length()-1;
            }
        }
    }
}
