
package corncadger.search;

import corncadger.Path;
import corncadger.Field;
import corncadger.Map;

import java.util.Vector;
import java.util.Enumeration;

class ExploreHomePathSet extends PathSet {

    private static Vector _exploreCriterias = null;
    private Vector exploreCriterias() {
	if (_exploreCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    v.addElement(Criteria.moreCliffsCriteria);
	    _exploreCriterias = v;
	}
	return _exploreCriterias;
    }

    private static Vector _finalExploreCriterias = null;
    private Vector finalExploreCriterias() {
	if (_finalExploreCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(Criteria.moreCliffsCriteria);
	    v.addElement(Criteria.maybeNearerToHomeCriteria);
	    v.addElement(Criteria.higherLevelCriteria);
	    v.addElement(FlagCriteria.hasNoOrUnknownCornCriteria);
	    v.addElement(FlagCriteria.hasNoCornCriteria);
	    v.addElement(Criteria.moreUnwatchedNeighborsCriteria);
	    v.addElement(Criteria.moreUnwatchedWallsCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    _finalExploreCriterias = v;
	}
	return _finalExploreCriterias;
    }

    public boolean add(Path _path, Map _m) {
        // this means only one path per field
        Enumeration e   = this.paths();
        Path        one, best;
        while (e.hasMoreElements()) {
            one = (Path)e.nextElement();
            if (one.end() == _path.end()) {
                // same end
                // now check if _path is better than one
		best = _betterPathAfterCriterias(exploreCriterias(), 
						 one, _path, _m);
		if (best != null)
		  return (best == _path) 
		    ? this._replacePath(one, _path)
		    : false;

                return false; // same end .. 
            }
        }
        // end not found
        // --> new path
        return this.add(_path);
    }

    private Path _betterPathToExplore(Path _a, Path _b, Map _m) {
        Path best;
	best = _betterPathAfterCriterias(finalExploreCriterias(), 
					 _a, _b, _m);
	if (best != null) return best;
	/*
	  System.out.println("Explore:Paths still equal after all criterias "+
	  "(length: "+_a.length()+")");
	*/
        return _a;
    }
    public Path bestPath(Map _m) {
        Path best     = null;
        int  max      = this.paths.size();
        for (int i = 0; i < max; i++) {
            Path one = (Path)this.paths.elementAt(i);
            if (best == null) {
                best = one;
                continue;
            }
            best = this._betterPathToExplore(best, one, _m);
        }
        return best;
    }

    public PathSet newInstance() {
	return new ExploreHomePathSet();
    }

    public boolean isWalkable() { return true; }

}
