
package corncadger.search;

import corncadger.Path;
import corncadger.Field;
import corncadger.Map;

import java.util.Vector;
import java.util.Enumeration;

class ExplorePathSet extends PathSet {

    private static Vector _exploreCriterias = null;
    private Vector exploreCriterias() {
	if (_exploreCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    _exploreCriterias = v;
	}
	return _exploreCriterias;
    }

    /*
    private static Vector _finalExploreCriterias = null;
    private Vector finalExploreCriterias() {
	if (_finalExploreCriterias == null) {
	    Vector v = new Vector();
	    // the shorter path of corse
	    v.addElement(Criteria.shorterPathCriteria);
	    // maybe i can find a better way.. this way
	    v.addElement(Criteria.isUnexploredCriteria);
	    
	    // prefer unexplored number of corn
	    //v.addElement(Criteria.hasUnknownCornCriteria);

	    // if fields have corn prefer the one with unknown number
	    v.addElement(Criteria.hasUnknownNumberOfCornCriteria);
	    // more neigbors to watch
	    v.addElement(Criteria.moreUnwatchedNeighborsCriteria);
	    // better to find the way home 
	    v.addElement(Criteria.maybeNearerToHomeCriteria);
	    // better for the way home ..
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    // prefer unexplored for exploring
	    v.addElement(Criteria.lessCliffsCriteria);
	    // on a mountain u can see more than in a valley
	    v.addElement(Criteria.higherLevelCriteria);
	    // more to explore
	    v.addElement(Criteria.moreUnwatchedWallsCriteria);
	    // more to explore as long as i'm not full
	    v.addElement(Criteria.lowerNumberOfCornCriteria);
	    // that's it
	    _finalExploreCriterias = v;
	}
	return _finalExploreCriterias;
    }
    */

    public boolean add(Path _path, Map _m) {
        // this means only one path per field
        Enumeration e   = this.paths();
        Path        one, best;
        while (e.hasMoreElements()) {
            one = (Path)e.nextElement();
            if (one.end() == _path.end()) {
                // same end
                // now check if _path is better than one
		best = _betterPathAfterCriterias(exploreCriterias(), 
						 one, _path, _m);
		if (best != null)
		  return (best == _path) 
		    ? this._replacePath(one, _path)
		    : false;

                return false; // same end .. 
            }
        }
        // end not found
        // --> new path
        return this.add(_path);
    }

    private Path _betterPathToExplore(Path _a, Path _b, Map _m) {
        Path best;
	//best = _betterPathAfterCriterias(finalExploreCriterias(), 
	//				 _a, _b, _m);
	best = CriteriaTree.explorationTree().betterPath(_a,_b,_m);
	if (best != null) return best;
	/*
	  System.out.println("Explore:Paths still equal after all criterias "+
	  "(length: "+_a.length()+")");
	*/
        return _a;
    }
    public Path bestPath(Map _m) {
        Path best     = null;
        int  max      = this.paths.size();
        for (int i = 0; i < max; i++) {
            Path one = (Path)this.paths.elementAt(i);
            if (best == null) {
                best = one;
                continue;
            }
            best = this._betterPathToExplore(best, one, _m);
        }
        return best;
    }

    public PathSet newInstance() {
	return new ExplorePathSet();
    }

    public boolean isWalkable() { return true; }

}
