
package corncadger.search;

import corncadger.Path;
import corncadger.Map;
import corncadger.Field;

import java.util.Vector;
import java.util.Enumeration;

class HomePathSet extends PathSet {

    private static Vector _homeCriterias = null;
    protected Vector homeCriterias() {
	if (_homeCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(FlagCriteria.hasCliffCriteria);
	    v.addElement(FlagCriteria.canDropCornOnNextCliffDownCriteria);
	    v.addElement(Criteria.moreUnknownNeighborsCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    v.addElement(Criteria.moreUnknownNumberOfCornCriteria);
	    _homeCriterias = v;
	}
	return _homeCriterias;
    }

    private static Vector _finalHomeCriterias = null;
    protected Vector finalHomeCriterias() {
	if (_finalHomeCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(FlagCriteria.hasCliffCriteria);
	    v.addElement(FlagCriteria.canDropCornOnNextCliffDownCriteria);
	    v.addElement(Criteria.nearerCliffCriteria);
	    v.addElement(FlagCriteria.hasFirstCliffAtEndCriteria);
	    v.addElement(Criteria.moreUnknownNeighborsCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    v.addElement(Criteria.moreUnknownNumberOfCornCriteria);
	    _finalHomeCriterias = v;
	}
	return _finalHomeCriterias;
    }

    public  boolean add(Path _path, Map _m) {
        // this means only one path per field
        Enumeration e   = this.paths();
	Criteria    c   = null;
        Path        one, best;
	if (_path.end().isHome()) return this.add(_path);
        while (e.hasMoreElements()) {
            one = (Path)e.nextElement();
            if (one.end() == _path.end()) {
                // same end
                // criterias
		best = _betterPathAfterCriterias(homeCriterias(), 
						 one, _path, _m);
		if (best != null)
		  return (best == _path) 
		    ? this._replacePath(one, _path)
		    : false;

                return false; // same end .. 
                // i dont't want double paths to same field
            }
        }
        // end not found
        // --> new path
        return this.add(_path);
    }

    private Path betterPathHome(Path _a, Path _b, Map _m) {
        Path best;
	best = _betterPathAfterCriterias(finalHomeCriterias(), 
					 _a, _b, _m);
	if (best != null) return best;
	/*
	  System.out.println("Home:Paths still equal after all criterias "+
	  "(length: "+_a.length()+")");
	*/
        return _a;
    }

    public Path bestPath(Map _map) {
        Path    best     = null;
        int     max      = this.paths.size();
	Path    one;
        for (int i = 0; i < max; i++) {
            one = (Path)this.paths.elementAt(i);
            if (best == null) {
                best = one;
                continue;
            }
            best = this.betterPathHome(best, one, _map);
        }
        return best;
    }

    public PathSet newInstance() {
	return new HomePathSet();
    }

    public boolean isWalkable() { return true; }

}
