
package corncadger.search;

import corncadger.Map;
import corncadger.Field;

class MapCreationCrawl extends FieldPathCrawl {

    public MapCreationCrawl(Map _m, Field _f, 
			    int _crawlID, boolean _noCliffs) {
	super(_m, _f, _crawlID, _noCliffs);
    }

    boolean isPassable(Field _field, int _dir,
		       int _wall, Field _n) 
    {
	Map m = this.map();

	if (_field.radius() > 30)
	    // out of range
	    return false;

	if (_n == null) {
	    // create a new field
	    _n = m.createNeighborAt(_field, _dir);
	    if (_n == null) 
		// could not create field
		return false;
	}
	else if (_n.crawlID() == this.crawlID())
	    return false; // already visited

	return true;
    }

    PathSet createPathSet() {
	return PathSet.standardPathSet();
    }
}
