/**
 *
 *  cache to save the fastest paths between to fields
 *
 *
 */

package corncadger.search;

import corncadger.Path;
import corncadger.Field;

import java.util.Hashtable;

// path cache for a special start field
class SinglePathCache {
    Hashtable map = new Hashtable();

    void addPath(Path _path) {
        Field end = _path.end();
        Path  old = (Path)map.get(end);
        // allways hold the shortest path
        if ((old == null) || (_path.length() < old.length()))
            map.put(_path, end);
    }

    Path pathToField(Field _field) {
        return (Path)map.get(_field);
    }

}

// the path cache
public class PathCache {
    Hashtable caches = new Hashtable();

    public void addPath(Path _path) {
        Field           start = _path.start();
        SinglePathCache cache = (SinglePathCache)caches.get(start);
        if (cache == null) {
            cache = new SinglePathCache();
            caches.put(start, cache);
        }
        cache.addPath(_path);
    }

    public Path pathBetween(Field _start, Field _end) {
        SinglePathCache cache      = (SinglePathCache)caches.get(_start);
        Path            p          = null;
        if (cache != null)
            p = cache.pathToField(_end);
        return p;
    }
}
