
package corncadger.search;

import corncadger.Path;
import corncadger.Map;

import java.util.Vector;
import java.util.Enumeration;

public class WayPathSet extends PathSet {

    private static Vector _wayCriterias = null;
    private Vector wayCriterias() {
	if (_wayCriterias == null) {
	    Vector v = new Vector();
	    v.addElement(Criteria.shorterPathCriteria);
	    v.addElement(Criteria.moreUnknownNeighborsCriteria);
	    v.addElement(Criteria.moreUnknownWallsCriteria);
	    v.addElement(Criteria.nearestToUnknownWallsCriteria);
	    _wayCriterias = v;
	}
	return _wayCriterias;
    }

    public boolean add(Path _path, Map _m) {
        // this means only one path per field
        Enumeration e   = this.paths();
	Criteria    c   = null;
        Path        one, best;
        while (e.hasMoreElements()) {
            one = (Path)e.nextElement();
            if (one.end() == _path.end()) {
                // same end
                // now check if _path is better than one
		best = _betterPathAfterCriterias(wayCriterias(), 
						 one, _path, _m);
		if (best != null)
		  return (best == _path) 
		    ? this._replacePath(one, _path)
		    : false;

                return false; // same end .. 
                // i dont't want more than one path to the same field
            }
        }
        // end not found
        // --> new path
        return this.add(_path);
    }

    public Path bestPath(Map _m) {
        Path best     = null;
        int  max      = this.paths.size();
        for (int i = 0; i < max; i++) {
            Path one = (Path)this.paths.elementAt(i);
            if (best == null) {
                best = one;
                continue;
            }
            if (one.length() < best.length()) {
                best = one;
                continue;
            }
        }
        return best;
    }

    public PathSet newInstance() {
	return new WayPathSet();
    }

    public boolean isWalkable() { return true; }

}
