package dierennsemmel;

public class Field{

// Instance variables:

	public Object element;
	public int koerner=0;
	public boolean visited=false;

	public int preX;	// die 2 beinhalten die Koordinaten des Vorgngerfeldes (also des Feldes, von dem der Hamster kommt)
	public int preY;

	public int X;	// beinhalten die Koordinaten des Feldes (NICHT des Vorgngerfeldes)
	public int Y;


// beliebige Objekte als Elemente

/*
 Ich denke es ist einfacher, absolute Koordinaten fr jedes Feld zu benutzen, also nicht das Koordinatensystem der Drehung des Hamsters anzupassen.

Up = oben
RUp = rechts oben
LUp = links oben
RDn = links unten
LDn = rechts unten
Dn = unten

*/

	public Field nextUp;
	public Field nextRUp;
	public Field nextLUp;
	public Field nextRDn;
	public Field nextLDn;
	public Field nextDn;


	// Folgeknoten

	// Konstruktoren

	public int exits() {			// berechnet die Anzahl der freien Zugnge zum Feld
		int i = 0;
		if (nextUp != null) i++;
		if (nextRUp != null) i++;
		if (nextLUp != null) i++;
		if (nextDn != null) i++;
		if (nextLDn != null) i++;
		if (nextRDn != null) i++;
		return i;
	}

	public Field() {
		this(0,0,0,0,null,null,null,null,null,null);
	}

/*	public Field(Field f) {
		preX= f.getPreX();
		preY= f.getPreY();
		nextUp = f.getNextUp();
		nextRUp = f.getNextRUp();
		nextLUp = f.getNextLUp();
		nextRDn = f.getNextRDn();
		nextLDn = f.getNextLDn();
		nextDn = f.getNextDn();
	}
*/
/*	public Field(int posX, int posY) {				// erstellt neues Feld mit Vorgngerkoordinaten
		this(posY,posX,0,0,null,null,null,null,null,null);
	} */

	public Field(int posX, int posY, int pX, int pY) {		// erstellt neues Feld mit Vorgngerkoordinaten
		this(posY,posX,pX,pY,null,null,null,null,null,null);
	}

// ist ein angrenzendes Feld = "null" (bzw wird Field irgendwo mit "null" aufgerufen), dann ist es entweder nicht vorhanden (Grenze des Labyrinths) oder eine Wand blockiert, auer es ist komplett leer
// int posX/Y speichern die Koordinaten des Vorgngerfeldes

	public Field(int posX, int posY, int pX, int pY, Field U, Field RU, Field LU, Field RD, Field LD, Field D){
		preX = posX;
		preY = posY;
		X = pX;
		Y = pY;
		nextUp = U;
		nextRUp = RU;
		nextLUp = LU;
		nextRDn = RD;
		nextLDn = LD;
		nextDn = D;
	}

// Rckgabe der Vorgngerkoordinaten

	public int getPreX() {
		return preX;
	}

	public int getPreY() {
		return preY;
	}

// Rckgabe der Feldkoordinaten

	public int getX() {
		return X;
	}

	public int getY() {
		return Y;
	}

// Angrenzende Felder auslesen

	Field getNextUp() {
		return nextUp;
	}

	Field getNextRUp() {
		return nextRUp;
	}

	Field getNextLUp() {
		return nextLUp;
	}

	Field getNextRDn() {
		return nextRDn;
	}

	Field getNextLDn() {
		return nextLDn;
	}

	Field getNextDn() {
		return nextDn;
	}


// Modifikatoren

// hier drin speichert er die Koordinaten des Feldes, von dem er kommt (also das Vorgngerfeld)

	void setElement(int posX,int posY) {
		preX = posX;
		preY = posY;
	}

	void setKoords(int posX, int posY) {
		X=posX;
		Y=posY;
	}

// Angrenzende Felder neu setzen

//	zur bersicht:  Field(int posX, int posY, Field U, Field RU, Field LU, Field RD, Field LD, Field D)

	void setNextUp(Field temp) {
		nextUp = temp;
	}

	void setNextLUp(Field temp) {
		nextLUp = temp;
	}

	void setNextRUp(Field temp) {
		nextRUp = temp;
	}

	void setNextLDn(Field temp) {
		nextLDn = temp;
	}

	void setNextRDn(Field temp) {
		nextRDn = temp;
	}

	void setNextDn(Field temp) {
		nextDn = temp;
	}


// Angrenzende Felder AUF NULL neu setzen

	void setNextUpNull() {
		nextUp = null;
	}

	void setNextLUpNull() {
		nextLUp = null;
	}

	void setNextRUpNull() {
		nextRUp = null;
	}

	void setNextLDnNull() {
		nextLDn = null;
	}

	void setNextRDnNull() {
		nextRDn = null;
	}

	void setNextDnNull() {
		nextDn = null;
	}

// Methoden zum Ein/Auslesen der Eigenschaften des Klassenobjekts (als des Feldes)

// Wieviel Korn liegt auf dem Feld?

	void setKornAvailable(int k) {
		koerner=k;
	}

	int getKornAvailable() {
		return koerner;
	}

// War ich hier schon?

	public void setVisited() {
		visited=true;
	}

	public boolean getVisited() {
		return visited;
	}

// Ist ein angrenzendes Feld blockiert durch eine Wand? --> mte dadurch gelst sein, da dieses Feld in meiner Liste dann leer ist.

// compareTo Methode. Wird bei Unterschieden immer >0. (Zeigt also die Anzahl der Unterschiede)
// bei Feld = null wird -1 zurckgegeben.

	public int compareTo(Field c) {
		int diff=0;
		if (c!=null) {

			if (((nextUp==null) && (c.nextUp!=null)) || ((nextUp!=null) && (c.nextUp==null))) diff++;
			if (((nextLUp==null) && (c.nextLUp!=null)) || ((nextLUp!=null) && (c.nextLUp==null))) diff++;
			if (((nextRUp==null) && (c.nextRUp!=null)) || ((nextRUp!=null) && (c.nextRUp==null))) diff++;
			if (((nextLDn==null) && (c.nextLDn!=null)) || ((nextLDn!=null) && (c.nextLDn==null))) diff++;
			if (((nextRDn==null) && (c.nextRDn!=null)) || ((nextRDn!=null) && (c.nextRDn==null))) diff++;
			if (((nextDn==null) && (c.nextDn!=null)) || ((nextDn!=null) && (c.nextDn==null))) diff++;

		} else return -1;

		return diff;

	}

}


