package dierennsemmel;

import java.io.*;
import algds.c2002.Hamster;

public class dieRennsemmel extends Hamster {

public Field feld;

Node2 root;		// speichert Beginn des Laufens, jedoch keine Felder doppelt
Node2 alleElemente;	// doppelt verkettete Liste, speichert die Reihenfolge der besuchten Felder
Node2 unvis;		// speichert die bis dahin unbesuchten Felder

boolean do_log = false;
boolean madestep=false;				// speichert, ob er einen Schritt gemacht hat
boolean finished = false;

static int posX;  // Position im Koordinatensystem -> x-Achse
static int posY;  // Position im Koordinatensystem -> y-Achse
static int steps;
static int stepsMax = 100;		// Wenn ich hier eine zu groe Zahl einstelle, kann es bei manchen Feldern sein, da er "eiert" (also auf 3 oder 4 Feldern theor. endlos luft), aber dann greift natrlich diese Grenze und er rennt zurck.

	boolean a = false;				// die brauch ich z.b. in der Methode alreadyVisited, sie legen fest, in welche richtung der hamster schauen kann
	boolean b = false;
	boolean c = false;
	boolean d = false;
	boolean e = false;
	boolean f = false;

/*
eins nach oben = y+2
eins nach links oben = x-1,y+1
eins nach links unten = x-1,y-1
eins nach unten = y-2
eins nach rechts unten = x+1,y-1
eins nach rechts oben = x+1,y+1
*/

public boolean fLog(String s) {
	return fLog(s,true);
}

public boolean fLog(String s, boolean Zeilenumbruch) {
	if (do_log) {
		BufferedWriter f1;
		try {
			f1 = new BufferedWriter(new FileWriter("./log.txt",true));
			f1.write(s);
			log(s);
			if (Zeilenumbruch) {
				f1.newLine(); 
				log("\n");
			}
			f1.close();
		}
		catch (IOException e) {
			return false;
		} 
	}
	return true;
} 

// Ich habe eine Liste mit bereits besuchten Feldern

public void saveFieldIntoList(Field f) {
	Node2 n = root;
	if (f==null) return;
	boolean dontSave = false;
	while (n.getNext()!=null) {
//		fLog(n.getElement().getX()+","+n.getElement().getY()+" =Listenelement "+f.getX()+","+f.getY()+" =bergebenes Feld");
		if ((n.getElement().getX()==f.getX()) && (n.getElement().getY()==f.getY()))   // Dann ist das Feld schonmal besucht worden
			dontSave=true;
		n=n.getNext();
	}
//	fLog(n.getElement().getX()+","+n.getElement().getY()+" =Listenelement "+f.getX()+","+f.getY()+" =bergebenes Feld");
	if ((n.getElement().getX()==f.getX()) && (n.getElement().getY()==f.getY()))   // Dann ist das Feld schonmal besucht worden
		dontSave=true;
	if (!dontSave) {
		n=root;
		while (n.getNext()!=null) {
			n=n.getNext();		// nur mal eben die Liste auf das letzte Element setzen
		}
		n.setNext(new Node2(f,null,n));
		n=n.getNext();
//		fLog("Feld ("+f.toString()+" "+f.getX()+","+f.getY()+") wurde gespeichert");
	}// else fLog("Feld ("+f.toString()+" "+f.getX()+","+f.getY()+") wurde nicht gespeichert");
}

public boolean areBound(Field a1, Field a2) {		// berprft, ob 2 Felder verbunden sind - Felder sind immer nur an gegenberliegenden Stellen verbunden (zb. a1.Up mit a2.Dn)
	boolean b=false;
	if ((a1!=null) && (a2!=null)) {		// Felder drfen nicht leer sein
		if ((a1.getNextUp()==a2.getNextDn()) && (a1.getNextUp()!=null) && (a2.getNextDn()!=null)) b=true;
		if ((a1.getNextLUp()==a2.getNextRDn()) && (a1.getNextLUp()!=null) && (a2.getNextRDn()!=null)) b=true;
		if ((a1.getNextRUp()==a2.getNextLDn()) && (a1.getNextRUp()!=null) && (a2.getNextLDn()!=null)) b=true;
		if ((a1.getNextLDn()==a2.getNextRUp()) && (a1.getNextLDn()!=null) && (a2.getNextRUp()!=null)) b=true;
		if ((a1.getNextRDn()==a2.getNextLUp()) && (a1.getNextRDn()!=null) && (a2.getNextLUp()!=null)) b=true;
		if ((a1.getNextDn()==a2.getNextUp()) && (a1.getNextDn()!=null) && (a2.getNextUp()!=null)) b=true;
	}
	return b;
}

public Field checkField(Field f) {		// berprft anhand der Koordinaten, ob ein Feld schon drin ist
	Node2 n = root;
	if (f==null) {
		return null;		// das Feld ist noch nicht betrachtet, oder bereits wieder aus der Liste gelscht
	}
	while (n.getNext()!=null) {
		if ((n.getElement().getX()==f.getX()) && (n.getElement().getY()==f.getY())) {  // Dann ist das Feld schonmal besucht worden
			return n.getElement();	// ja Feld wurde in der Liste gefunden, wurde also auch schon mal besucht
		}
		n=n.getNext();
	}
	if ((n.getElement().getX()==f.getX()) && (n.getElement().getY()==f.getY())) {  // Noch das letzte Feld der Liste untersuchen
		return n.getElement();	// ja Feld wurde in der Liste gefunden, wurde also auch schon mal besucht
	}
	return null;			// nein, Feld wurde noch nicht besucht, da es nicht in der Liste drin ist
}

// Erklrungen siehe weiter unten im Code

public void saveUnvisited(Field f) {			// diese Liste enthlt alle Felder, die bis dahin zwar ENTDECKT, jedoch nicht VISITED sind. (damit kann er sich also merken, wo er noch hinmu, wenn er das ganze Spielfeld untersuchen will)
	Node2 n = unvis;
	if (f==null) return;				// Abbruch bei leerem Feld
	if (n==null) {				// Ist die Liste noch leer, so mu UNVIS noch gesetzt werden
		if (!f.getVisited()) {
			unvis=new Node2(checkField(f),null,null);
			n=unvis;
		}
	}else {
		if (!f.getVisited()) {		// wenn das Feld noch unbesucht ist, so wird es in die Liste gepackt.
			boolean b=false;
			while (n.getNext()!=null) {	// vorher mu aber natrlich geschaut werden, ob das Feld vielleicht schonmal drin ist
				if (checkField(n.getElement())==checkField(f)) b=true;
				n=n.getNext();
			}
			if (checkField(n.getElement())==checkField(f)) b=true;	// das letzte element mu nat. auch noch gecheckt werden.

			if (!b) {				// wenn das Feld noch nicht drin ist, dann mach es rein
				n.setNext(new Node2(checkField(f),null,n));
			}

		}
	}

	// nun noch die Liste durchsuchen, ob inzwischen ein Feld den Status visited == true erhalten hat

	n=unvis;
	if (n!=null) {
		while (n.getNext()!=null) {
			if (checkField(n.getElement()).getVisited()) {
//				fLog("wurde schon besucht");
				if (n.getParent()==null) {				// (es knnt ja sein, da es das erste element der liste betrifft)
					n=n.getNext();
						n.setParent(null);			// dann setzt er beim ersten Feld einfach den Vorgnger aufs Nirvana
					unvis=n;				// dabei mu natrlich auch der "Root"-Knoten entsprechend umgesetzt werden
				} else if (n.getNext()==null) {			// (es knnt ja sein, da es das letzte element der liste betrifft)
					n.getParent().setNext(new Node2(null,null,null));
					n=n.getParent();
				} else
					n.getParent().setNext(n.getNext());		// das ist der Lschvorgang
			}
			n=n.getNext();
		}

		// und dann mu er das ganze nochmal frs letzte n machen

		if (checkField(n.getElement()).getVisited()) {
			if (n.getParent()==null) {				// (es knnt ja sein, da es das erste element der liste betrifft)
				n=n.getNext();
					n.setParent(null);			// dann setzt er beim ersten Feld einfach den Vorgnger aufs Nirvana
				unvis=n;				// dabei mu natrlich auch der "Root"-Knoten entsprechend umgesetzt werden
			} else if (n.getNext()==null) {			// (es knnt ja sein, da es das letzte element der liste betrifft)
				n=n.getParent();
				n.setNext(null);
				if (n.getParent()==null) {
					n=null;				// wenn es kein vor und zurck mehr gibt, dann kann diese Liste auf Null gesetzt werden
					unvis=null;
				} else n=n.getParent();
			} else {
				n.getParent().setNext(n.getNext());		// das ist der Lschvorgang
			}
		}
	}
}

// Die "Schau-Dich-Um-Hamster!" Methode

public void lookAround() {
	madestep=false;
	Field tempfield = new Field();
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextUp());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {					// nein, das Feld war wohl noch nicht drin.
			feld.setNextUp(new Field(posX,posY,posX,posY+2));
			checkField(feld.getNextUp());			// nochmal nachschauen, ob ein feld mit diesen koordinaten existiert, falls ja wird das neu erstellte feld durch das bereits bekannte ersetzt
			feld.getNextUp().setNextDn(feld);
			saveFieldIntoList(feld.getNextUp());		// und dann soll es noch in die Liste der bekannten Felder/Koordinaten gespeichert werden
		} else {
			feld.setNextUp(tempfield);
			tempfield.setNextDn(feld);
		}
//		saveUnvisited(feld.getNextUp());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextLUp());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {
			feld.setNextLUp(new Field(posX,posY,posX-1,posY+1));
			checkField(feld.getNextLUp());
			feld.getNextLUp().setNextRDn(feld);
			saveFieldIntoList(feld.getNextLUp());
		} else {
			feld.setNextLUp(tempfield);
			tempfield.setNextRDn(feld);
		}
//		saveUnvisited(feld.getNextLUp());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextLDn());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {
			feld.setNextLDn(new Field(posX,posY,posX-1,posY-1));
			checkField(feld.getNextLDn());
			feld.getNextLDn().setNextRUp(feld);
			saveFieldIntoList(feld.getNextLDn());
		} else {
			feld.setNextLDn(tempfield);
			tempfield.setNextRUp(feld);
		}
//		saveUnvisited(feld.getNextLDn());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextDn());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {
			feld.setNextDn(new Field(posX,posY,posX,posY-2));
			checkField(feld.getNextDn());
			feld.getNextDn().setNextUp(feld);
			saveFieldIntoList(feld.getNextDn());
		} else {
			feld.setNextDn(tempfield);
			tempfield.setNextUp(feld);
		}
//		saveUnvisited(feld.getNextDn());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextRDn());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {
			feld.setNextRDn(new Field(posX,posY,posX+1,posY-1));
			checkField(feld.getNextRDn());
			feld.getNextRDn().setNextLUp(feld);
			saveFieldIntoList(feld.getNextRDn());
		} else {
			feld.setNextRDn(tempfield);
			tempfield.setNextLUp(feld);
		}
//		saveUnvisited(feld.getNextRDn());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
	if (((lookForward() & WALLMASK) != WALL)) {
		tempfield = checkField(feld.getNextRUp());			// ist das nchste Feld schon in der Liste der besuchten Felder? (Verglichen wird anhand der Koordinaten)
		if (tempfield==null) {
			feld.setNextRUp(new Field(posX,posY,posX+1,posY+1));
			checkField(feld.getNextRUp());
			feld.getNextRUp().setNextLDn(feld);
			saveFieldIntoList(feld.getNextRUp());
		} else {
			feld.setNextRUp(tempfield);
			tempfield.setNextLDn(feld);
		}
//		saveUnvisited(feld.getNextRUp());				// dies schaut nach, ob das Feld das visited flag gesetzt hat, und merkt sich (falls es dies nicht hat), dieses Feld in einer separaten Liste
	}
	turn(TURN_LEFT);
}

// Methode, die berprft, ob man im Kreis geht, und ob alle vorher im Kreis durchlaufenen Felder nur 2 Ausgnge haben. ("Donut-Ring")

public void circleSolver() {
	Node2 temp2 = alleElemente;
	boolean zwei = false;
	while (temp2.getParent()!=null) {
		temp2 = temp2.getParent();
		if (temp2.getElement()==feld) {			// Ein Feld wurde schon mindestens 1 mal besucht
			if (feld.exits()>=3) {
				boolean alleSindZwei = true;
				Node2 aSZ = alleElemente;
				while (aSZ != temp2) {
					if (aSZ.getElement()!=null)
						if (aSZ.getElement().exits()!=2)
							alleSindZwei = false;
					aSZ=aSZ.getParent();
				}
//				fLog("alle vorherigen Felder sind 2? "+alleSindZwei);
				zwei = alleSindZwei;
			
				if (alleSindZwei) {

					Field vorletztesFeld = alleElemente.getParent().getElement();		//damit habe ich die 2 Felder, die den Eingang in den Ring bilden
					Field erstes = temp2.getNext().getElement();

					// als nchstes werden diese 2 Felder gelscht (bzw. der Zugang vom aktuellen Feld zu den 2 anderen Feldern wird versperrt)

					if (feld.getNextUp()==vorletztesFeld) feld.setNextUpNull();
					if (feld.getNextLUp()==vorletztesFeld) feld.setNextLUpNull();
					if (feld.getNextRUp()==vorletztesFeld) feld.setNextRUpNull();
					if (feld.getNextLDn()==vorletztesFeld) feld.setNextLDnNull();
					if (feld.getNextRDn()==vorletztesFeld) feld.setNextRDnNull();
					if (feld.getNextDn()==vorletztesFeld) feld.setNextDnNull();

					if (feld.getNextUp()==erstes) feld.setNextUpNull();
					if (feld.getNextLUp()==erstes) feld.setNextLUpNull();
					if (feld.getNextRUp()==erstes) feld.setNextRUpNull();
					if (feld.getNextLDn()==erstes) feld.setNextLDnNull();
					if (feld.getNextRDn()==erstes) feld.setNextRDnNull();
					if (feld.getNextDn()==erstes) feld.setNextDnNull();
				}
			}

			break;					// beende den Suchdurchlauf
		}
	}
}

// Diese Methode erstellt eine simple Liste mit Feldern, die fr den Rckweg genutzt werden.

public void pathFinder(int x, int y) {						// die Methode wird mit den Koordinaten des Zielfeldes aufgerufen (x,y)
	Node2 backPath = new Node2();				// Startpunkt fr den Rckweg ist das momentane (es ist das letzte) Element der alleElemente-Liste
	Node2 temp;
	Node2 temp2;
	Node2 wayToHere = alleElemente;					// Liste aller bisher besuchten Felder mit Reihenfolge
	Field f;

	boolean zeroFieldFound = false;					// speichert, ob er (x,y) in der Liste gefunden hat (war ursprnglich nur als "geh zurck zu 0,0" gedacht)

	while (wayToHere.getNext()!=null)
		wayToHere = wayToHere.getNext();			// Node auf das Ende dieser Liste setzen
	int i=0;
	while ((!zeroFieldFound) && (wayToHere.getParent()!=null)) {
		i++;
		temp = wayToHere;
		temp2=wayToHere;
		f = wayToHere.getElement();
		
		while (temp.getParent()!=null) {
			if ((checkField(temp.getElement())==checkField(f)) && (checkField(f)!=null)) {		// Das Feld wurde in der Liste gefunden
				temp2 = temp;					// speichert die momentane Position von wayToHere
//				fLog("Feld "+temp2.getElement().getX()+","+temp2.getElement().getY()+" in der Liste gefunden "+i);
			}
			temp = temp.getParent();				// Node auf das Ende dieser Liste setzen
		}

		backPath.setElement(temp2.getElement());
		backPath.setNext(new Node2(null,null,backPath));	
		backPath=backPath.getNext();

		wayToHere = temp2.getParent();
	}

	if (wayToHere!=null) {
		f = wayToHere.getElement();
		temp = wayToHere;

		if (checkField(temp.getElement())==checkField(f)) {		// Das Feld wurde in der Liste gefunden
			backPath.setElement(temp.getElement());
			backPath.setNext(new Node2(null,null,backPath));	
			backPath=backPath.getNext();
			fLog("Feld "+temp.getElement().getX()+","+temp.getElement().getY()+" in der Liste gefunden");
		}
	}

	while (backPath.getParent()!=null) {
		if (backPath.getElement()!=null)
			fLog(backPath.getElement().getX()+","+backPath.getElement().getY());
		backPath = backPath.getParent();			// Node auf das Ende dieser Liste setzen
	}

/*
	Jetzt ist nun also die Liste der Felder erstellt, auf denen er zurckgehen soll.
	Nun kommt als nchstes die "Rcklaufroutine"
*/
	boolean b=false;
	while (backPath.getNext()!=null) {						// und jetzt von vorne die Liste abarbeiten

		lookAround();

		if (checkField(backPath.getElement())==checkField(feld.getNextUp()))
			b=goUp2();
		else if (checkField(backPath.getElement())==checkField(feld.getNextLUp()))
			b=goLUp2();
		else if (checkField(backPath.getElement())==checkField(feld.getNextRUp()))
			b=goRUp2();
		else if (checkField(backPath.getElement())==checkField(feld.getNextLDn()))
			b=goLDn2();
		else if (checkField(backPath.getElement())==checkField(feld.getNextRDn()))
			b=goRDn2();
		else if (checkField(backPath.getElement())==checkField(feld.getNextDn()))
			b=goDn2();
		fLog("b="+b);
		backPath=backPath.getNext();
	}

	if ((atHome()) && (getCarriedCorn()>0))
		dropHere(getCarriedCorn());

}

// Methoden zum Wechseln des Feldes

public boolean goUp() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		forward();
		feld.getNextUp().setElement(posX,posY);		// in feld.setElement speichert er, woher er gerade kommt.
		feld.getNextUp().setKoords(posX,posY+2);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextUp());
		if (tempfield!=null) feld.setNextUp(tempfield);
		tempfield.setNextDn(feld);
		boolean b=alreadyVisited();
		posX=posX;
		posY=posY+2;
		feld=feld.getNextUp();
		if (b) feld.setNextDnNull();
		return true;
}

public boolean goLUp() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		feld.getNextLUp().setElement(posX,posY);
		feld.getNextLUp().setKoords(posX-1,posY+1);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextLUp());
		if (tempfield!=null) feld.setNextLUp(tempfield);
		tempfield.setNextRDn(feld);
		boolean b=alreadyVisited();
		posX=posX-1;
		posY=posY+1;
		feld=feld.getNextLUp();
		if (b) feld.setNextRDnNull();
		return true;
}

public boolean goRUp() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		turn(TURN_RIGHT);
		forward();
		turn(TURN_LEFT);
		feld.getNextRUp().setElement(posX,posY);
		feld.getNextRUp().setKoords(posX+1,posY+1);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextRUp());
		if (tempfield!=null) feld.setNextRUp(tempfield);
		tempfield.setNextLDn(feld);
		boolean b=alreadyVisited();
		posX=posX+1;
		posY=posY+1;
		feld=feld.getNextRUp();
		if (b) feld.setNextLDnNull();
		return true;
}

public boolean goRDn() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		forward();
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		feld.getNextRDn().setElement(posX,posY);
		feld.getNextRDn().setKoords(posX+1,posY-1);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextRDn());
		if (tempfield!=null) feld.setNextRDn(tempfield);
		tempfield.setNextLUp(feld);
		boolean b=alreadyVisited();
		posX=posX+1;
		posY=posY-1;
		feld=feld.getNextRDn();
		if (b) feld.setNextLUpNull();
		return true;
}

public boolean goLDn() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		feld.getNextLDn().setElement(posX,posY);
		feld.getNextLDn().setKoords(posX-1,posY-1);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextLDn());
		if (tempfield!=null) feld.setNextLDn(tempfield);
		tempfield.setNextRUp(feld);
		boolean b=alreadyVisited();
		posX=posX-1;
		posY=posY-1;
		feld=feld.getNextLDn();
		if (b) feld.setNextRUpNull();
		return true;
}

public boolean goDn() {
		if ((getCarriedCorn()<CORNCARRY_MAX) && (getAvailableCorn()>0)) {
			take(20);
		}
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		feld.getNextDn().setElement(posX,posY);
		feld.getNextDn().setKoords(posX,posY-2);		// in feld.setKoords speichert er die Koordinaten des Feldes
		Field tempfield = checkField(feld.getNextDn());
		if (tempfield!=null) feld.setNextDn(tempfield);
		tempfield.setNextUp(feld);
		boolean b=alreadyVisited();
		posX=posX+0;
		posY=posY-2;
		feld=feld.getNextDn();
		if (b) feld.setNextUpNull();
		return true;
}

// "Geh!"-Methoden fr den Rckweg

public boolean goUp2() {
		forward();
		Field tempfield = checkField(feld.getNextUp());
		if (tempfield!=null) feld.setNextUp(tempfield);
		posX=posX;
		posY=posY+2;
		feld=feld.getNextUp();
		return true;
}

public boolean goLUp2() {
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		Field tempfield = checkField(feld.getNextLUp());
		if (tempfield!=null) feld.setNextLUp(tempfield);
		posX=posX-1;
		posY=posY+1;
		feld=feld.getNextLUp();
		return true;
}

public boolean goRUp2() {
		turn(TURN_RIGHT);
		forward();
		turn(TURN_LEFT);
		Field tempfield = checkField(feld.getNextRUp());
		if (tempfield!=null) feld.setNextRUp(tempfield);
		posX=posX+1;
		posY=posY+1;
		feld=feld.getNextRUp();
		return true;
}

public boolean goRDn2() {
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		forward();
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		Field tempfield = checkField(feld.getNextRDn());
		if (tempfield!=null) feld.setNextRDn(tempfield);
		posX=posX+1;
		posY=posY-1;
		feld=feld.getNextRDn();
		return true;
}

public boolean goLDn2() {
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		Field tempfield = checkField(feld.getNextLDn());
		if (tempfield!=null) feld.setNextLDn(tempfield);
		posX=posX-1;
		posY=posY-1;
		feld=feld.getNextLDn();
		return true;
}

public boolean goDn2() {
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		turn(TURN_LEFT);
		forward();
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		turn(TURN_RIGHT);
		Field tempfield = checkField(feld.getNextDn());
		if (tempfield!=null) feld.setNextDn(tempfield);
		posX=posX+0;
		posY=posY-2;
		feld=feld.getNextDn();
		return true;
}

// War er schon auf dem Feld?

boolean alreadyVisited() {
	a = false;
	b = false;
	c = false;
	d = false;
	e = false;
	f = false;
	if (feld.getNextUp()!=null)
		if (feld.getNextUp().getVisited())
			a = true;
	if (feld.getNextLUp()!=null)
		if (feld.getNextLUp().getVisited())
			b = true;
	if (feld.getNextRUp()!=null)
		if (feld.getNextRUp().getVisited())
			c = true;
	if (feld.getNextRDn()!=null)
		if (feld.getNextRDn().getVisited())
			d = true;
	if (feld.getNextLDn()!=null)
		if (feld.getNextLDn().getVisited())
			e = true;
	if (feld.getNextDn()!=null)
		if (feld.getNextDn().getVisited())
			f = true;

/*	if (feld.getVisited()) {
		if (((a) & (b) & (c) & (d) & (e) & (f))==true) {
			return true;
		}
	} else feld.setVisited();
*/

	if (feld.getVisited()) return true;
	else feld.setVisited();

	return false;

}

// Die Methode zum Initieren des Feldwechsels

public void switchField() {

/*	fLog(posX+" "+posY+" "+feld.toString()+" =eigenes Feld");
	if (feld.getNextUp()!=null) fLog(feld.getNextUp().getX()+","+feld.getNextUp().getY()+" "+feld.getNextUp().toString()+" "+feld.getNextUp().getVisited()+" =Up");
	if (feld.getNextLUp()!=null) fLog(feld.getNextLUp().getX()+","+feld.getNextLUp().getY()+" "+feld.getNextLUp().toString()+" "+feld.getNextLUp().getVisited()+" =LUp");
	if (feld.getNextRUp()!=null) fLog(feld.getNextRUp().getX()+","+feld.getNextRUp().getY()+" "+feld.getNextRUp().toString()+" "+feld.getNextRUp().getVisited()+" =RUp");
	if (feld.getNextLDn()!=null) fLog(feld.getNextLDn().getX()+","+feld.getNextLDn().getY()+" "+feld.getNextLDn().toString()+" "+feld.getNextLDn().getVisited()+" =LDn");
	if (feld.getNextRDn()!=null) fLog(feld.getNextRDn().getX()+","+feld.getNextRDn().getY()+" "+feld.getNextRDn().toString()+" "+feld.getNextRDn().getVisited()+" =RDn");
	if (feld.getNextDn()!=null) fLog(feld.getNextDn().getX()+","+feld.getNextDn().getY()+" "+feld.getNextDn().toString()+" "+feld.getNextDn().getVisited()+" =Dn");

	String s="aktuell: "+posX;
	fLog("("+s+",",false);
	s=""+posY;
	fLog(s+")");
*/

	if ((atHome()) && (getCarriedCorn()>0))
		dropHere(getCarriedCorn());

// fr den Normalfall. ("Normalfall" bedeutet, da Bedingungen wie Ziefeld!=besucht und Zielfeld!= null zutreffen.)

	if ((feld.getNextUp()!=null) && (!feld.getNextUp().getVisited()) && ((feld.getPreX()!=posX) || (feld.getPreY()!=posY+2))) {

		madestep=goUp();

	}else if ((feld.getNextLUp()!=null) && (!feld.getNextLUp().getVisited()) && ((feld.getPreX()!=posX-1) ||  (feld.getPreY()!=posY+1))) {

		madestep=goLUp();

	}else if ((feld.getNextLDn()!=null) && (!feld.getNextLDn().getVisited()) && ((feld.getPreX()!=posX-1) || (feld.getPreY()!=posY-1))) {

		madestep=goLDn();

	}else if ((feld.getNextRDn()!=null) && (!feld.getNextRDn().getVisited()) && ((feld.getPreX()!=posX+1) || (feld.getPreY()!=posY-1))) {

		madestep=goRDn();

	}else if ((feld.getNextRUp()!=null) && (!feld.getNextRUp().getVisited()) && ((feld.getPreX()!=posX+1) || (feld.getPreY()!=posY+1))) {

		madestep=goRUp();

	}else if ((feld.getNextDn()!=null) && (!feld.getNextDn().getVisited()) && ((feld.getPreX()!=posX) || (feld.getPreY()!=posY-2))) {

		madestep=goDn();

	}

// wenn es sich verklemmt hat, dann soll er weitergehen, auch wenn das feld das Flag Visited gesetzt hat,jedoch soll er (vorerst) noch nicht auf das zuletzt besuchte Feld gehen

	else if ((feld.getNextUp()!=null) && (!feld.getNextUp().getVisited())) {

		madestep=goUp();

	}else if ((feld.getNextLUp()!=null) && (!feld.getNextLUp().getVisited())) {

		madestep=goLUp();

	}else if ((feld.getNextLDn()!=null) && (!feld.getNextLDn().getVisited())) {

		madestep=goLDn();

	}else if ((feld.getNextRDn()!=null) && (!feld.getNextRDn().getVisited())) {

		madestep=goRDn();

	}else if ((feld.getNextRUp()!=null) && (!feld.getNextRUp().getVisited())) {

		madestep=goRUp();

	}else if ((feld.getNextDn()!=null) && (!feld.getNextDn().getVisited())) {

		madestep=goDn();

	}

//

	else if ((feld.getNextUp()!=null) && ((feld.getPreX()!=posX) || (feld.getPreY()!=posY+2))) {

		madestep=goUp();

	}else if ((feld.getNextLUp()!=null) &&  ((feld.getPreX()!=posX-1) ||  (feld.getPreY()!=posY+1))) {

		madestep=goLUp();

	}else if ((feld.getNextLDn()!=null) && ((feld.getPreX()!=posX-1) || (feld.getPreY()!=posY-1))) {

		madestep=goLDn();

	}else if ((feld.getNextRDn()!=null) && ((feld.getPreX()!=posX+1) || (feld.getPreY()!=posY-1))) {

		madestep=goRDn();

	}else if ((feld.getNextRUp()!=null) && ((feld.getPreX()!=posX+1) || (feld.getPreY()!=posY+1))) {

		madestep=goRUp();

	}else if ((feld.getNextDn()!=null) && ((feld.getPreX()!=posX) || (feld.getPreY()!=posY-2))) {

		madestep=goDn();

	}

// Wenn der Normalfall nicht zutrifft

	else if ((feld.getNextUp()!=null)) {

		madestep=goUp();

	}else if ((feld.getNextLUp()!=null)) {

		madestep=goLUp();

	}else if ((feld.getNextLDn()!=null)) {

		madestep=goLDn();

	}else if ((feld.getNextRDn()!=null)) {

		madestep=goRDn();

	}else if ((feld.getNextRUp()!=null)) {

		madestep=goRUp();

	}else if ((feld.getNextDn()!=null)) {

		madestep=goDn();

	} 

// hier gibts dann keinen anderen Ausweg mehr, als wieder sich umzuschauen und zur Not nach Hause zu gehen.

	else if (!atHome()) {
		log("Ich glaub' ich komm' nicht mehr nach Hause :( \n");
		pathFinder(0,0);
	}

// ansonsten ist halt Schluss.

	else finished=true;

}

public void run() {

// neues Logfile erstellen
	if (do_log) {
		BufferedWriter f1;
		try {
			f1 = new BufferedWriter(new FileWriter("./log.txt"));
			f1.write("LogFile");
			f1.newLine(); 
			f1.newLine(); 
			f1.close();
		} catch (IOException e) {
			//keine fehlerausgabe
		}
	}
// ende Logfile

	finished = false;
	feld = new Field(0,0,0,0);
	root = new Node2(feld,null,null);
	alleElemente=new Node2(feld,null,null);
	posX=0;
	posY=0;
	steps=0;
	saveFieldIntoList(feld);
	while (!finished) {

		if (!feld.getVisited()) {
			fLog("Ich schau mich um");
			lookAround();
		}

		switchField();
		steps++;
//		fLog(posX+" "+posY+" "+feld.toString()+" =eigenes Feld");

		circleSolver();

		alleElemente.setNext(new Node2(feld,null,alleElemente));
		alleElemente=alleElemente.getNext();

		if (steps==stepsMax) {
			fLog("Rufe nun Pathfinder auf");
			pathFinder(0,0);
			fLog("Pathfinder beendet");
			finished=true;
		}


		fLog("Zyklus beendet");
		fLog("");
	}
	if ((atHome()) && (getCarriedCorn()>0))
		dropHere(getCarriedCorn());
}



public String getHamsterAuthor() { return "die Rennsemmel"; }

public String getHamsterDate() { return "300402"; }

public String getHamsterVersion() { return "0.38"; }

}
