
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
import java.util.LinkedList;
import java.util.Random;
import Dighty;
public class CHamsterCollect {
  Hamster2 m_cHamster;
  CDightyData m_cD;
  int m_iHPosX;
  int m_iHPosY;
  // init des Pfadfinders
  static final  CPathFinder_A cPathfinder = new CPathFinder_A();
  // starten des Zufallgenerators
  static final Random rnd = new Random(2000);
/*-------------------------------------------------*/
/*------------------------ CGen -------------------*/
/*-------------------------------------------------*/
  public class CGen
  {
    int m_iPosX;
    int m_iPosY;
    int m_iCornCount;
  }
/***************************************************/
/********************* Constructor *****************/
/***************************************************/
  public CHamsterCollect(Hamster2 cHamster, CDightyData cD)
  {
    m_cHamster = cHamster;
    m_cD = cD;
  }
/***************************************************/
/******************* CreateCornList ****************/
/***************************************************/
  /** erstellt eine Lister der Felder, die Koerner enthalten */
  ObjectList CreateCornList()
  {
    ObjectList cList = new ObjectList();
    // durchgehen aller Felder, um die gesuchten Felder zu finden
    int iRadius = 1;
    boolean bMaxRadiusReached = false;
    CGen cGen;
    while ((!bMaxRadiusReached) && (iRadius < CLabyrinth_ly0.c_iMaxSizeX + CLabyrinth_ly0.c_iMaxSizeY)) {
      bMaxRadiusReached = true;
      int iDir = 0;
      int iX = CLabyrinth_ly0.c_iStartX + iRadius * CLabyrinth_ly0.c_iMoveX[iDir];
      int iY = CLabyrinth_ly0.c_iStartY + iRadius * CLabyrinth_ly0.c_iMoveY[iDir];
      iDir = CLabyrinth_ly0.Reflect((iDir - 1 + CLabyrinth_ly0.c_iMovepossibilities) % CLabyrinth_ly0.c_iMovepossibilities);
      for (int i = 0; i < CLabyrinth_ly0.c_iMovepossibilities; i++)  {
        for (int j = 0; j < iRadius; j++)  {
          iX += CLabyrinth_ly0.c_iMoveX[iDir];
          iY += CLabyrinth_ly0.c_iMoveY[iDir];
          if ((iX < 0) || (iY < 0) || (CLabyrinth_ly0.Transform_KoordX(iX) >= CLabyrinth_ly0.c_iMaxSizeX) ||
             (CLabyrinth_ly0.Transform_KoordY(iY) >= CLabyrinth_ly0.c_iMaxSizeY)) continue; // <-- ausserhalb des Arrays
          bMaxRadiusReached = false;
          if (m_cD.m_cpFelder.Access(iX, iY).m_iAnz_Koerner > 0)  { cGen = new CGen(); cGen.m_iPosX = iX; cGen.m_iPosY = iY; cGen.m_iCornCount = m_cD.m_cpFelder.Access(iX, iY).m_iAnz_Koerner; cList.add(cGen); }
        }
        iDir = (iDir + CLabyrinth_ly0.c_iMovepossibilities + 1) % CLabyrinth_ly0.c_iMovepossibilities;
      }
      iRadius++;
    }
    return cList;
  }

/***************************************************/
/******************* GetCollectCosts ***************/
/***************************************************/

  /** ermittelt den Aufwand / Gewinn des Sammelns einer Korn-"Einkaufs"-Liste */
  int GetCollectCosts(ObjectList cList)
  {
    int iAufwand = 0, iAufwand_Direkt, iAufwand_InDirekt;
    int iCanTake;
    int iPosX = m_iHPosX, iPosY = m_iHPosY; // Aktuelle Position X und Y
    int iCornCarriage = 0; // speichert, wieviele Koerner gerade getragen werden
    int iAlreadyCollectCornCount = 0, iLength = cList.getCount();
    int iCornCount = 0;
    CGen cPos;
    for (int i = 0; i < iLength;)
    {
      // kontrolle, ob Zielfeld == Bau
      cPos = (CGen)(cList.getItem(i)); // Position des aktuellen Kornfeldes
      if ((cPos.m_iPosX == CLabyrinth_ly0.c_iStartX) && (cPos.m_iPosY == CLabyrinth_ly0.c_iStartY)) { i++; continue;}
      // init der Verlaufsvariablen
      // gehe zum Zielfeld, teste vorher, ob es sich nicht lohnen wuerde, einen Abstecher zum Bau zu unternehemn
      iAufwand_Direkt        = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, cPos.m_iPosX, cPos.m_iPosY);
      iAufwand_InDirekt      = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY)
                             + cPathfinder.go_fast(m_cD.m_cpFelder, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cPos.m_iPosX, cPos.m_iPosY);
      if (iAufwand_Direkt == iAufwand_InDirekt)
      {
        // gehe zum ZielFeld ueber den Bau
        iAufwand += (Constants.POINTS_CORN * iCornCarriage - iAufwand_InDirekt);
        iCornCarriage = 0;
      } else iAufwand -= iAufwand_Direkt;
      iPosX = cPos.m_iPosX; iPosY = cPos.m_iPosY;
      // nehme maximale Anzahl von Koerner auf
      iCanTake = Math.min(cPos.m_iCornCount - iAlreadyCollectCornCount, Constants.CORNCARRY_MAX - iCornCarriage);
      iCornCarriage += iCanTake;
      iAlreadyCollectCornCount += iCanTake;
      // gehe nach Hause, wenn voll beladen
      if ((iCornCarriage == Constants.CORNCARRY_MAX) || ((i == iLength - 1) && (cPos.m_iCornCount == iAlreadyCollectCornCount)))
      {
        // go home
        iAufwand += (Constants.POINTS_CORN * iCornCarriage - cPathfinder.go_fast(m_cD.m_cpFelder,iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY));
        iPosX = CLabyrinth_ly0.c_iStartX; iPosY = CLabyrinth_ly0.c_iStartY;
        iCornCarriage = 0;
      }
      // nehme naechstes Feld, wenn dann aktuelle total abgegrasst ist
      if (cPos.m_iCornCount == iAlreadyCollectCornCount) { i++; iAlreadyCollectCornCount = 0;}
    }
    return iAufwand;
  }

/***************************************************/
/*********************** preSort *******************/
/***************************************************/

  /** sotiert eine Liste vor, Ziel: eine effizientere Startlist */
  public int preSort(ObjectList cList_org)
  {
    int iLength = cList_org.getCount();
    if (iLength == 0) return 0;
    ObjectList cList     = new ObjectList(); cList    .setCapacity(iLength);
    ObjectList cRestList = new ObjectList();
    cList_org.CloneTo(cRestList);
    int iAufwand, iAkt_Aufwand;
    int j, iNr;
    CGen cPos = new CGen();
    cPos.m_iPosX = m_iHPosX;
    cPos.m_iPosY = m_iHPosY;
    // Bestimmen der Reihenfolge der Felder
    m_cHamster.logln("Length: " + Integer.toString(iLength));
    for (int i = 0; i < iLength; i++)
    {
      iAkt_Aufwand = cPathfinder.go_fast(m_cD.m_cpFelder, cPos.m_iPosX, cPos.m_iPosY, ((CGen) (cRestList.getItem(0))).m_iPosX, ((CGen) (cRestList.getItem(0))).m_iPosY);
      iNr = 0;
      for (j = 1; j < iLength - i; j++)  {
        iAufwand = cPathfinder.go_fast(m_cD.m_cpFelder, cPos.m_iPosX, cPos.m_iPosY, ((CGen) (cRestList.getItem(j))).m_iPosX, ((CGen) (cRestList.getItem(j))).m_iPosY);
        if (iAufwand < iAkt_Aufwand)  {
          // ein naeheres Feld wurde erkannt
          iAkt_Aufwand = iAufwand;
          iNr = j;
        }
        // aktualisieren der Verlaufsvariabeln und der Restliste
      }
      cPos = (CGen) (cRestList.getItem(iNr));
      cList.add(cPos);
      cRestList.exchange(iNr, iLength - i - 1);
    }
    int iGewinn = GetCollectCosts(cList) - GetCollectCosts(cList_org);
    if (iGewinn > 0) cList.CloneTo(cList_org);
    return iGewinn;

  }
/***************************************************/
/************************* Sort ********************/
/***************************************************/


  /** sotiert eine Liste neu, nach Effiziens*/
  public int sort(ObjectList cList_org)
  {
    int iLength = cList_org.getCount();
    if (iLength == 0) return 0;
    // eine Kopie der Felder erzeugen
    ObjectList cList_Prototyp = new ObjectList();
    cList_Prototyp.setCapacity(iLength);
    cList_Prototyp.add(cList_org.getItem(0));             // kopieren des ersten Elements der Uhrprungsfeldliste in den Prototyp
    int iAktAufwand = 0;                         // speichert den Aufand der aktuell zusammengestellten Liste, am anfang den Aufwand des Prototyps
    int iAktBestPos;                             // speichert den aktuellen Index der besten Position des einzufuegenen Elementes, am anfang steht er auf Ende des Prototys
    // Hauptschleife, die die Liste anwachsen laesst
    for (int i = 1; i < iLength; i++)
    {
//       m_cHamster.logln("i: " + Integer.toString(i));
      // erstellen eines Prototypen der um 1 wachsenden Liste
      cList_Prototyp.add(cList_org.getItem(i)); // kopieren des nachsten zu verwendenen Elements der Orginaliste in den Prototyp
      // Initiieren der Verlaufsvariablen
      iAktAufwand = GetCollectCosts(cList_Prototyp);
      iAktBestPos = i;
      // nun Effizienspruefung aller moegichen Positionen des neuen Feldes
      // wird durch durchtauschen des zu testenen Elements mit allen anderen erreicht, dabei wird iAktaufwand/iAktBestPos gegebenenfals aktualisiert
      for (int j = i - 1; j >= 0; j--)  {
        // Vertauschen der Alten Position des zu testenen Elements mit der neuen Position
        cList_Prototyp.exchange(j + 1, j);
        // ermitteln, ob der tausch bessere Ergebnisse liefert, als die zuvor beste Anortnung, dann aktualisiere die Verlaufsvariablen
        int iNeuerAufwand = GetCollectCosts(cList_Prototyp);
        if (iAktAufwand < iNeuerAufwand)  {
          iAktAufwand = iNeuerAufwand;
          iAktBestPos = j;
        }
      }
      // nachdem nun die beste Anortnung des Prototys gefunden wurde, wird dieser daruf eingestellt
      for (int j = 0; j < iAktBestPos; j++)   {
        cList_Prototyp.exchange(j, j + 1);
//        m_cHamster.logln("j: " + Integer.toString(j));
  //      m_cHamster.logln(": " + Integer.toString(i));
      }
      // wiederhohlen, bis alle Felder in den Prototypen eingetragen sind
    }
    // Auswerten des Ergebnisses, d.h. ermitteln des Gewinns, theoretisch muss er mindestens neutral sein, niemals negativ
//    int iGewinn = iAktAufwand - GetCollectCosts(cList_org);
    int iGewinn = GetCollectCosts(cList_Prototyp) - GetCollectCosts(cList_org);
    if (iGewinn > 0)  cList_Prototyp.CloneTo(cList_org);
    return iGewinn;
  }

/***************************************************/
/*********************** ClearList *****************/
/***************************************************/

  public int ClearList(ObjectList cList_org)
  {
    int iLength = cList_org.getCount();
    if (iLength == 0) return 0;
    // eine Kopie der Felder erzeugen
    int iDeleyCount = 0;
    ObjectList cRestList = new ObjectList(); cList_org.CloneTo(cRestList);
    ObjectList cAktList  = new ObjectList();
    int j, k;
    for (int i = 0; i < cRestList.getCount(); i++) {
      k = 0;
      cAktList.clear();
      // erstellen der kleineren akuellen Liste aus der Restliste
      cRestList.CloneTo(cAktList);
      cAktList.delete(i);
      if (GetCollectCosts(cAktList)  > GetCollectCosts(cRestList))   {
        cAktList.CloneTo(cRestList);
        i = 0;
        iDeleyCount++;
      }
    }
    // schauen, ob sich der insgesammt Aufwand gelohnt hat, sollte er zumindest
    int iGewinn_org, iGewinn_new;
    if ((iGewinn_org = GetCollectCosts(cList_org)) < (iGewinn_new = GetCollectCosts(cRestList)))
       cRestList.CloneTo(cList_org);
//    m_cHamster.logln(" remove count " + Integer.toString(iDeleyCount));
    return iGewinn_new - iGewinn_org;
  }
/***************************************************/
/************* GenerateAndEraseTakeList ************/
/***************************************************/
  protected ObjectList GenerateAndEraseTakeList(ObjectList cList){
    int iAufwandDirekt = 0;
    int iAufwandInDirekt = 0, iCanTake;
    int iCornCarriage = m_cHamster.getCarriedCorn();
    int iPosX = m_iHPosX;
    int iPosY = m_iHPosY;
    ObjectList cResult = new ObjectList();
    for (int i = 0; i < cList.getCount(); i++)  {
      // ermitteln des Gens
      if (Constants.CORNCARRY_MAX == iCornCarriage) break;
      CGen cGen = (CGen) cList.getItem(i);
      if (cGen.m_iCornCount <= 0) continue;
      iAufwandDirekt   = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, cGen.m_iPosX, cGen.m_iPosY);
      // gehe bei bedarf nach Hause
      iAufwandInDirekt = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY)
                       + cPathfinder.go_fast(m_cD.m_cpFelder, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cGen.m_iPosX, cGen.m_iPosY);
      if (iAufwandDirekt == iAufwandInDirekt) break;
      iPosX = cGen.m_iPosX;
      iPosY = cGen.m_iPosY;
      cResult.add(cGen);
      iCanTake = Math.min(cGen.m_iCornCount, Constants.CORNCARRY_MAX - iCornCarriage);
      iCornCarriage += iCanTake;
      cGen.m_iCornCount -= iCanTake;
      if (cGen.m_iCornCount == 0) cList.setItem(i, null);
    }
    CGen cHomeGen = new CGen();
    cHomeGen.m_iPosX = CLabyrinth_ly0.c_iStartX;
    cHomeGen.m_iPosY = CLabyrinth_ly0.c_iStartY;
    cResult.add(cHomeGen);
    for (int i = 0; i < cList.getCount(); i++)  {
      CGen cGen = (CGen) cList.getItem(i);
      if (cGen == null) continue;
      if (cGen.m_iCornCount == 0) { cList.setItem(i, null); continue; }
      if (cGen.m_iCornCount >= Constants.CORNCARRY_MAX) cResult.add(cGen);
      cGen.m_iCornCount = cGen.m_iCornCount % Constants.CORNCARRY_MAX;
      if (cGen.m_iCornCount == 0) cList.setItem(i, null);
    }
    cList.pack();
    return cResult;
  }
/***************************************************/
/****************** WerfeKlippen *******************/
/***************************************************/
  protected int GetHeightestCorns(ObjectList cGesammt, ObjectList cPartial, int iMaxHeight)
  {
    int iAktHeight = -100;
    CFeld cFeld;
    CGen cGen;
    cPartial.clear();
    for (int i = 0; i < cGesammt.getCount(); i++) {
      cGen = (CGen) cGesammt.getItem(i);
      cFeld = m_cD.m_cpFelder.Access(cGen.m_iPosX, cGen.m_iPosY);
      if (cFeld.m_iHoehe > iMaxHeight) continue;
      if (cFeld.m_iHoehe < iAktHeight) continue;
      if (cFeld.m_iHoehe > iAktHeight)  cPartial.clear();
      iAktHeight = cFeld.m_iHoehe;
      cPartial.add(cGen);
    }
    return iAktHeight;
  }
  protected boolean DropIfNice(CGen cPos, ObjectList cTakeList)
  {
    CPath cPath;   CGen cGoGen;
    int iPosX, iPosY, k, iTake;
    if (cTakeList.getCount() == 0) return false;
    // er sollte nicht gerade vom Homefeld kommen, da es sich nicht lohnt - test ob er Klippen benutzt
    cPath = cPathfinder.go(m_cD.m_cpFelder, cPos.m_iPosX, cPos.m_iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
    // suchen nach einer Klippe
    int iPX = cPos.m_iPosX, iPY = cPos.m_iPosY;
    while (cPath.size() != 0) {
      int iDir = ((Integer)(cPath.pop())).intValue();
      if ((m_cD.m_cpFelder.Access(iPX, iPY).m_iRahmen[iDir] & Constants.WALLMASK) == Constants.CLIFFDOWN )
      {
        iPX = ((CGen) (cTakeList.getLast())).m_iPosX; iPY = ((CGen) (cTakeList.getLast())).m_iPosY;
        cPath = cPathfinder.go(m_cD.m_cpFelder, iPX, iPY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
        while (cPath.size() != 0) {
          iDir = ((Integer)(cPath.pop())).intValue();
          if ((m_cD.m_cpFelder.Access(iPX, iPY).m_iRahmen[iDir] & Constants.WALLMASK) == Constants.CLIFFDOWN )
          {
            // ueberpruefen, ob es sich ueberhaupt lohnt, die Klippen etwas hinunter zu werfen
            int iAufwand1, iAufwand2;
            cGoGen  = ((CGen) (cTakeList.getItem(0)));
            if (cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, cGoGen.m_iPosX, cGoGen.m_iPosY) >=
                cPathfinder.go_fast(m_cD.m_cpFelder, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cGoGen.m_iPosX, cGoGen.m_iPosY)) return false;
            //-- sammeln
            for (k = 0; k < cTakeList.getCount(); k++)
            {
              cGoGen  = ((CGen) (cTakeList.getItem(k)));
              iPosX = cGoGen.m_iPosX;
              iPosY = cGoGen.m_iPosY;
              CHamsterMoveTo.run(m_cHamster, m_cD, iPosX, iPosY);
              m_cD.m_cpFelder.Access(iPosX, iPosY).m_iAnz_Koerner -= m_cHamster.take(Constants.CORNCARRY_MAX);
            }
            CHamsterMoveTo.run(m_cHamster, m_cD, iPX, iPY);
            CHamsterLockTo.run(m_cHamster, m_cD, iDir);
            CFeld cFeldNew = m_cD.m_cpFelder.Access(iPX + CLabyrinth_ly0.c_iMoveX[iDir], iPY + CLabyrinth_ly0.c_iMoveY[iDir]);
            iTake  = m_cHamster.dropForward(Constants.CORNCARRY_MAX);
            cFeldNew.m_iAnz_Koerner += iTake;
            if ((iTake == 0) && (m_cHamster.getCarriedCorn() > 0) )
              return false;
            while (m_cHamster.getAvailableCorn() > 0)  {
              iTake = m_cHamster.take(Constants.CORNCARRY_MAX);
              m_cD.Access().m_iAnz_Koerner -= iTake;
              iTake = m_cHamster.dropForward(iTake);
              cFeldNew.m_iAnz_Koerner += iTake;
              if (iTake == 0) {
                // ein grosses Problem
                return false;
              }
            }
            return true;
          }
          iPX += CLabyrinth_ly0.c_iMoveX[iDir];
          iPY += CLabyrinth_ly0.c_iMoveY[iDir];
        }
        return false;
      }
      iPX += CLabyrinth_ly0.c_iMoveX[iDir];
      iPY += CLabyrinth_ly0.c_iMoveY[iDir];
    }
    return false;
  }

  protected boolean WerfeKlippen() {
    boolean bResult = false;
    ObjectList cGesammtKornListe, cKornListe = new ObjectList(), cTakeList = new ObjectList();
    int iHeight = 100, iGetHeight, iGewinn, iCornCarriage, i, iAufwand_Direkt = 0, iAufwand_InDirekt = 0, j, k, iCount;
    CFeld cFeld;
    CGen cPos = null;
    CPath cPath;
    boolean bRetryKornLoop = false, bClifFound, bRestartKornLoop;
    do {
      int iPosX = m_iHPosX = m_cD.m_iPosX;  int iPosY = m_iHPosY = m_cD.m_iPosY, iCanTake, iAlreadyCollectCornCount, iDroppCount;
      if (!bRetryKornLoop){
        cGesammtKornListe = CreateCornList();
        iHeight = GetHeightestCorns(cGesammtKornListe, cKornListe, iHeight);
        if (cKornListe.getCount() == 0) break;
        do{  iGewinn = sort(cKornListe);} while (iGewinn > 0);
        ClearList(cKornListe);
      }
      iCornCarriage = m_cHamster.getCarriedCorn();
      bRetryKornLoop = bClifFound = bRestartKornLoop = false;
      iAlreadyCollectCornCount = 0;
      iDroppCount = 0;
      cTakeList.clear();
      iCount = 0;
      for (i = 0; i < cKornListe.getCount(); i++)
      {
        cPos = (CGen)(cKornListe.getItem(i)); // Position des aktuellen Kornfeldes
        if (cPos == null) { i++; continue;}
        iCount++;
        cFeld = m_cD.m_cpFelder.Access(cPos.m_iPosX, cPos.m_iPosY);
        cPath = cPathfinder.go(m_cD.m_cpFelder, iPosX, iPosY, cPos.m_iPosX, cPos.m_iPosY);
        iAufwand_Direkt        = cPath.size();//cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, cPos.m_iPosX, cPos.m_iPosY);
        iAufwand_InDirekt      = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY)
                               + cPathfinder.go_fast(m_cD.m_cpFelder, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cPos.m_iPosX, cPos.m_iPosY);
        if (iAufwand_Direkt == iAufwand_InDirekt){
          cPos = new CGen(); cPos.m_iPosX = m_cD.m_iPosX;     cPos.m_iPosY = m_cD.m_iPosY;
          if (DropIfNice(cPos, cTakeList)) { iDroppCount++; bResult = true;}
          bRetryKornLoop = false;   bRestartKornLoop = true;
          cTakeList.clear();
          break;
        } else if (iCount > 1){
          // ueberpruefen, ob der Weg zum neuen Feld ueber "unwegsammes Gelaende" fuehrt
          int iPX = iPosX, iPY = iPosY;
          while (cPath.size() != 0) {
            int iDir = ((Integer)(cPath.pop())).intValue();
            if ((m_cD.m_cpFelder.Access(iPX, iPY).m_iRahmen[iDir] & Constants.CLIFFDOWN) == Constants.CLIFFDOWN ) {
              bRetryKornLoop = true;
              break;
            }
            iPX += CLabyrinth_ly0.c_iMoveX[iDir];
            iPY += CLabyrinth_ly0.c_iMoveY[iDir];
          }
          if (bRetryKornLoop) { i++; iAlreadyCollectCornCount = 0; continue; }
        }
        iPosX = cPos.m_iPosX; iPosY = cPos.m_iPosY;
        cTakeList.add(cPos);
        // nehme maximale Anzahl von Koerner auf
        iCanTake = Math.min(cFeld.m_iAnz_Koerner - iAlreadyCollectCornCount, Constants.CORNCARRY_MAX - iCornCarriage);
        iCornCarriage += iCanTake;
        iAlreadyCollectCornCount += iCanTake;
        cKornListe.setItem(i, null);
        // gehe nach Hause, wenn voll beladen
        if (iCornCarriage == Constants.CORNCARRY_MAX)
        {
          if (DropIfNice(cPos, cTakeList)) {
            bRetryKornLoop = false;   bRestartKornLoop = true;
            iDroppCount++; bResult = true;
            cTakeList.clear();
            break;
          } else {
            iCornCarriage = m_cHamster.getCarriedCorn();
            cTakeList.clear();
            iPosX = m_cD.m_iPosX; iPosY = m_cD.m_iPosY;
          }
        }
        if (cFeld.m_iAnz_Koerner == iAlreadyCollectCornCount) { i++; iAlreadyCollectCornCount = 0;}
      }
      if (iDroppCount == 0)
        if (DropIfNice(cPos, cTakeList)) {bResult = true; iDroppCount++;};
      if ((iDroppCount == 0) && bRetryKornLoop) iDroppCount++;
      if (iDroppCount == 0) iHeight--;
    } while (true);
    return bResult;
  }
/***************************************************/
/*---------------------- run ----------------------*/
/***************************************************/
  ObjectList m_PreRunCornList;
  public void run() {
   // anschalten des entfernungspuffers
//    m_cD.m_cpFelder.DistanceBuffering(true);
    // Klippenwerfen
    int i = 0;
    if (m_cD.m_cpFelder.m_bIsExtendedLyb)
      while ((WerfeKlippen()) && (i < 5)) i++;
   // Speichern der aktuellen Hamsterposition
    m_iHPosX = m_cD.m_iPosX;
    m_iHPosY = m_cD.m_iPosY;
    // erstellender Kornliste(n)
    ObjectList cKornListL = CreateCornList();
    ObjectList cCornList  = new ObjectList();
    ObjectList cCornList2 = new ObjectList();
    cKornListL.CloneTo(cCornList);
    // voreinsammeln
    preSort(cCornList);
    m_bPreRunReached20 = false;
    int iGewinn;
    do{  iGewinn = sort(cCornList);} while (iGewinn > 0);
    m_PreRunCornList = GenerateAndEraseTakeList(cCornList);
    //--  richtige Optimierung ...
//    m_cD.m_cpFelder.DistanceBuffering(true);
    // Speichern der aktuellen Hamsterposition
    m_iHPosX = CLabyrinth_ly0.c_iStartX;
    m_iHPosY = CLabyrinth_ly0.c_iStartY;
    cCornList.CloneTo(cKornListL);
    // starten der Optimierung
    m_cHamster.logln(" generate random indivis ..., Anzahl der Kornfelder:" + cKornListL.getCount());
    CGenetig cOptimizer = new CGenetig(1000, cKornListL);
    // hinzufuegen der Startlisten als Individuum
    preSort(cCornList);
    cOptimizer.AddKonstIndivToIndivPool(cCornList);
    // hinzufuegen von statisch optimierte Listen
    m_cHamster.logln(" generate static indivis ...");
    do{  iGewinn = sort(cCornList);} while (iGewinn > 0);
    cCornList.CloneTo(cCornList2);
    for (i = 0; i < cCornList2.getCount() / 2; i++) cCornList2.exchange(i, cCornList2.getCount() - i - 1);
    do{  iGewinn = sort(cCornList2);} while (iGewinn > 0);
    cOptimizer.AddKonstIndivToIndivPool(cCornList);
    cOptimizer.AddKonstIndivToIndivPool(cCornList2);
    ClearList(cCornList);
    ClearList(cCornList2);
    System.out.println(" Fitness, static1 = " + Integer.toString(GetCollectCosts(cCornList)));
    System.out.println(" Fitness, static2 = " + Integer.toString(GetCollectCosts(cCornList2)));
    cOptimizer.AddKonstIndivToIndivPool(cCornList);
    cOptimizer.AddKonstIndivToIndivPool(cCornList2);
    // "freigeben" von Speicher, damit Java schneller wird
    cCornList = null;
    cCornList2 = null;
    cKornListL = null;
    m_cD.m_cpFelder_Optimal = null;
   // ablaufen
   m_cHamster.logln(" optimize ...");
   CIndividual cBestIndivi = cOptimizer.Optimize();
   m_cHamster.logln(" go Shoping");
   cBestIndivi.go();
  }
  static boolean m_bPreRunReached20 = false;
  boolean PreRun(ObjectList cList) {
   if (m_cD.m_bMovedTimeOutSaver) CHamsterDoAStep.run(m_cHamster, m_cD, true);
   // go Home
   if ((m_cHamster.getCarriedCorn() == Constants.CORNCARRY_MAX) || ((m_cHamster.getCarriedCorn() > 0) && (m_bPreRunReached20)))
   {
     if (!m_bPreRunReached20) {
       m_bPreRunReached20 = true;
       if (cList.getCount() > 0) cList.delete(0);
     }
     CPath cPath = cPathfinder.go(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
     if (cPath.size() != 0){
       int iDirection = ((Integer) (cPath.pop())).intValue();
       CHamsterMoveTo.run(m_cHamster, m_cD, m_cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[iDirection], m_cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[iDirection]);
       return (cPath.size() > 0) || (cList.getCount() > 0);
    }
   }
   if (cList.getCount() == 0) return false;
   CGen cGen = (CGen) cList.getItem(0);
   CFeld cFeld = m_cD.m_cpFelder.Access(cGen.m_iPosX, cGen.m_iPosY);
   if (cFeld.m_iAnz_Koerner == 0) { cList.delete(0); return PreRun(cList);}
   // Schnitt
   if ((cGen.m_iPosX == CLabyrinth_ly0.c_iStartX) && (cGen.m_iPosY == CLabyrinth_ly0.c_iStartY)) {
     m_bPreRunReached20 = true;
     cList.delete(0);
     return PreRun(cList);
   }
   // go Feld
   CPath cPath = cPathfinder.go(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, cGen.m_iPosX, cGen.m_iPosY);
   if (cPath.size() != 0){
     int iDirection = ((Integer) (cPath.pop())).intValue();
       CHamsterMoveTo.run(m_cHamster, m_cD, m_cD.m_iPosX + CLabyrinth_ly0.c_iMoveX[iDirection], m_cD.m_iPosY + CLabyrinth_ly0.c_iMoveY[iDirection]);
       return (cPath.size() > 0) || (cList.getCount() > 0);
    }else if ((cGen.m_iPosX == cGen.m_iPosX) && (cGen.m_iPosY == cGen.m_iPosY)) {
      cFeld.m_iAnz_Koerner -= m_cHamster.take(Constants.CORNCARRY_MAX);
      if (cFeld.m_iAnz_Koerner == 0) cList.delete(0); else
      if (m_bPreRunReached20) if (cFeld.m_iAnz_Koerner < Constants.CORNCARRY_MAX) cList.delete(0);
      return PreRun(cList);
    }
    return cList.getCount() > 0;
 }
/*-------------------------------------------------*/
/*-------------- CIndivSortFunction ---------------*/
/*-------------------------------------------------*/
  public class CIndivSortFunction implements ListSortCompare {
    public int CompareFunc(Object item1, Object item2) {
      return  (((CIndividual) (item1)).m_iFitness - ((CIndividual) (item2)).m_iFitness);
    }
  }
/*-------------------------------------------------*/
/*------------------- CGenetig --------------------*/
/*-------------------------------------------------*/
  /** der Genetische Algo*/
  public class CGenetig
  {
    int m_iAnzIndiv; // Anzahl von Individuen
    ObjectList m_cCornList;
    ObjectList m_cpIndiv = new ObjectList(); // IndividumListe
/***************************************************/
/******************* Constructor *******************/
/***************************************************/
    CGenetig(int iAnzIndiv, ObjectList cCornList)
    {
      m_cCornList = cCornList;
      m_iAnzIndiv =  iAnzIndiv;
      m_cpIndiv.setCapacity(iAnzIndiv);

      for (int i = 0; i < iAnzIndiv; i++)
        m_cpIndiv.add(new CIndividual(m_cCornList));
    }
/***************************************************/
/************ AddKonstIndivToIndivPool *************/
/***************************************************/
    void AddKonstIndivToIndivPool(ObjectList cpCornList)
    {
      m_iAnzIndiv++;
      m_cpIndiv.add(new CIndividual(cpCornList, 1));
    }
/***************************************************/
/******************** Optimize *********************/
/***************************************************/
/**

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
!!!!!!!!!!!!!!!!!!!!!!11
!!!!!!!!!!!!!!111

 ich habe bei C00. maze bei der Optimirung ueber 1300 Punkte erhalten, nach einen Zufallsstart
 nun erhalte ich nurnoch ca 1230 - das sind 70 Punkte, ich weis leider nicht, was ich geaendert hatte - es waren
 jedoch 150 Generationen bei 100 Individuen
*/
    public CIndividual Optimize()
    {
       int iPuntke = m_cHamster.getPoints();
       int iRandomIndiv1;
       int iRandomIndiv2;
       float iCount;
       int iMaxIndexToTake;
       int iSizeToRestore;
       ObjectList Childs = new ObjectList();
       System.out.println("Punkte nach Scouten: " + Integer.toString(iPuntke));
      // Evolutionsschleife
      int iIndivCount = m_cpIndiv.getCount();
      CIndivSortFunction cSortFkt = new CIndivSortFunction(); // sortierungsfkt
      m_cpIndiv.sort(cSortFkt);
      CIndividual cBestInd = (CIndividual)m_cpIndiv.getItem(0);
      CIndividual cCmpInd  = null;
      int iTimeOutCredits = (int)cBestInd.m_cGenom.getCount() / 20;
      boolean bDecCredits = true;
      if (cBestInd.m_cGenom.getCount() > 0)
      for (int iEvoNr = 0; ; iEvoNr ++)
      {
        if(m_cD.m_bTimeOutWarning2){
          m_cD.m_bTimeOutWarning2 = false;
          if (PreRun(m_PreRunCornList)) m_cD.m_bTimeOutWarning = false;
          cCmpInd = (CIndividual)m_cpIndiv.getItem(0);
          if ((cCmpInd.m_iFitness - cBestInd.m_iFitness) < 2)
            if (bDecCredits) iTimeOutCredits--;
          bDecCredits = !bDecCredits;
          cBestInd = cCmpInd;
        }
        // TimeoutSave
        if (m_cD.m_iStartTime + Constants.TOTAL_RUNTIME - System.currentTimeMillis() - (Constants.TOTAL_RUNTIME / 10) < 0)       {
          m_cHamster.logln(" TotalTimeoutWarning -> Stop Evolution");
           break;
        }
        if (m_cD.m_bTimeOutWarning) {
          cCmpInd = (CIndividual)m_cpIndiv.getItem(0);
          if ((cCmpInd.m_iFitness - cBestInd.m_iFitness) < 2) {
            iTimeOutCredits--;
          }
          cBestInd = cCmpInd;
          m_cD.m_bTimeOutWarning = false;
        }
        if (iTimeOutCredits < 0) break;
        // toeten von schlechten Indivs
        iSizeToRestore = m_cpIndiv.getCount();
        for (int i = 5; i < m_cpIndiv.getCount(); i++)
          if (rnd.nextFloat() < Math.pow(i / (float)m_cpIndiv.getCount(), 0.7))
             m_cpIndiv.setItem(i, null);
        m_cpIndiv.pack();
        iMaxIndexToTake = m_cpIndiv.getCount();
          // Auffrischen der Indivs
        CIndividual cIndiv = null;
        for (int i = iMaxIndexToTake; i < iSizeToRestore; i++)
        {
          iRandomIndiv1 = rnd.nextInt(iMaxIndexToTake);
          iRandomIndiv2 = rnd.nextInt(iMaxIndexToTake);
          if (iRandomIndiv1 != iRandomIndiv2)
            cIndiv = ( new CIndividual((CIndividual) (m_cpIndiv.getItem(iRandomIndiv1)), (CIndividual) (m_cpIndiv.getItem(iRandomIndiv2)), "s"));
          else cIndiv = new CIndividual(m_cCornList);
          m_cpIndiv.add(cIndiv);
        }

        // ermitteln der Fitness aller Individuen
        iCount = 0;
        for (int i = 0; i < m_cpIndiv.getCount(); i++)
          iCount += ((CIndividual) (m_cpIndiv.getItem(i))).m_iFitness;
        m_cpIndiv.sort(cSortFkt);
        System.out.print(iCount);
        System.out.println("   Evo: " + Integer.toString(iEvoNr) + " beste Leistung: " + Integer.toString(((CIndividual) (m_cpIndiv.getItem(0))).m_iFitness) + " Laenge " + ((CIndividual) (m_cpIndiv.getItem(0))).m_cGenom.getCount() + " Credits: " + iTimeOutCredits);
      }
      // sortieren der Individuum Liste
      m_cpIndiv.sort(cSortFkt);
      while (PreRun(m_PreRunCornList));
      System.out.println("theoretische Punkte nach Ablauf des Labyrints: " + Integer.toString(m_cHamster.getPoints() + ((CIndividual) (m_cpIndiv.getItem(0))).m_iFitness));
      return (CIndividual) (m_cpIndiv.getItem(0)); // gebe bestes zurueck
    }
  }
  // Gen eines Korns
/*-------------------------------------------------*/
/*--------------------- CGen_Corn -----------------*/
/*-------------------------------------------------*/
  public class CGen_Corn extends CGen
  {
    public CGen_Corn(CXY cXY, int iCornCount) { m_iPosX = cXY.m_iX;  m_iPosY = cXY.m_iY; m_iCornCount = iCornCount;}
    public CGen_Corn(int iX, int iY, int iCornCount) { m_iPosX = iX;  m_iPosY = iY; m_iCornCount = iCornCount;}
    public CGen_Corn(CGen_Corn cCorn, int iCornCount) { m_iPosX = cCorn.m_iPosX;  m_iPosY = cCorn.m_iPosY; m_iCornCount = iCornCount;}
    public int m_iCornCount;
  }
/*-------------------------------------------------*/
/*--------------------- CIndividual ---------------*/
/*-------------------------------------------------*/

  /** classe fuer ein Individuum*/
  public class CIndividual
  {
    public static final int   c_iWorstDistance = Constants.POINTS_CORN * Constants.CORNCARRY_MAX - 2;
    public static final float c_fKillConst = c_iWorstDistance * 1.414f;     // Konstante zum Kicken von Korngene
    public ObjectList m_cGenom = new ObjectList();
    public int m_iGenomLength;
    public int m_iFitness;

    /** erstellt ein Individuum aus einem Konstanten Kornarray*/
    public CIndividual(ObjectList cCornList, int iStatikDummy)
    {
      cCornList.CloneTo(m_cGenom);
      m_iFitness = InterpreteGenom();
    }
/***************************************************/
/********************** toString *******************/
/***************************************************/
    public String toString() {
      ObjectList pcGenom = m_cGenom;
      String Result = " ";
      for (int i = 0; i < pcGenom.getCount(); i++)  {
        CGen_Corn cGen_Corn = (CGen_Corn) (pcGenom.getItem(i));
        Result += " C(" + cGen_Corn.m_iPosX + " " + cGen_Corn.m_iPosY + " " + cGen_Corn.m_iCornCount + ")";
      }
      return Result;
    }
/***************************************************/
/********** CIndividual - CreateSingleGenom ********/
/***************************************************/

  protected void CreateSingleGenoms(CIndividual cFather, CIndividual cMother, ObjectList cGenomF, ObjectList cGenomM)
  {
     // hinzufuegen aller Gene zum Genom, elemenieren der Doppelten
    cFather.m_cGenom.CloneTo(cGenomF);
    cMother.m_cGenom.CloneTo(cGenomM);
    Object cAktGen, cTestGen;
    ObjectList cGenom = cGenomM, cGenom2 = cGenomF;
    int j, i, k, iLength;
      // die einfachen Genome wurden erstellt, nun muessen noch Gene herausgefiltert werden, die im jewalig anderen nicht vorhanden sind
    for (k = 0; k < 2; k++)
    {
      iLength = cGenom2.getCount();
      for (i = 0; i < cGenom.getCount(); i++) {
        cAktGen =  cGenom.getItem(i);
        for (j = 0; j < iLength; j++)  {
          if (cAktGen == cGenom2.getItem(j)) break; // abgleichen der Referenzen
        }
        // wurde die J-Schleife nicht via break abgebrochen, exisiert das jewalige Gen im Genom nicht in Genom2
        if (j == iLength)
        {
          if (rnd.nextInt(4) != 0){ // hinzufuegen des fehlenden Gens zum anderen Genom
            if (iLength > 0){
              cGenom2.insert(rnd.nextInt(iLength), cAktGen);
              iLength++;
            }
            else cGenom2.add(cAktGen);
          } else{
            cGenom.setItem(i, null); // kill
          }
        }
      }
      cGenom.pack();
      cGenom2 = cGenomM;
      cGenom = cGenomF;
    }
  }
/***************************************************/
/********* CIndividual - ErstelleKantenListe *******/
/***************************************************/
  protected ObjectList KantenListe(ObjectList cFather , ObjectList cMother)
  {
    int i, j, iPrevIndex, iSufIndex;
    ObjectList Result = new ObjectList();
    ObjectList cKante;
    Result.setCapacity(cFather.getCount());
    for (i = 0; i < cFather.getCount(); i++) {
      // Indizes Bestimmen
      if (i == cFather.getCount() - 1) {  iSufIndex = 0; iPrevIndex = i - 1; }
        else { iSufIndex = i + 1; if (i == 0) iPrevIndex = cFather.getCount() - 1; else  iPrevIndex = i - 1; }
      cKante = new ObjectList();
      // hinzufuegen der Vatergene
      if (iPrevIndex > 0)
        cKante.add(cFather.getItem(iPrevIndex));
      if (iSufIndex < cFather.getCount() - 1)
        cKante.add(cFather.getItem(iSufIndex));
      // suchen des aquivalenten Muttergens
      j = cMother.indexOf(cFather.getItem(i));
      // Indizes Bestimmen
      if (j == cMother.getCount() - 1) { iSufIndex = 0; iPrevIndex = j - 1;}
        else { iSufIndex = j + 1; if (j == 0) iPrevIndex = cMother.getCount() - 1; else  iPrevIndex = j - 1; }
      // hinzufuegen der Muttergene
      if (iPrevIndex > 0)
        if (cKante.indexOf(cMother.getItem(iPrevIndex)) == - 1) cKante.add(cMother.getItem(iPrevIndex));
      if (iSufIndex < cMother.getCount() - 1)
        if (cKante.indexOf(cMother.getItem(iSufIndex))  == - 1) cKante.add(cMother.getItem(iPrevIndex));
      // Tag
      cKante.add(cFather.getItem(i));
      Result.add(cKante);
    }
    return Result;
  }
/***********************************************/
/********** CIndividual - Crossproduct *********/
/***********************************************/
  public CIndividual(CIndividual cFather, CIndividual cMother, String sDummy)
  {
//      goHome(cCornList);
//    TakeSomeCorns(cCornList);

    int iRnd;
    ObjectList cGenom_Father = new ObjectList();
    ObjectList cGenom_Mother = new ObjectList();
    CreateSingleGenoms(cFather, cMother, cGenom_Father, cGenom_Mother);
    if (cGenom_Father.getCount() == 0) return;
    iRnd = rnd.nextInt(100);
    if (iRnd <  25)
     CrossOver_ERX(cGenom_Father, cGenom_Mother);
    else
      if (iRnd <  50)
     CrossOver_OX(cGenom_Father, cGenom_Mother);
    else
      if (iRnd <  75)
    CrossOver_PMX(cGenom_Father, cGenom_Mother);
    else
      if (iRnd <  90)  Mutation1(cGenom_Mother);
    else
      if (iRnd < 100)  Elemination1(cGenom_Mother);
//                    {sort(cGenom_Mother); m_cGenom = cGenom_Mother;}
//    if (rnd.nextInt(100) == 0) Elemination(m_cGenom);
    m_iFitness = InterpreteGenom();
  }
/***************************************************/
/************* CIndividual - Elemination1 **********/
/***************************************************/
  public void Elemination1(ObjectList cGenom_Mother)
  {
    m_cGenom = cGenom_Mother;
    m_cGenom.delete(rnd.nextInt(m_cGenom.getCount()));
  }
/***************************************************/
/************** CIndividual - Mutation1 ************/
/***************************************************/
  public void Mutation1(ObjectList cGenom_Mother) {
    m_cGenom = cGenom_Mother;
    m_cGenom.exchange(rnd.nextInt(m_cGenom.getCount()), rnd.nextInt(m_cGenom.getCount()));
  }
/***************************************************/
/********** CIndividual - Crossproduct_PMX *********/
/***************************************************/
  public void CrossOver_PMX(ObjectList cGenom_Father, ObjectList cGenom_Mother) {
    int iStartIndex, iEndIndex;
    int i, iIndex;
    ObjectList cTsTListeM = new ObjectList();
    ObjectList cTsTListeF = new ObjectList();
    iStartIndex = rnd.nextInt(cGenom_Father.getCount());
    iEndIndex   = rnd.nextInt(cGenom_Father.getCount() - iStartIndex) + iStartIndex;
    for (i = iStartIndex; i < iEndIndex; i++)  cTsTListeF.add(cGenom_Father.getItem(i));
    for (i = 0; i < cGenom_Mother.getCount(); i++)
      if (cTsTListeF.indexOf(cGenom_Mother.getItem(i)) == -1)
        cTsTListeM.add(cGenom_Mother.getItem(i));
    iIndex = 0;
    for (i = 0; i < iStartIndex; i++) { m_cGenom.add(cTsTListeM.getItem(iIndex)); iIndex++; }
    for (i = iStartIndex; i < iEndIndex; i++) m_cGenom .add(cTsTListeF.getItem(i- iStartIndex));
    for (i = iEndIndex; i < cGenom_Father.getCount(); i++) { m_cGenom.add(cTsTListeM.getItem(iIndex)); iIndex++; }
    cTsTListeF = null;
    cTsTListeM = null;
//    if (rnd.nextBoolean()) m_cGenom.exchange(rnd.nextInt(m_cGenom.getCount()), rnd.nextInt(m_cGenom.getCount()));
  }
/***************************************************/
/*********** CIndividual - Crossproduct_OX *********/
/***************************************************/
  public void CrossOver_OX(ObjectList cGenom_Father, ObjectList cGenom_Mother) {
    int i, iIndex;
    ObjectList cTsTListeS = cGenom_Father;//new ObjectList();
    ObjectList cTsTListeO = cGenom_Mother;//new ObjectList();
    ObjectList cTmpList;
/*    for (i = 0; i < cGenom_Father.getCount(); i++) {
      cTsTListeS.add(cGenom_Mother.getItem(i));
      cTsTListeO.add(cGenom_Father.getItem(i));
    }*/
    iIndex = 0;
    while (m_cGenom.getCount() < cGenom_Father.getCount()) {
      if (rnd.nextInt(4) == 0){
        iIndex = cTsTListeO.indexOf(cTsTListeS.getItem(iIndex));
        cTmpList = cTsTListeO;
        cTsTListeO = cTsTListeS;
        cTsTListeS = cTmpList;
      }
      m_cGenom.add(cTsTListeS.getItem(iIndex));
      if (m_cGenom.getCount() == cGenom_Father.getCount()) break;
      cTsTListeO.setItem(cTsTListeO.indexOf(cTsTListeS.getItem(iIndex)), null);
      cTsTListeS.setItem(iIndex, null);
      do {
        iIndex++;
        if (iIndex >= cTsTListeS.getCount()) iIndex = 0;
      }
      while (cTsTListeS.getItem(iIndex) == null);
    }
    cTsTListeS = null;
    cTsTListeO = null;
//    if (rnd.nextBoolean()) m_cGenom.exchange(rnd.nextInt(m_cGenom.getCount()), rnd.nextInt(m_cGenom.getCount()));
  }
/***************************************************/
/********** CIndividual - Crossproduct_ERX *********/
/***************************************************/
  public void CrossOver_ERX(ObjectList cGenom_Father, ObjectList cGenom_Mother)
  {
    int i, iIndex;
    ObjectList cNewCity = new ObjectList();
    ObjectList cKantenListe = KantenListe((ObjectList) cGenom_Father, (ObjectList) cGenom_Mother);
    iIndex = 0; //rnd.nextInt(cKantenListe.getCount());
    ObjectList cAktKante;
    ObjectList cTstKante;
    CGen  cAktGen;
    while (true) {
      // hinzufuegen eines Gens
      cAktKante = (ObjectList) cKantenListe.getItem(iIndex);
      cAktGen = (CGen) cAktKante.getLast();
      m_cGenom.add(cAktGen);
      // auswahl einer neuen Stadt
      cNewCity.clear();
      for (i = 0; i < cKantenListe.getCount(); i++) {
        cTstKante = (ObjectList) cKantenListe.getItem(i);
        if (cTstKante == cAktKante) continue;
        if (cAktKante.indexOf(cTstKante.getLast()) != - 1) {
          if (cNewCity.getCount() == 0) { cNewCity.add(cTstKante); continue;}
          if (((ObjectList) (cNewCity.getItem(0))).getCount() < cTstKante.getCount()) continue;
          if (((ObjectList) (cNewCity.getItem(0))).getCount() == cTstKante.getCount()) { cNewCity.add(cTstKante); continue; }
          cNewCity.clear();
          cNewCity.add(cTstKante);
        }
      }
      // alle vorkommen von der aktuellen Stadt aus der KantenListe entfernen + aktuelle Kante
      cKantenListe.remove(cAktKante);
      cAktKante = null;
      if (cKantenListe.getCount() == 0) break;
      if (cNewCity.getCount() == 0)
        iIndex = rnd.nextInt(cKantenListe.getCount());
        else
          iIndex = cKantenListe.indexOf(cNewCity.getItem(rnd.nextInt(cNewCity.getCount())));
      for (i = 0; i < cKantenListe.getCount(); i++) {
        cTstKante = (ObjectList) cKantenListe.getItem(i);
        cTstKante.remove(cAktGen);
      }
    }
    cNewCity = null;
    cKantenListe = null;
  }

  //------------------------------------------------------
//  http://www.fh-augsburg.de/informatik/projekte/emiel/GenAlg/ERX.html
//  http://www.ads.tuwien.ac.at/~guenther/TravSale/ga.html

/***************************************************/
/*************** GenerateRandomIndiv ***************/
/***************************************************/
    public CIndividual(ObjectList cCornList)
    {
      GenerateRandomIndiv(cCornList);
    }
    /** erstellt ein Individuum einem zufaelligen Genom */
    void GenerateRandomIndiv(ObjectList cCornList){
      ObjectList cList = new ObjectList();
      cCornList.CloneTo(cList);
      int iRnd;
      for (int i = 0; i < cCornList.getCount(); i++)
      {
        iRnd = rnd.nextInt(cList.getCount());
        m_cGenom.add(cList.getItem(iRnd));
        cList.delete(iRnd);
      }
      m_iFitness = InterpreteGenom();
    }
/***************************************************/
/***************** InterpreteGenom *****************/
/***************************************************/

    /** brechent den Punktzahl, die das Individuum erreichen wuerde */
    int InterpreteGenom()
    {
      m_iGenomLength = m_cGenom.getCount();
      return GetCollectCosts(m_cGenom);;
    }

/***************************************************/
/*********************** Go ************************/
/***************************************************/
    // Sammelt die Koerner anhand des aktuellen Genoms
    void go()
    {
      int iGewinn;
//      do { iGewinn = sort(m_cGenom); } while (iGewinn > 0);
//      ClearList(m_cGenom);
      int i;
      CGen cGen;
      m_iFitness = InterpreteGenom();
      int iAufwandDirekt = 0;
      int iAufwandInDirekt = 0;
      for (i = 0; i < m_iGenomLength;)
      {
        // ermitteln des Gens
        cGen = (CGen) m_cGenom.getItem(i);
        // regagieren auf Gen: Corn
        if (m_cD.m_cpFelder.Access(cGen.m_iPosX, cGen.m_iPosY).m_iAnz_Koerner <= 0) { i++; continue;}
        // gehe zum Kornfeld
        iAufwandDirekt   = cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, cGen.m_iPosX, cGen.m_iPosY);
        // gehe bei bedarf nach Hause
        if (m_cHamster.getCarriedCorn() > 0)  {
          iAufwandInDirekt = cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY)
                           + cPathfinder.go_fast(m_cD.m_cpFelder, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cGen.m_iPosX, cGen.m_iPosY);
          if (iAufwandDirekt == iAufwandInDirekt)   {
            CHamsterMoveTo.run(m_cHamster, m_cD, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
          }
        }
        CHamsterMoveTo.run(m_cHamster, m_cD, cGen.m_iPosX, cGen.m_iPosY);
        // nehme Koerner auf
        m_cD.m_cpFelder.Access(m_cD.m_iPosX, m_cD.m_iPosY).m_iAnz_Koerner -= (m_cHamster.take(Constants.CORNCARRY_MAX));
        if (m_cD.m_cpFelder.Access(m_cD.m_iPosX, m_cD.m_iPosY).m_iAnz_Koerner == 0)  i++;
        if (Constants.CORNCARRY_MAX == m_cHamster.getCarriedCorn())
          CHamsterMoveTo.run(m_cHamster, m_cD, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);          // wenn voll, nach Hause gehen
      }
    }

  }
}

