
//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
import java.util.Random;
/**
  Hauptalgorithmus zum aufdecken des Labyribths
*/
public class CHamsterScout {
  Hamster2 m_cHamster;
  CDightyData m_cD;
  CXY m_cSeachCenter;
  static final int c_iMaxPoints = Constants.CORNCARRY_MAX * Constants.POINTS_CORN;
  CPathFinder_A cPathfinder = new CPathFinder_A();
  // statische Variablen fuer die FindNextFeld-Rotiene
  protected static ObjectList m_cFeldListe  = new ObjectList();
  protected static Integer [] m_cFeldAbbInt; // bildet X - Y Koordinaten in Z Koordinaten ab und generiert eine Liste davon, dient ausschlieslich der Optimierung
  // bildet 2D Koordinaten in 1D ab
  protected int XYtoZ (int iX, int iY) { return (iX << 7) +  iY; }
  // bildet die 1D Koordinate zurueck in 2D ab (X-Wert)
  protected int ZtoX (int iZ) { return iZ >> 7;}
  // bildet die 1D Koordinate zurueck in 2D ab (Y-Wert)
  protected int ZtoY (int iZ) { return iZ & 127;}
  protected int BestimmeDenUnknownWert(int iPosX, int iPosY, int iRadius){
    int iResult = 0;
    for (int k = 1; k <= iRadius; k++){
      int iDir = 0;
      int iX = iPosX + k * CLabyrinth_ly0.c_iMoveX[0];
      int iY = iPosY + k * CLabyrinth_ly0.c_iMoveY[0];
      iDir = CLabyrinth_ly0.Reflect((iDir - 1 + CLabyrinth_ly0.c_iMovepossibilities) % CLabyrinth_ly0.c_iMovepossibilities);
      for (int i = 0; i < CLabyrinth_ly0.c_iMovepossibilities; i++)
      {
        for (int j = 0; j < iRadius; j++) {
          iX += CLabyrinth_ly0.c_iMoveX[iDir];
          iY += CLabyrinth_ly0.c_iMoveY[iDir];
          if ((iX < 0) || (iY < 0) || (CLabyrinth_ly0.Transform_KoordX(iX) >= CLabyrinth_ly0.c_iMaxSizeX) ||
             (CLabyrinth_ly0.Transform_KoordY(iY) >= CLabyrinth_ly0.c_iMaxSizeY)) continue; // <-- ausserhalb des Arrays
          CFeld cFeld = m_cD.m_cpFelder.Access(iX, iY);
          if (!cFeld.m_bBekanntheitsgrad) iResult++;
        }
     }
    }
    return iResult;
  }
  protected boolean FindNextFeld(CXY cFeld)
  {
    m_cFeldListe.clear(); // loeschen der Liste der erreichbaren Felder
    m_cFeldListe.add(m_cFeldAbbInt[XYtoZ(m_cD.m_iPosX, m_cD.m_iPosY)]); // hinzufuegen des Startfeldes
//    System.out.println("X: " + m_cD.m_iPosX + " Y: " +  m_cD.m_iPosY +  " O: " + XYtoZ(m_cD.m_iPosX, m_cD.m_iPosY));
    int iFeldCount_AktGeneration = 1; // speichert, wieviele Felder pro Generation neu hinzukommen
    int iFeldCount;// Tempvariable, Speichert den Index des letzten Feldes in der m_cFeldListe der alten Generatiion
    int iFeldBorderCount; // Speichert, wieweit eine Schleife Zaehlen darf
    int i, j, k;   // Schleifenvariablen
    int iPosValue; // speichert die Position eines Feldes in nur einem Integer (1D)
    int iPosX;     // speichert die X-Position eines Feldes (2D)
    int iPosY;     // speichert die Y-Position eines Feldes (2D)
    int idX;       // weitere Position
    int idY;       // weitere Position
    int iFeldPosValue;  // speichert die Position eines Feldes in nur einem Integer
    int iUnbekanntCount = 1000;
    boolean bNeighbourExists;  // speichert, ob ein Nachbar zu einem Feld in der Liste gefunden wurde
    boolean bNewFeldToScoutFound = false; // speichert, ob ein Feld zum scouten gefunden wurde
    boolean bAllFeldsCanReached;  // speichert, ob alle Felder um das aktuelle Feld erreicht werden koennen
    boolean bTookALock;           // speichert, ob schon ein lick auf ein Feld geworfen wurde
    // bestimmt die Anzahl von unbekannten Feldern um eine Position bei angegebenen Radius
    // suche, solange es Felder zum erreichen giebt
    while (iFeldCount_AktGeneration > 0)
    {
      iFeldCount = m_cFeldListe.getCount() - iFeldCount_AktGeneration;
      iFeldCount_AktGeneration = 0;
      iFeldBorderCount = m_cFeldListe.getCount();
      if (iFeldCount == iFeldBorderCount) return false;
      // Schleife, die alle aeusseren Felder entlang geht, und Nachtbarn, die noch nicht eingefuegt sind, zur Liste hinzufuegt
      for (i = iFeldCount; i < iFeldBorderCount; i++)
      {
        // Schleife, die um ein Feld herummscannt
        for (j = 0; j < CLabyrinth_ly0.c_iMovepossibilities; j++)
        {
           // ermitteln der Position der Nachtbarn
           iFeldPosValue = ((Integer) m_cFeldListe.getItem(i)).intValue();
           iPosValue = iFeldPosValue + XYtoZ(CLabyrinth_ly0.c_iMoveX[j], CLabyrinth_ly0.c_iMoveY[j]);
           iPosX = ZtoX(iPosValue); iPosY = ZtoY(iPosValue);
           // ueberpruefen, on das Feld ueberhaupt erreicht werden kann
           if (m_cD.m_cpFelder.canMove_known(ZtoX(iFeldPosValue), ZtoY(iFeldPosValue), j) == -1) continue; // nicht erreichbar
           // suchen in der Liste, ob es den Nachbarn schon in der Liste giebt
           bNeighbourExists = false;
           for (k = 0; k < m_cFeldListe.getCount(); k++) if (((Integer) m_cFeldListe.getItem(k)).intValue() == iPosValue) bNeighbourExists = true;
           if (bNeighbourExists) continue; // wenn Nachbar schon vorhanden ist, dann fuege ihn nicht mehr zur Liste hinzu
           // hinzufuegen des Feldes
           m_cFeldListe.add(m_cFeldAbbInt[iPosValue]);
           iFeldCount_AktGeneration++;
          // -- Test auf Anlauffaehigkeit --
           // testen, ob das Feld schon bekannt ist, dann soll es nicht angelaufen werden
           CFeld cBewerber = m_cD.m_cpFelder.Access(iPosX, iPosY);
           if (cBewerber.m_bBekanntheitsgrad) continue;
           // falls das Feld zuweit Weg vom Bau ist, ist es keine alternative und wird ignoriert
           if (cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, iPosX, iPosY) +
                 cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY) >=
                    Constants.POINTS_CORN * Constants.CORNCARRY_MAX) { continue; }
           // testen, ob man das Feld nicht ignorieren koennte, da alle Felder um ihn herum bekannt sind
           bAllFeldsCanReached = true;
           bTookALock = false;
           for (k = 0; k < CLabyrinth_ly0.c_iMovepossibilities; k++)
           {    // test, ob alle Nachtbarn erreicht werden koennen, wenn nicht, dann muss das Feld beducht werden
              idX = iPosX + CLabyrinth_ly0.c_iMoveX[k];
              idY = iPosY + CLabyrinth_ly0.c_iMoveY[k];
              if (cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, idX, idY) == 0)
              {
                if ((m_cD.m_iPosX != idX) || (m_cD.m_iPosY != idY)) { bAllFeldsCanReached = false; break;}
              } else// schauen, ob der Inhalt ueberprueft werden konnte (ein Blick muss das Feld schon bekommen haben, sonst waere es nicht erreichbar) ;
              {
                 int iPass = m_cD.m_cpFelder.Access(iPosX, iPosY).m_iRahmen[k] & Constants.WALLMASK;
                 if ((iPass == 0) || (iPass == Constants.CLIFFUP))
                   bTookALock = true; // der Inhalt des Feldes ist bekannt , es muss vielleicht nicht besucht werden
              }
           }
           // wenn nicht schon ein besseres Feld in der Evolution gefunden worde, dann setze dieses
           if ((!bTookALock) || (!bAllFeldsCanReached) || (m_cD.m_cpFelder.Access(iPosX, iPosY).m_iAnz_Koerner ==  CLabyrinth_ly0.c_iUnexploredCornCount))
           {
             // falls das erste Feld, setze es einfach
             if (!bNewFeldToScoutFound)
             {
               cFeld.m_iX = iPosX;
               cFeld.m_iY = iPosY;
               bNewFeldToScoutFound = true;
               iUnbekanntCount = BestimmeDenUnknownWert(iPosX, iPosY, 4);
             } else
             // vergleiche das schon vorhandene Feld mit dem neuen ermittelten
             {
               CFeld cChoosen = m_cD.m_cpFelder.Access(cFeld.m_iX, cFeld.m_iY);
               // das hoehere wird bevorzugt
               if (cChoosen.m_iHoehe > cBewerber.m_iHoehe) continue;
               // das Feld mit weniger Unbekanntem bevorzugen
               int iUnbekanntCount_new = BestimmeDenUnknownWert(iPosX, iPosY, 4);
//               if (iUnbekanntCount_new > iUnbekanntCount) continue;
               // das Feld, das weiter vom Bau weg ist bevorzugen
               if (cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, cFeld.m_iX, cFeld.m_iY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY) +
                     cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, cFeld.m_iX, cFeld.m_iY) >
                       cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY) +
                         cPathfinder.go_fast(m_cD.m_cpFelder_Optimal, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, iPosX, iPosY)) {continue;}
               cFeld.m_iX = ZtoX(iPosValue);
               cFeld.m_iY = ZtoY(iPosValue);
               iUnbekanntCount = iUnbekanntCount_new;
             }
           }// else  m_cD.m_cpFelder.Access(iPosX, iPosY).m_bBekanntheitsgrad = true;
        }
      }
      if (bNewFeldToScoutFound)
      {
//        cDSaver.Push(m_cD.m_iPosX, m_cD.m_iPosX, cFeld.m_iX, cFeld.m_iY);
        return true;
      }
    }
    return false;
  }

  public CHamsterScout(Hamster2 cHamster, CDightyData cD)
  {
    m_cHamster = cHamster;
    m_cD = cD;
    m_cFeldListe.setCapacity((CLabyrinth_ly0.c_iMaxSizeX - 2) * (CLabyrinth_ly0.c_iMaxSizeY - 2));
    m_cFeldAbbInt = new Integer[128 * 128];
    for (int i = 0; i < 128 * 128; i++)
      m_cFeldAbbInt[i] = new Integer(i);
  }
/***************************************************/
/******************* CreateCornList ****************/
/***************************************************/
  /** erstellt eine Lister der Felder, die Koerner enthalten */
  ObjectList CreateCornList()
  {
    ObjectList cList = new ObjectList();
    // durchgehen aller Felder, um die gesuchten Felder zu finden
    int iRadius = 1;
    boolean bMaxRadiusReached = false;
    CXY cGen;
    while ((!bMaxRadiusReached) && (iRadius < CLabyrinth_ly0.c_iMaxSizeX + CLabyrinth_ly0.c_iMaxSizeY)) {
      bMaxRadiusReached = true;
      int iDir = 0;
      int iX = CLabyrinth_ly0.c_iStartX + iRadius * CLabyrinth_ly0.c_iMoveX[iDir];
      int iY = CLabyrinth_ly0.c_iStartY + iRadius * CLabyrinth_ly0.c_iMoveY[iDir];
      iDir = CLabyrinth_ly0.Reflect((iDir - 1 + CLabyrinth_ly0.c_iMovepossibilities) % CLabyrinth_ly0.c_iMovepossibilities);
      for (int i = 0; i < CLabyrinth_ly0.c_iMovepossibilities; i++)  {
        for (int j = 0; j < iRadius; j++)  {
          iX += CLabyrinth_ly0.c_iMoveX[iDir];
          iY += CLabyrinth_ly0.c_iMoveY[iDir];
          if ((iX < 0) || (iY < 0) || (CLabyrinth_ly0.Transform_KoordX(iX) >= CLabyrinth_ly0.c_iMaxSizeX) ||
             (CLabyrinth_ly0.Transform_KoordY(iY) >= CLabyrinth_ly0.c_iMaxSizeY)) continue; // <-- ausserhalb des Arrays
          bMaxRadiusReached = false;
          if (m_cD.m_cpFelder.Access(iX, iY).m_iAnz_Koerner > 0)  { cGen = new CXY(iX, iY); cList.add(cGen); }
        }
        iDir = (iDir + CLabyrinth_ly0.c_iMovepossibilities + 1) % CLabyrinth_ly0.c_iMovepossibilities;
      }
      iRadius++;
    }
    return cList;
  }
/***************************************************/
/*********************** MoveTo ********************/
/***************************************************/
  protected void MoveTo(CXY cXY)
  {

    ObjectList cKornListe = CreateCornList();
    // giebt es zuviele Kornfelder?
    if (cKornListe.getCount() > 250){
      if (cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY) > 0){
        CFeld cFeld = m_cD.Access();
        cFeld.m_iAnz_Koerner -= m_cHamster.take(Constants.CORNCARRY_MAX);
        if (m_cHamster.getCarriedCorn() == Constants.CORNCARRY_MAX) {
          CHamsterMoveTo.run(m_cHamster, m_cD, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY, false); return;
        }
      }
    }else // ist das Maul voll?
    if (m_cHamster.getCarriedCorn() == Constants.CORNCARRY_MAX) {
      CHamsterMoveTo.run(m_cHamster, m_cD, cXY.m_iX, cXY.m_iY, false);
      return;
    }
    // ist die maximale Rekursionstiefe erreicht worden (Buffix)
    if (m_iRecDeep > 250){
      CHamsterMoveTo.run(m_cHamster, m_cD, cXY.m_iX, cXY.m_iY, false);
      return;
    }
//    System.out.println(" X: " + cXY.m_iX + " Y: " + cXY.m_iY);
    int iAufwand_AktPosToKorn, iAufWandAToB, iAufwand_AktKornToHome, iAufWand_AktKornToB;
    CXY cKorn;
    CPath cPath;
    int iPosX, iPosY, iAufwand, iMinAufwand, iUmweg;
    CXY cBestFeld = new CXY(0, 0), cGesammtBestFeld = new CXY(0, 0);
    int iBestGoHomePosition = 0, iGewinn;
    iAufWandAToB = cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, cXY.m_iX, cXY.m_iY);
    CXY cBestKorn = new CXY();
    int iBestKornGewinn = -1;
//    System.out.println("iAufWandAToB " + iAufWandAToB);
    for (int i = 0; i < cKornListe.getCount(); i++) {
      cKorn = (CXY) cKornListe.getItem(i);
      iPosX = cKorn.m_iX;
      iPosY = cKorn.m_iY;
      iAufwand_AktPosToKorn = cPathfinder.go_fast(m_cD.m_cpFelder, m_cD.m_iPosX, m_cD.m_iPosY, cKorn.m_iX, cKorn.m_iY);
      if (iAufwand_AktPosToKorn == 0)
        if ((iPosX != m_cD.m_iPosX) || (iPosY != m_cD.m_iPosY)) continue;
      if (iAufwand_AktPosToKorn - 1 > iAufWandAToB) continue;
      iAufwand_AktKornToHome = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
      cPath = cPathfinder.go(m_cD.m_cpFelder, iPosX, iPosY, cXY.m_iX, cXY.m_iY);
      iAufWand_AktKornToB = cPath.size();
      // bestimme den optimalen Weg nach Hause von K (Korn) nach B
      iUmweg = iAufwand_AktPosToKorn + iAufWand_AktKornToB - iAufWandAToB;
      iMinAufwand = 100000;
//      if ( ((float) (((float) (iAufWandAToB)) / ((float) (2)))) < iAufwand_AktPosToKorn) continue;
//       System.out.println("iAufWand_AktKornToB    " + iAufWand_AktKornToB);
//       System.out.println("iAufwand_AktPosToKorn  " + iAufwand_AktPosToKorn);
//       System.out.println("iAufwand_AktKornToHome " + iAufWand_AktKornToB);
      while (cPath.size() != 0)  {
        int iDir = ((Integer) (cPath.pop())).intValue();
        iPosX += CLabyrinth_ly0.c_iMoveX[iDir];
        iPosY += CLabyrinth_ly0.c_iMoveY[iDir];
        iAufwand = cPathfinder.go_fast(m_cD.m_cpFelder, iPosX, iPosY, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
        if (iAufwand < iMinAufwand) {
          if (iAufwand == 0)
            if ((iPosX != CLabyrinth_ly0.c_iStartX) && (iPosY != CLabyrinth_ly0.c_iStartY)) continue;
          iMinAufwand = iAufwand;
          cBestFeld.m_iX = iPosX;
          cBestFeld.m_iY = iPosY;
//          System.out.println("iAufwand " + iAufwand);
        }
      }
      if ((cBestFeld.m_iX == 0) && (cBestFeld.m_iY == 0)) {
/*        if (iAufwand_AktKornToHome == 0) {
          cBestFeld.m_iX = cKorn.m_iX;
          cBestFeld.m_iY = cKorn.m_iY;
          iMinAufwand = 0;
        } else*/
          continue;
      }
      iGewinn = iAufwand_AktKornToHome - iMinAufwand - iUmweg;
      if ((iBestKornGewinn < iGewinn)/* || ((iAufwand_AktKornToHome == 0) && (iBestKornGewinn == -1))*/ ){
        iBestKornGewinn = iGewinn;
        cBestKorn.m_iX = cKorn.m_iX;
        cBestKorn.m_iY = cKorn.m_iY;
        cGesammtBestFeld.m_iX = cBestFeld.m_iX;
        cGesammtBestFeld.m_iY = cBestFeld.m_iY;
      }
    }
    if (iBestKornGewinn >= 0) {
      CHamsterMoveTo.run(m_cHamster, m_cD, cBestKorn.m_iX, cBestKorn.m_iY, false);
      CFeld cFeld = m_cD.m_cpFelder.Access(cBestKorn.m_iX, cBestKorn.m_iY);
      cFeld.m_iAnz_Koerner -= m_cHamster.take(Constants.CORNCARRY_MAX);
      if ((cGesammtBestFeld.m_iX != m_cD.m_iPosX) || (cGesammtBestFeld.m_iY != m_cD.m_iPosY)) {
        m_iRecDeep++;
        MoveTo(cGesammtBestFeld);
        cFeld = m_cD.m_cpFelder.Access(cGesammtBestFeld.m_iX, cGesammtBestFeld.m_iY);
        cFeld.m_iAnz_Koerner += m_cHamster.dropHere(Constants.CORNCARRY_MAX);
      }
//      MoveTo(cXY);
     return;
   } else {
      CHamsterMoveTo.run(m_cHamster, m_cD, cXY.m_iX, cXY.m_iY, false);
   }
  }
  /** Einsprungspunkt, um die Suche zu starten  */
  static int m_iRecDeep;
  public void run() {
    CHamsterLockAround.run(m_cHamster, m_cD); // einen ersten Blick auf die Umgebung werfen
    // Hauptschleife
    CXY cXY = new CXY(20, 20);
    m_cSeachCenter = new CXY(m_cD.m_iPosX, m_cD.m_iPosY); // Mittelpunkt der Suche
    boolean bDirection = false;
    CPathFinder_A cPathfinder = new CPathFinder_A();
    while (FindNextFeld(cXY))
    {
      m_iRecDeep = 0;
      MoveTo(cXY);
    }
  }
}
