package dighty;
import algds.c2002.Constants;

public class CLabyrinth_ly0 {

  public static final int c_iMaxSizeX = Constants.MAZELENGTH_MAX * 2 + 2;  // maximale Ausdehnung des Labyrinths in X-Richtung
  public static final int c_iMaxSizeY = Constants.MAZELENGTH_MAX * 2 + 2;  // maximale Ausdehnung des Labyrinths in Y-Richtung
  public static final int c_iMovepossibilities = 6;                        // Anzahl er Bewegungsrichtungen
  public static final int   c_iMoveX[] = { 0,  1,  1,  0, -1, -1} ;          // Bewegungskonstanten
  public static final int c_iMoveY[] = {-2, -1,  1,  2,  1, -1} ;          // Bewegungskonstanten
  public static final int c_iStartX = c_iMaxSizeX / 2;                     // Startposition X in Spielkoordinaten
  public static final int c_iStartY = c_iMaxSizeY;                         // Startposition Y in Spielkoordinaten
  public static final int c_iUnexploredCornCount = -1;                     // Feld noch nicht besucht, aber schon angeschaut
  public static final int c_iUnexploreCornData = -2;                       // Feld noch unbekannt
  public static final int c_iStartHoehe = 0;                               // Hoehe, die jedes unbekannte Feld + Startfeld hat
  public static final int c_iScoutCollectFactor = 6;
  public static final int WALLMASK = -2147483634;                          // zur Optimierungszwecken benutzt
  protected boolean m_bBuffering = false;                                  // speichert, ob die Wegfindrotiene den Distancebuffer nutzen soll
  public boolean m_bIsExtendedLyb = false;
  CFeld [][] m_pcFeld;
  /** Hauptkonstruktor */
  protected CLabyrinth_ly0(boolean bBuffering)
  {
    m_pcFeld = new CFeld[c_iMaxSizeX][c_iMaxSizeY];
    for (int x = 0; x < c_iMaxSizeX; x++) for (int y = 0; y < c_iMaxSizeY; y++) m_pcFeld[x][y] = new CFeld(bBuffering);
    DistanceBuffering(false);
  }
  /**   Standardkonstruktor, erstellt ein "unbekanntes" Labyrinth, mit Distancebuffer */
  public CLabyrinth_ly0() { this(true);  }
  /** dieser Konstruktor erstellt ein "bekanntes" und lehres Labyrinth, es wird zur Optimirung und zur Entscheidungsfindung beim Scouten benutzt*/
  public CLabyrinth_ly0(int iOptimal) {
   this(false);
   for (int x = 0; x < c_iMaxSizeX; x++)
     for (int y = 0; y < c_iMaxSizeY; y++)
       for (int z = 0; z < c_iMovepossibilities; z++)
         // schauen, ob nicht der Rand berechnet wird, ist dann setze Wand, sonst Freiraum
         {
          m_pcFeld[x][y].m_iRahmen[z]  =
              ((Transform_KoordX(Transform_KoordXRet(x) + c_iMoveX[z]) <= 1) ||
               (Transform_KoordY(Transform_KoordYRet(y) + c_iMoveY[z]) <= 1) ||
               (Transform_KoordX(Transform_KoordXRet(x) + c_iMoveX[z]) >= c_iMaxSizeX - 2) ||
               (Transform_KoordY(Transform_KoordYRet(y) + c_iMoveY[z]) >= c_iMaxSizeY - 2)) ? Constants.WALL : 0;
          }
  }
  /**    rechnet eine die im Spiel benutzten Koordinate X in eine fuer ein Array ertraeglichen Wert um */
  static public int Transform_KoordX(int iX)  {   return iX; }
  /**    rechnet eine die im Spiel benutzten Koordinate Y in eine fuer ein Array ertraeglichen Wert um  */
  static public int Transform_KoordY(int iY)  {   return iY / 2;  }
  /**    rechnet ein arrayertraeglichen Wert in die ensprechende SpielKoordinate(X) um  */
  static public int Transform_KoordXRet(int iX)  {   return iX; }
  /**    rechnet ein arrayertraeglichen Wert in die ensprechende SpielKoordinate(Y) um  */
  static public int Transform_KoordYRet(int iY)  {   return iY * 2;  }
  /**    spiegelt die Richtungsnummer, und giebt den neuen Wert zurueck */
  static public int Reflect(int iD) { return (iD + c_iMovepossibilities / 2) % c_iMovepossibilities; }

  /**    convertiert DeltaX und DeltaY in eine MovementNr  */
  public static int TransformDXDYtoNr(int iDX, int iDY)
  {
    for (int i = 0; i < c_iMovepossibilities; i++) if ((iDX == c_iMoveX[i]) && (iDY == c_iMoveY[i])) return i;
    return c_iMovepossibilities; //<-- wenn das eintrifft soll eine OutOfBoundExeption ausgeloest werden, die Parameter wurden falsch angegeben
  }
  /**
    zugriff auf ein einzelnes Feld, da aber eine andere Koordinatenart benutzt wird, muss
    sie erst umgerechnent werden */
  public CFeld Access(int iX, int iY) {
    return m_pcFeld[Transform_KoordX(iX)][Transform_KoordY(iY)];
  }
  /**
    ermittelt, ob man sich von einem bestimmten Feld auf ein anderes bewegen kann, Feld muss bekannt sein
    Rueckgabe: der Auwand derzeit immer 1, wenn moeglich, sonst - 1
  */
  public int canMove_known(int iX, int iY, int iMoveNr)
  {
    int iPass = Access(iX, iY).m_iRahmen[iMoveNr] & WALLMASK;
    return ((iPass > c_iUnexploreCornData) && (iPass != Constants.CLIFFUP) && (iPass != Constants.WALL)) ? 1 : -1;
  }
  /**
    bestimmt den minimalen Abstand zwischen 2 Felder, d.h. wieviele Schritte man braechte,
    vom ersten Feld auf das zweite zu gelangen
  */
  static public int MinDistance(int iX1, int iY1, int iX2, int iY2)
  {
    int dx = Math.abs(iX1 - iX2);
    int dy = Math.abs(iY1 - iY2);
    return 1;//dx <= dy ? (dx + dy) / 2 : dx;
  }
  /* ------------------------------- Distancebufferingrotienen --------------------------
  /** Schaltet das Buffering an / ab*/
  public void DistanceBuffering(boolean bFlag)
  {
    if (bFlag) {  m_bBuffering = true; ClearDistanceBuffer(); }
    else m_bBuffering = false;
  }
  /** Loescht die Distancebuffers */
  public void ClearDistanceBuffer()
  {
    int x, y;
    for (x = 0; x < c_iMaxSizeX; x++)
      for (y = 0; y < c_iMaxSizeY; y++) m_pcFeld[x][y].ClearDistanceBuffer();
  }

}