//Titel:        Dighty-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
import java.util.LinkedList;
import java.util.Arrays;

/**
  implementiert die Pfadfindrotiene A*, ein relativ effizenter, und immer effektiver
  und rekursiver Algorithmus
*/
public class CPathFinder_A extends CPathFinder{
  CLinkedList m_cPfaderweiterer; // speichert die Liste der zu ueberpruefenden Felder,
                            //    leider ist keine sortierungsrotine (Ansatz wuerde reichen)
                            //    implementiert (da ist die STL doch viel besser ;-) )
  CSearchFeld [][] m_cpFelds;
  boolean [][] m_bpFeldReady;
  public CPathFinder_A() {
    m_cPfaderweiterer = new CLinkedList();
    m_cpFelds = new CSearchFeld [m_cpFelder.c_iMaxSizeX][m_cpFelder.c_iMaxSizeY];
    for (int x = 0; x < m_cpFelder.c_iMaxSizeX; x++) for (int y = 0; y < m_cpFelder.c_iMaxSizeY; y++) m_cpFelds[x][y] = new CSearchFeld();
    m_bpFeldReady = new boolean[m_cpFelder.c_iMaxSizeX][m_cpFelder.c_iMaxSizeY];
    for (int x = 0; x < m_cpFelder.c_iMaxSizeX; x++) for (int y = 0; y < m_cpFelder.c_iMaxSizeY; y++) m_bpFeldReady[x][y] = false;
  }
  /** startet die Suche, Rueckgabe des Auwandes */
  public int go_fast()
  {
    // Init
    int iDistance;
    // ueberpruefen, ob Buffering eingeschaltet ist, und wenn ja, ob nicht der Wert schon gepuffert ist
    //    , wenn beides ja, gieb gepufferten Wert zurueck, sonst berechne
    if (m_cpFelder.m_bBuffering){
      if ((iDistance = m_cpFelder.Access(m_iStartX, m_iStartY).GetBufItem( CLabyrinth_ly0.Transform_KoordX(m_iEndX), CLabyrinth_ly0.Transform_KoordY(m_iEndY))) != 0) return iDistance; // Rueckgabe des gespeicherten Wertes
    }
    // das Statusarray loeschen
    int y;
    for (int x = 0; x < m_cpFelder.c_iMaxSizeX; x++) Arrays.fill(m_bpFeldReady[x], false);
    m_cPfaderweiterer.clear();// loescht die zu bearbeitende Liste
    CSearchFeld cStartFeld = new CSearchFeld(m_iStartX, m_iStartY, 0, 0);
    insert(cStartFeld); // fuegt das Startfeld ein
    m_cpFelds[CLabyrinth_ly0.Transform_KoordX(m_iStartX)][CLabyrinth_ly0.Transform_KoordY(m_iStartY)] = cStartFeld;
    m_bpFeldReady[CLabyrinth_ly0.Transform_KoordX(m_iStartX)][CLabyrinth_ly0.Transform_KoordY(m_iStartY)] = true;
    // go
    try { if (!run()) return 0; } catch (ArrayIndexOutOfBoundsException e) {  System.out.println(" ArrayIndexOutOfBoundExeption captured!! - SX=" + Integer.toString(m_iStartX) + " SY=" + Integer.toString(m_iStartY) + " EX=" + Integer.toString(m_iEndX) + " EX = " + Integer.toString(m_iEndY)); return 0;  }
    iDistance = ((CSearchFeld) (m_cPfaderweiterer.removeFirst())).m_iDistance;
    // Puffern der Entfernung, fals erwuenscht
    if (m_cpFelder.m_bBuffering) m_cpFelder.Access(m_iStartX, m_iStartY).SetBufItem(CLabyrinth_ly0.Transform_KoordX(m_iEndX),CLabyrinth_ly0.Transform_KoordY(m_iEndY), (char) iDistance);
    // Rueckgabe der Entfernung
    return iDistance;
  }
  /**  startet die Suche, Rueckgabe der Weg */
  public CPath go(boolean bLog)
  {
    if (bLog){  System.out.print(Integer.toString(m_iStartX) + " <- X: S, " ); System.out.print(Integer.toString(m_iStartY) + " <- Y: S, " );
                System.out.print(Integer.toString(m_iEndX) +   " <- X: E, " ); System.out.println(Integer.toString(m_iEndY) + " <- Y: E, " ); }
    for (int x = 0; x < m_cpFelder.c_iMaxSizeX; x++) Arrays.fill(m_bpFeldReady[x], false);
    m_cPfaderweiterer.clear();// loescht die zu bearbeitende Liste
    CSearchFeld cStartFeld = new CSearchFeld(m_iStartX, m_iStartY, 0, 0);
    insert(cStartFeld); // fuegt das Startfeld ein
    m_cpFelds[CLabyrinth_ly0.Transform_KoordX(m_iStartX)][CLabyrinth_ly0.Transform_KoordY(m_iStartY)] = cStartFeld;
    m_bpFeldReady[CLabyrinth_ly0.Transform_KoordX(m_iStartX)][CLabyrinth_ly0.Transform_KoordY(m_iStartY)] = true;
    CPath cPath = new CPath();
    try {
      if (run())
      {   if (bLog)  System.out.print("zusmmenstellen des Pfades\n");
        // zusmmenstellen des Pfades
        CSearchFeld cFeld = (CSearchFeld) m_cPfaderweiterer.removeFirst();
        while ((cFeld.m_iPosX != m_iStartX) || (cFeld.m_iPosY != m_iStartY))
        {
          if (bLog)  System.out.print(Integer.toString(cFeld.m_iPosX) + " <- X: Sk, " );
          if (bLog)  System.out.print(Integer.toString(cFeld.m_iPosY) + " <- Y: Sk, " );
          cPath.push(new Integer(cFeld.m_iDirection));
          int iNewX = cFeld.m_iPosX + CLabyrinth_ly0.c_iMoveX[CLabyrinth_ly0.Reflect(cFeld.m_iDirection)];
          int iNewY = cFeld.m_iPosY + CLabyrinth_ly0.c_iMoveY[CLabyrinth_ly0.Reflect(cFeld.m_iDirection)];
          if (bLog) System.out.print(Integer.toString(CLabyrinth_ly0.Reflect(cFeld.m_iDirection)) + " <- D, " );
          if (bLog) System.out.print(Integer.toString(iNewX) + " <- X: nSk, " );
          if (bLog) System.out.println(Integer.toString(iNewY) + " <- Y: nSk" );
          cFeld = m_cpFelds[CLabyrinth_ly0.Transform_KoordX(iNewX)][CLabyrinth_ly0.Transform_KoordY(iNewY)];
        }
     }
   }
   catch (ArrayIndexOutOfBoundsException e) { System.out.println(" warning: ArrayIndexOutOfBoundExeption captured!! - SX = " + Integer.toString(m_iStartX) + " SY = " + Integer.toString(m_iStartY) + " EX = " + Integer.toString(m_iEndX) + " EX = " + Integer.toString(m_iEndY));}
    // Puffern der Entfernung, fals erwuenscht
   if (m_cpFelder.m_bBuffering) m_cpFelder.Access(m_iStartX, m_iStartY).SetBufItem(CLabyrinth_ly0.Transform_KoordX(m_iEndX), CLabyrinth_ly0.Transform_KoordY(m_iEndY), (char)(cPath.size()));
   return cPath;
  }
  /** Hauptschleife des Algorithmus
      es wird immer das naechste zum Ziel zu bearbeitende Feld genommen, und Abzweigungen erstellt, bis das Ziel erreicht ist
  */
  protected boolean run()
  {
    int iPosX, iPosY;
    int iNwPosX, iNwPosY;
    int iPresentCost, iCost;
    int iTestX, iTestY;
    int iCanMove;
    CSearchFeld cFeld;
    for (;;)    {
      // holen des besten Feldes, falls keins da, giebt es keinen bekannten Weg zum Ziel
      if (m_cPfaderweiterer.size() == 0) return false;
      cFeld = (CSearchFeld) m_cPfaderweiterer.removeFirst();
      iPosX = cFeld.m_iPosX;
      iPosY = cFeld.m_iPosY;
       // schauen, ob es das Zielfeld ist, dann beende, sonst erstelle Abkoemmlinge des Feldes, und restarte
      if ((iPosX == m_iEndX) && (iPosY == m_iEndY)){ insert(cFeld); return true;}
      else
      {
      // Erstellen der Nachfahren
        iPresentCost = cFeld.m_iDistance;//laufende Kosten
        for (int i = 0; i < CLabyrinth_ly0.c_iMovepossibilities; i++)
        {
          iNwPosX = iPosX + CLabyrinth_ly0.c_iMoveX[i];
          iNwPosY = iPosY + CLabyrinth_ly0.c_iMoveY[i];
          iTestX = CLabyrinth_ly0.Transform_KoordX(iNwPosX);
          iTestY = CLabyrinth_ly0.Transform_KoordY(iNwPosY);
          if (m_bpFeldReady[iTestX][iTestY]) continue; // Feld ist schon aufgenommen worden
          iCanMove = m_cpFelder.canMove_known(iPosX, iPosY, i);
          if (iCanMove == -1){ continue;} // zur der Seite geht es nicht weiter ...
  //        System.out.print(Integer.toString(iPosX + CLabyrinth_ly0.c_iMoveX[i]) + " <- X: nSkee, " );
  //        System.out.println(Integer.toString(iPosY + CLabyrinth_ly0.c_iMoveY[i]) + " <- Y: nSkee" );
          CSearchFeld cSFeld = m_cpFelds[iTestX][iTestY];
          cSFeld.m_iDirection = i;
          cSFeld.m_iDistance = iPresentCost + iCanMove;
          cSFeld.m_iSort_Distance =  cSFeld.m_iDistance + CLabyrinth_ly0.MinDistance(iNwPosX, iNwPosY, m_iEndX, m_iEndY);
          cSFeld.m_iPosX = iNwPosX;
          cSFeld.m_iPosY = iNwPosY;
          m_bpFeldReady[iTestX][iTestY] = true;
          insert(cSFeld);
        }
      }
    }
  }
  /**   Function die ein Feld zur "Pfaderweiterer"-Liste sotiert! hinzufuegt */
  protected void insert(CSearchFeld cFeld)
  {
    int iPos = 0;
    int iSize = m_cPfaderweiterer.size();
    CLinkedList.Entry e = m_cPfaderweiterer.header;
    while (iPos < iSize)
    {
      if (((CSearchFeld)((e = e.next).element)).m_iSort_Distance >= cFeld.m_iSort_Distance) break;
      iPos++;
    }
    m_cPfaderweiterer.addBefore(cFeld, (iPos == iSize ? m_cPfaderweiterer.header : e));
  }
  /**
    implementation der Datenstruktur zum speichern des suchverlaufes
  */
  protected class CSearchFeld
  {
    public int m_iDirection;
    public int m_iPosX;
    public int m_iPosY;
    public int m_iDistance;
    public int m_iSort_Distance;
    public CSearchFeld()    {  }
    public CSearchFeld(int iPX, int iPY, int iDirection, int iDistance) {
      m_iDirection = iDirection;
      m_iPosX = iPX;
      m_iPosY = iPY;
      m_iDistance = iDistance;
      m_iSort_Distance = iDistance + CLabyrinth_ly0.MinDistance(iPX, iPY, m_iEndX, m_iEndY);

    }
  }
}