
//Titel:        hamster-Hamster
//Version:
//Copyright:    Copyright (c) 1999
//Autor:       Stoneyard
//Firma:
//Beschreibung:  Programmierwettbewerb 2002
package dighty;
//import algds.c2002.Hamster;
import algds.c2002.Hamster2;
import algds.c2002.Constants;
//import hamster.*;
/*
  todo
  - eine timeout rescue -Funktion: verhindert das Verlieren nach 3 min <-> done
  - ein Sortieralgorithmus fuer die Kornlste <-> alsmost done
  - ein Ausschlusalgortihmus zum eingrenzen der Koerner <-> done
  - ein Klippenrunterschmeissmethode <-> hmm erwies sich als inneffizient
/*
  Fortschritte:
  13. Februar 2002: - Entwicklung der Grunddatenstruktur(Dighty, CDightyData, CLabyrinth_ly0 (ly steht fuer Layer), CFeld)
                    - Implementierung einer Wegfindrotiene( CPaths, CPathFinder, CPathFinder_A)
                    - Implementation CHamsterLockTo <-- sorgt dafuer, das der Hamster in die gewuenschte Richtung schaut
                    - Erschaffung   CHamsterMoveTo  <-- bewegt den Hamster zum gewuenschten Punkt
                    - sehr viele Probleme mit Java geloest, leider nicht alle <- hat die meiste Zeit gekostet!
  14. Februar       - Erstellen der Klase CHamsterLockAround
                    - Hinzufuegen von CHamsterGetFeldInfo
                    - Kreieren von CXY
                    - erstellen einer Scoutklasse, 100% effektiv nur normalen Labyrints, es ist also noch ein Bug vorhanden
                    - Standartlabyrinth    : 340 Schritte
                    - leeres 8'er Spielfeld: 175 Schritte
                    - Bug behoben, das Klippen immer als Wall intepretiert wurden
  15. Februar       - 1. Modifikation-> Abarbeitungsgeschwindigkeit deutlich erhoeht
                                        Standartlabyrinth    :  335 Schritte
                                        leeres 8'er Spielfeld:  173 Schritte
                                        2 Standartlabyrinth  :  206 Schritte, jedoch 15 Kollisionen <<-- duerfte theoretisch niemals auftreten, also Bug
                                        Komplex              :  646 Schritte
                    - Bug behoben, das Felder manchmal falsch speichert werden (Schraegen und Klippen)
                    - >                 2 Standartlabyrinth  :  208 Schritte, 0 Kollisionen
                    - 2. Modifikation -> von der Ferne bestimmbare Felder werden nichtmehr angelaufen
                                        Standartlabyrinth    :  330 Schritte
                                        leeres 8'er Spielfeld:  151 Schritte
                                        2 Standartlabyrinth  :  190 Schritte
                                        Komplex              :  609 Schritte
                    - 3. Modifikation -> die Auswahl, welches Feld angelaufen werden soll, bei gleichem Aufwand wurde spezifiziert, ist auf komplexe Labyrinthe moeglicherweise nicht so guenstig
                                        Standartlabyrinth    :  327 Schritte
                                        leeres 8'er Spielfeld:  98  Schritte
                                        2 Standartlabyrinth  :  177 Schritte
                                        Komplex              :  584 Schritte
  19.Februar        - 4. kleine Fehler in der wegfinrotiene behoben (Komplex 572 Schritte)
  21.Februar        - erstellen einer provisorischen Sammelrotiene ... sehr ineffizient
                    - die Scoutrotiene so erweitert, das nun auch ein "vorsammeln" stattfindet, erhoeht die Effizienz der
                       provisorischen Sammelrotiene deutlich
  25.Februar        - die Sammelrotiene durch eine generische Optimierung verbessert
  26.Februar        - enorme Optimierungen in Sachen Geschwindigkeit vorgenommen, eine Folge: die von mir verwendete LinkedList, die von Java mitgeliefert wird,
                        wurde von mir modifiziert, da sie eine der Bremsen darstellte
                    - Bug behoben der dazu fuehrte, dass manche Koerner nicht "gesehen" wurden
  06. Maerz         - die Optimirung der Geschwindikeit weiter vorrangetrieben, ohne zu sammeln erkundet er nun ein Labyrinth doppelt so schnell, ganz zu schweigen von der Wegfindrotiene
                        leider sehe ich kaum noch Verbesserungsmoeglichkeiten, die akzeptablen Aufwand bedeuten, es wuerde echt nurnoch eine hardwarenaehere Sprache,am besten C++, wegen Templates, weiterhelfen.
                    - eine Sammeloptimirung implementiert, die schon gute Ergebnisse erziehlt, jedoch bei meinem 30-Radius MaxLabyrinth zeitlich
                        an seine Grenzen stoesst, es waere mindestens eine Geschwindigkeiterhoehung von 50% noetig, die unter Java jedoch nicht zu erreichen ist, jedoch mit einem P4 2200 MHz *g*
  07. Maerz         - Fertigstellung einer Rotiene, die den Timeoutmechanismus der Hamsterwelt aushebelt, kostet jedoch Punkte
                    - ein Ausschlussalgorithmus hinzugefuegt, der dafuer sorgt, dass nach der Sotierung Felder, deren Ausbeutung unrentabel ist, auch nicht angelaufen werden
  08. Maerz         - dies und das
  11.Maerz          - eine Menge getueftelt, verschnellert, verbessert und optimiert. Der Hamster ist vorlaufig fertig.

*/

public class Dighty extends Hamster2{
  CDightyData m_cData;
  /**
    Konstruktor, muss aufgerufen werden
  */
  public Dighty(){
    System.out.println("wecke Dighty...");
    m_cData = new CDightyData();
    m_cData.m_iPosX = CLabyrinth_ly0.c_iStartX;
    m_cData.m_iPosY = CLabyrinth_ly0.c_iStartY;
    System.out.println("Dighty ist bereit ...");
  }
  /**
    implementation der Runmethode
  */

  public void run(){
    // starten des TimeoutSavers
    m_cData.m_iStartTime = System.currentTimeMillis();
    CHamsterTimeOutSaver cTimeOutSaver = new CHamsterTimeOutSaver(this, m_cData);
    cTimeOutSaver.start();
    logln("Startparameter, X: " + Integer.toString(m_cData.m_iPosX) + " Y: " + Integer.toString(m_cData.m_iPosY));
    log("lets scout \n");
    CHamsterScout cDoScout = new CHamsterScout(this, m_cData);   cDoScout.run();
    log("lets catch corns \n");
    CHamsterCollect cDoCollect = new CHamsterCollect(this, m_cData);   cDoCollect.run();
    // go home
    logln("go home \n");
    CHamsterMoveTo.run(this, m_cData, CLabyrinth_ly0.c_iStartX, CLabyrinth_ly0.c_iStartY);
    // beende den TimeOutSaver
    cTimeOutSaver.DoStop();	try { cTimeOutSaver.join();	} catch (InterruptedException e) {}
  }
  /** Autor(en) des Hamsters. */
  public String getHamsterAuthor() { return " Simon Steinmeyer und Torsten Sommerfeld"; }

  /** Datum der Hamsterversion. */
  public String getHamsterDate() { return " 30.04.2002"; }

  /** Hamsterversion. */
  public String getHamsterVersion() { return "0.01"; }

}