package h2d2c.util;

//---------------------------------------------------------------------
//----- Interface h2d2.util.DirConstants
//---------------------------------------------------------------------
public interface DirConstants extends algds.c2002.Constants {
  /* Richtungsangaben. */
  static final int MINDIR = 0, MAXDIR = 5, NUMDIR = 6;
  static final int N = 0, NE = 1, SE = 2, S = 3, SW = 4, NW = 5;
  static final int[] SAMEDIR = {N , NE, SE, S , SW, NW};
  static final int[] LEFTDIR = {NW, N , NE, SE, S , SW};
  static final int[] LEFT2DIR= {SW, NW, N , NE, SE, S };
  static final int[] ANTIDIR = {S , SW, NW, N , NE, SE};
  static final int[] RIGHT2DIR={SE, S , SW, NW, N , NE};
  static final int[] RIGHTDIR= {NE, SE, S , SW, NW, N };
  static final String[] DIRSTRING = {"N", "NE", "SE", "S", "SW", "NW"};

  /** Indizes in WALKLUT. */
  static final int X = 0, Y = 1;
  /** LookUpTable fuer Nachbarkoordinaten.
   * <pre>
   * __: x-1,y-1
   *            N: x,y-1
   * NW: x-1,y          NE: x+1,y-1
   *            _: x,y
   * SW: x-1,y+1        SE: x+1,y
   *            S: x,y+1
   *                    __: x+1,y+1
   * </pre>
   * {N , NE, SE, S , SW, NW}
   */
  static final int[][] WALKLUT = {{0,-1},{+1,-1},{+1,0},{0,+1},{-1,+1},{-1,0}};

  /** Unbekannte Heimatentfernung. */
  static final int INFINITEDISTANCE = 1000000000;

  static final int MAX_DISTANCE = -POINTS_CORN*CORNCARRY_MAX/POINTS_STEP/2;
}
