package mannie;

/**	Field definiert Kartenfeld-Klasse, die die Anzahl der
	auf ihr befindlichen Koerner und den kleinsten Abstand
	zum Heimatfeld speichert. Weiterhin stellt sie die dazu-
	gehoerigen Zugriffs- und Definitions-Methoden, sowie
	eine ueberladene toString()-Methode bereit.*/
public class Field{
	//Instanz-Variablen
	//Waende nach 6 Seiten, wand-->true
	public boolean[] wall=new boolean[6];
	//Abstaende zu HOME auf Nachbarfeldern
	private int[] distance=new int[6];
	private int corn;
	private int dist;
	private char mark;
	
	//Null-Kostruktor zur standartisierten Initialisierung
	//eines default-Fields
	public Field(){
		corn=0;
		//aufgrund der staendigen Distanzabfragen
		//sicherheitstechnisch uebervorsichtig
		dist=200;
		mark='-';
	}
	public Field(int c, int d){
		corn=c;
		dist=d;
		mark='-';
	}
	
	//Accessor-Methoden
	//# der Wege um ein Feld
	public int getIntWays(){
		int counter=0;
		for(int i=0; i<6; i++){
			if(!wall[i]) ++counter;
		}
		return counter;
	}
	//gibt # der Waende das Feld zurueck
	public int getIntWalls(){
		int counter=0;
		for(int i=0; i<6; i++){
			if(wall[i]) ++counter;
		}
		return counter;
	}
	//ermittelt die Richtung aus einer Sackgasse
	//NUR IN DERSELBEN AUFRUFEN!!!
	public int getOnlyDir(){
		for(int i=0; i<6; i++)
			if (!wall[i]) return i;
		//ansonsten gib 100 zurueck
		return 100;
	}
	public boolean[] getWalls(){return wall;}
	//keine Fehlerabfrage, da dir staendig erneuert wird
	//aus 0<=dir<6 folgt Abgeschlossenheit und keine 
	//ArrayOutOfBoundException, NullPointerException
	//ueber Array wall[] moeglich
	public boolean getWall(int direction){return wall[direction];}
	public int getCorn(){return corn;}
	public int getDist(){return dist;}
	public char getMark(){return mark;}
	
	//Setz-Methoden
	public void setMark(char m){mark=m;}
	public void setWalls(boolean[] w){wall=w;}
	public void setWall(int dir, boolean w){wall[dir]=w;}
	public void setCorn(int c){corn=c;}
	public void setDist(int d){dist=d;}
	
	//toString zur Kontrolle
	public String toString(){
		String walls="";
		for(int i=0; i<6; i++){
			if(wall[i]) walls+=""+i;
			else if(!wall[i]) walls+="-";
		}
		return("c:"+corn+"\td:"+dist+"\tw:"+walls);
	}
}