package mort;

import java.util.*;

public class MazeMap {
  private Node map[][];
  public Node outside;
  private int pass=1;
  private int leaveskilled=0;

  MazeMap() {
    map=new Node[61][61];
    for (int y=0;y<61;y++) for (int x=0;x<61;x++) {
      Node n=new Node();
      n.pos=new Pos(x,y);
      setNode(n.pos,n);
    }
    outside=new Node();
    outside.pos=new Pos(100,100);
  }

  public Vector findLeaves(Vector origin) { // returns a vector of leaves
    Vector l=new Vector();
    if (origin==null) {
      pass++;
      Vector fields=new Vector();
      Node n=getNode(Mort.m.homepos);
      n.distpass=pass;
      fields.add(n);
      while (fields.size()!=0) {
        Enumeration e=fields.elements();
        fields=new Vector();
        while (e.hasMoreElements()) {
          n=(Node)e.nextElement();
          for (int i=0;i<6;i++) if (n.knowWall(i)) if (!n.getWall(i)) if (n.getNext(i).distpass!=pass) {
            Node next=n.getNext(i);
            next.distpass=pass;
            if (next.isLeaf()) l.add(next); else fields.add(next);
          }
        }
      }
    } 
    return l;
  }
  
  public void killLeaves(Vector v) { // kills the leaves in v
    Enumeration e=v.elements();
    while (e.hasMoreElements()) {
      Node n=(Node)e.nextElement();
      n.distance=-1;
      for (int i=0;i<6;i++) n.setWall(i,true);
      leaveskilled++;
    }
  }

  private void spawn() { // calculates distances for each node... spawning...
    pass++;
    int d=0;
    Vector fields=new Vector();    
    Node n=getNode(Mort.m.homepos);
    fields.add(n);
    n.distpass=pass;
    n.distance=0;
    while (fields.size()!=0) {
      d++;
      Enumeration e=fields.elements();
      fields=new Vector();
      while (e.hasMoreElements()) {
        n=(Node)e.nextElement();
        for (int i=0;i<6;i++) if (n.knowWall(i)) if (!n.getWall(i)) if (n.getNext(i).distpass!=pass) {
          Node next=n.getNext(i);
          fields.add(next);
          next.distance=d;
          next.distpass=pass;
        }
      }
    }
  }    
  
  public void makeDistances() { // creates distances and removes leaves until there are no more left
    spawn();
    
    int oldkill=leaveskilled;
    Vector leaves=findLeaves(null);
    while (leaves.size()>0) {
      killLeaves(leaves);
      spawn(); 
      leaves=findLeaves(null);
    }
//    if (oldkill!=leaveskilled) Mort.m.logln("Killed "+(leaveskilled-oldkill)+" leaves.");
  }

  public void setNode(Pos p, Node n) {
    map[p.y][p.x]=n;
  }
  
  public Node getNode(Pos p) {
    if ((p.x<0) || (p.x>60) || (p.y<0) || (p.y>60)) return outside;
    return map[p.y][p.x];
  }

  public void exploreNode() {
    spinwithagrin(Mort.m.actpos);
  }
  
  private void spinwithagrin(Pos p) {   // spin around in a new node
    Node where=this.getNode(p);
    for (int i=0;i<6;i++) {
      int k=(i+Mort.actdir)%6;
      if ((Mort.m.lookForward() & Mort.m.WALLMASK) == Mort.m.WALL) {
        where.setWall(k,true);
      } else {
        where.setWall(k,false);
        if ((Mort.m.lookForward() & Mort.m.CORNMASK) == Mort.m.CORN) {
          where.getNext(k).cornhere=100;
        } else {
          where.getNext(k).cornhere=0;
        }
      }
      Mort.m.turn(Mort.m.TURN_RIGHT);
    }
  }
}

