// ----------------------------------------------------------------
// This is Mort.
// Trained to lurk behind corners and steal corn from the others...
// ----------------------------------------------------------------

package mort;

import algds.c2002.Hamster;

public class Mort extends Hamster {

  static Mort m; // this pointer is neccessary for other classes to gain access to Mort's variables
  
  static final Pos homepos=new Pos(30,30); // home position
  static Pos actpos=(Pos)homepos.clone();  // active position
  static int actdir=0;                     // active direction
  
  static MazeMap map=new MazeMap();        // this is the MazeMap, all the details are in here
  
  private int descent=0;                   // my descent into madness
  private int stackcount=0;                // number of cornstacks dropped

  public void run() {

    m=this;
    logln("This is Mort.");
 
    map.exploreNode();                     // new node, explore it!

    while ((map.getNode(actpos).countInteresting()!=0) || (!actpos.equals(homepos))) processNode();
    // while there's something left and we're not home yet --> go on
    dropCorn(); // drop corn
  }

  private void processNode() {
    if (!actpos.equals(homepos)) if (map.getNode(actpos).distance>8) takeCorn();
    if (stackcount>7) {
      if (getCarriedCorn()==CORNCARRY_MAX) {
        bringItHome();
        stackcount=0;
      }
    } else if (getCarriedCorn()>CORNCARRY_MAX/2) {
      dropCorn();
      stackcount++;
    }
    Node n=map.getNode(actpos);
    int i=-1;
    i=n.anyFurther();
    if (i>-1) {
      descent++;
      turnTo(i);
      walkOn();
      return;
    }
    descent=0;
    i=n.anySameLevelInteresting();
    if (i>-1) {
      turnTo(i);
      walkOn();
      return;
    }
    // at this stage, there's nothing here, except corn maybe... carry that home.
    bringCornHomewards();
  }

  private void bringCornHomewards() { // take corn and step homewards...
    if (actpos.equals(homepos)) {
      dropCorn();
      return;
    }
    Pos p=(Pos)actpos.clone();
    takeCorn();
    while (getCarriedCorn()>0 || p.equals(actpos)) {
      int i=map.getNode(actpos).homeHeadingNeighbor();
      turnTo(i);
      walkOn();
      dropCorn();
    }
  }
  
  private void bringItHome() { // bring carried corn to the home field
    while (!actpos.equals(homepos)) {
      takeCorn();
      int i=map.getNode(actpos).anyFurther();
      i=map.getNode(actpos).homeHeadingNeighbor();
      turnTo(i);
      walkOn();
    }
    dropCorn();
  }
  
  public void walkOn() {
    Node n=map.getNode(actpos).getNext(actdir);
    forward();
    actpos.setNextPos(actdir);
    if (!n.knowAllWalls()) map.exploreNode();
    map.makeDistances();
  }

  private void turnLeft() {
    turn(TURN_LEFT);
    actdir=(actdir+5)%6;
  }

  private void turnRight() {
    turn(TURN_RIGHT);
    actdir=(actdir+1)%6;
  }

  private void turnTo(int newdir) {
    if (actdir!=newdir) {
      if ((actdir-newdir+8)%6<3) while (actdir!=newdir) turnRight();
      else while (actdir!=newdir) turnLeft();
    }
  }
  
  private void takeCorn() {
    take(getAvailableCorn());
    map.getNode(actpos).cornhere=getAvailableCorn();
  }

  private void dropCorn() {
    dropHere(getCarriedCorn());
    map.getNode(actpos).cornhere=getAvailableCorn();
  }

  public String getHamsterAuthor() { 
    return "Butch"; 
  }

  public String getHamsterDate() { 
    return "27.03.02"; 
  }

  public String getHamsterVersion() { 
    return "--> I KISS BOYS <--"; 
  }
  
}
