
package nexus;
import algds.c2002.Constants; 


/**
 * Describe class <code>Field</code> here.
 *
 * @author <a href="mailto:jensL81@gmx.de">Jens Lincke</a>
 */
class Field implements Constants{
    
    /**
     * Describe constant <code>UNKNOWN_CORN</code> here.
     *
     */
    public static final int UNKNOWN_CORN = -1; 
    
     int corn;

     //Ansichten der in Richtung der Nachbarn 
     int[] looks;

     boolean lookedaround;

     Field(int corn){
	 lookedaround=false;
	 this.corn = corn;
     }

     Field(int corn, int[] looks){
	 lookedaround=true;
	 this.corn = corn;
	 this.looks = looks; 
     }

    public String toString(){
	return ("(Field: corn: " + corn + " looks:" + looksToString() +
		" lookedaround:"  + lookedaround); 
    };
    
    public String looksToString(){
	StringBuffer b = new StringBuffer();
	if(looks==null){ return "no looks";
	}else{
	    for(int i=0; i<looks.length; i++)
		b.append(looks[i] + "/");
	    return b.toString();
	}
    }


    /**
     *  berprft ob in Richtung dir keine Wand und auch
     *  kein Abhang liegt
     *
     *  @param dir Richtung 
     *  @return true, wenn man von dem Feld in Richtung dir passieren kann
     */
    public boolean isPassable(int dir){
	return isPassable(looks, dir);	
    }

    static public boolean isPassable(int[] looks ,int dir){
	return ((looks != null) &&  
		!((looks[dir]  & WALLMASK) == WALL) &&
		!((looks[dir] & WALLMASK) == CLIFFUP));	
	
    }

    /** 
     *  Anders, als der Name vermuten lsst, gibt diese Methode nur
     *  an ob man das Korn berhaupt sehen knnte...
     *
     * @return true, wenn die mglichkeit besteht Korn zu sehen
     */
    static public boolean isCornvisible(int[] looks ,int dir){
	if(looks == null)
	    return false;
	int mask = (looks[dir]  & WALLMASK);
	return (!(mask == WALL) && 
		!(mask == CLIFFUP) &&
		!(mask == CLIFFDOWN) && //bin mir noch nicht sichter
		!(mask == SLOPEUP) &&
		!(mask == SLOPEDOWN));
    }



    /**
     *  berprft ob in Richtung 
     *  vor und zurck passierbar ist
     *
     *  @param dir Richtung 
     *  @return true, wenn man von dem Feld in beide 
     *          Richtung dir passieren kann
     */
    public boolean isPassableViceVera(int dir){
	return (isPassable(dir) && 
		!((looks[dir] & WALLMASK) == CLIFFDOWN));

    }

    /**
     *  berprft ob man das Feld aus dieser Richtung erreichen kann 
     *
     *  @param dir Richtung 
     *  @return true wenn erreichbar
     *          
     */
    public boolean isReachable(int dir){
	return (isPassableViceVera(dir) || 
		((looks != null) && ((looks[dir] & WALLMASK) == CLIFFUP)));
    }




    
}









