
package nexus;

import java.util.Stack;

import algds.c2002.Constants; 

/** 
 *  Wenn man nun schon mal einen Graphtraversierungsalgorithmus 
 *  fr den Krzesten Weg zweckentfremdet hat, kann man ihn doch 
 *  auch fr seine eigentliche Aufgabe verwenden, nmlich alle
 *  Knoten eines Graphen zu besuchen ;o)
 *
 *
 */

class FieldMapStatusTraver extends ShortestPath implements Constants {
    
    StringBuffer status; 

    FieldMapStatusTraver(Nexus hamster){
	super(hamster);

	status = new StringBuffer();
	status.append("Ich sehe die Situation folgendermaen:\n");
	status.append("Ich befinde mich auf" + hamster.position + 
		      "und sehe in Richtung " + hamster.direction + "\n" );
	
    }

    public String getStatus(){
	return status.toString();
    }

    /**
     *  Endet bei keinem Feld
     * 
     *  @return immer false
     */  
    protected boolean compare(Path path){
	Position p =path.position;
	Field f = hamster.map.getField(p);
	if(!p.isHome() && ((f.corn == Field.UNKNOWN_CORN) || (f.corn > 0))){
	    status.append("* " + p + "hat " + 
			  ((f.corn > 0) ?  Integer.toString(f.corn) : 
			   "unbekannt") + 
			  " viel Korn und ist" +
			  path.length() + "schritte entfernt." + 
			  "Der Rckweg ist " + 
			  path.getPathRetour(hamster).length() + 
			  " lang.\n");
	}
	status.append(p.toString() + 
		      hamster.map.getConnections(p).toString() +  
		      hamster.map.getField(p) + 
		      "\n");
	return false;
    }

}
