
package nexus;

import java.util.Stack;

import algds.c2002.Constants; 


/**
 *
 *  <h2>Spezialisierung des ShortestPath Algorithmus</h2>
 *  
 *  <ul>
 *   <li>es wrde sich lohnen Corn abzuhohlen</li>
 *   <li>es liegt unbekannt viel Corn darauf</li>
 *   <li>wrde die Karte "aufdecken"</li>
 *  </ul>
 *
 *  <h3>TODO</h3>
 * 
 *  Dem Hamster ist es z.Zt. egal wie sehr interessant das Feld nun ist.
 *  Er unterscheidet nur zwischen interressant und nicht interessant.
 *  Es sollte zum Beispiel doch Mglich sein, eine Liste von gleichlangen 
 *  Pfanden nach ihrem interressantheitswert fr die jeweiliege Strategie
 *  zu sortieren... usw
 * 
 *
 */
class NextIntrestingField extends ShortestPath implements Constants {

  

    /**
     * Creates a new <code>NextIntrestingField</code> instance.
     *
     * @param hamster a <code>Nexus</code> value
     */
    NextIntrestingField(Nexus hamster){
	super(hamster);

    }

    /**
     * Describe <code>hasCornRevenue</code> method here.
     *
     * @param path a <code>Path</code> value
     * @return true, wenn es sich lohnt einen bekannten Kornhaufen abzuhohlen
     */
    public boolean hasCornRevenue(Path path){  
	Position p = path.position;
	Field f = hamster.map.getField(p);

	//sortiert nach Wahrscheinlichkeit	
	if(f.corn <= 0){ 
	    return false;
	}else if(p.isHome()){
	    return false;
	}else if((Math.min(f.corn, CORNCARRY_MAX)  * POINTS_CORN) 
		 + ((path.length() + path.getPathRetour(hamster).length())
		    * POINTS_STEP) 
		 < 0 ){
	    if(hamster.verbose()){
		hamster.logln("Der " + path.length() + " Schritte lange " +  
			      "Hinweg von " + hamster.position + " nach " + 
			      path.position + "und " + 
			      path.getPathRetour(hamster).length() +
			       " lange Rckweg lohnt sich nicht!");  
	    }
	    return false;
	}else if(((path.length() //
		   +(new ShortestPathHomeFrom(hamster, p)).findPath().length())
		  * POINTS_STEP) > 
		 (CORNCARRY_MAX * POINTS_CORN)){
	    // bis jetzt noch nicht vorgekommen, aber mglich ist es 
	    return false;
	}else return true;
    }
    

    /**
     * Describe <code>hasUnkownCorn</code> method here.
     *
     *  @param p  die fragliche Position
     *  @return true, wenn das Cornfeld unbekannt ist
     */
    private boolean hasUnkownCorn(Position p){  
	Field f = hamster.map.getField(p);
	return (f.corn == Field.UNKNOWN_CORN);
    }

    /**
     * Describe <code>hasUnknownNeighbors</code> method here.
     *
     * @param p  die fragliche Position
     * @return true, wenn es noch unangesehene Nachbarn hat
     */
    private boolean hasUnknownNeighbors(Position p){  
	Field f = hamster.map.getField(p);
	return (!f.lookedaround && 
		hamster.map.hasUnknownNeighbors(p));
    }
    
    /**
     * Bei welchen Feld soll der Pfad enden?
     *
     * @param path a <code>Path</code> value
     * @return true, wenn der Pfad zu diesem Feld fhren soll
     */
    protected boolean compare(Path path){
	//if(path.position.equals(1,-3)||path.position.equals(1,-2)) //debug
	//path.position.logAllYouKnow(hamster);
	
	return (hasCornRevenue(path) || 
		hasUnkownCorn(path.position) ||
		hasUnknownNeighbors(path.position));
    }
    
    
}


