package nexus;
import algds.c2002.Hamster2; 

import java.lang.NullPointerException;

//import nexus.WalkWallException;
//import nexus.WalkPathException             

import java.util.Stack;

/**
 *  <h1>Nexus - Mein Hamster</h1>  
 *  
 *  Um so mehr man sich mit dem Thema auseinandersetzt um so mehr,
 *  sieht man was noch alles anders gemacht werden kann. Aber da es
 *  nun mal einen Stichtag gibt, (und Mathe Klausuren) muss ich diese
 *  Version einreichen und hoffen, dass er sich einigermaen
 *  schlgt...
 *
 * @author <a href="mailto:jensL81@gmx.de">Jens Lincke</a>
 */
public class Nexus extends Hamster2 {

    /**
     *  KartenObjekt in dem er sich das Labyrith merkt 
     */
    FieldMap map;
    
    /**
     * Blickrichtung wie in Position
     */
    int direction; 

    /**
     * Position auf der Karte
     */
    Position position;

    /**
     *  
     */
    boolean finished;

    /**
     * true, wenn noch mehr Informationen ausgegeben werden sollen
     */
    static public boolean DEBUG = false;


    /**
     *  der Hamster tut sein Werk 
     */
    public void run() {
      	try{
	    //Initialisierung des Feldes
	    finished = false;
	    map = new FieldMap();
	    
	    //Anfangszustand
	    int direction=Position.D_NORTH;
	    position = new Position(0,0);
	    
	    //sich erst mal umsehen  
	    lookaround();
	    
	    //Arbeitsschleife

	    while(!finished){
		anfang:
		//Suche neue Aufgabe
		if(!(walkNextInterestingField())){
		    if(verbose())logln("Ich finde kein interesantes Feld");
		    //ein letzter Blick aufs Feld
		    if(walkNextInterestingFieldOnPath()){
 			if(verbose())logln("hab doch noch was gefunden!");
 			break anfang;		    
 		    }
		    
					    
		    //aufhhren wenn nichts gefunden
		    if(!atHome()) goStraightHome(); 
		    finished = true;
		}else {
		    if(!atHome()) take(getAvailableCorn());
		    lookaround();
		    if(getCarriedCorn() == CORNCARRY_MAX){
			goHome();
		    }
		}
	    }
	    
	    if(DEBUG) printStatus();
	    if(verbose()) log("Ich bin fertig.");
	}catch (NullPointerException exception){
	    //ich knnte, wenn ich wollte
	    //aber ich bin Optimist
	    //logln(exception.toString());
	    throw exception;
	}catch (WalkException exception){
	    if(DEBUG) printStatus();
	    logln(exception.toString());	
	}
    }

    /**
     * @return wesentliche Statusinformationen des Hamsters
     */
    public String toString(){
	return ("Hamster: position: " + position + 
		"direction: "  + direction + " " + 
		"field:" + map.getField(position));
    }

    /**
     *  Rechtsdrehung, Richtungsnderung wird sich gemerkt 
     */
    private void turn_right(){
	direction = Position.dir_class(direction+1);
	turn(TURN_RIGHT); 
    }
    

    /**
     *  Linksdrehung, Richtungsnderung wird sich gemerkt
     */
    private void turn_left(){
	direction = Position.dir_class(direction-1);;
	turn(TURN_LEFT); 
    }

    /**
     * drehe dich in richtung dir
     *   @param dir 
     */
    private void turn_dir(int dir){
	while(Position.dir_class(dir) 
	      != Position.dir_class(direction)){
	    turn_right();
	}
    }
    


    /**
     * luft einen Pfad entlang
     *
     * @param path a <code>Path</code> value
     * @return a <code>boolean</code> value
     * @exception WalkWallException if an error occurs
     */
    private boolean walk(Path path)
	throws WalkWallException{
	if(path == null) 
	    return false;
	try{
	    walk(path.getMoves());
	}catch (WalkWallException exception){
	    logln("Fehler auf:" +  path);
	    throw exception;	    
	}
	return true;
    }

    /**
     * arbeitet einen Stapel von relativen Bewegungen ab
     * @param stack a <code>Stack</code> value
     */
    private void walk(Stack stack){
	if(stack != null){
	    while(!stack.empty()){
		walk(((Integer) stack.pop()).intValue());
	    }
	}
    }

    
    /**
     * geht ein Feld weiter,  
     *
     *  kann gegen keine Wand laufen   
     *
     * @param dir an <code>int</code> value
     * @exception WalkWallException if an error occurs
     */
    private void walk(int dir)
	throws WalkWallException
    {
	
	//Krner fallen lassen, wenn man zufllig ber 
	//das Homefeld geht
	if(atHome())
	    dropHere(getCarriedCorn());

	while(direction!=dir){
	    turn_right();
	}
	if(map.getField(position).isPassable(dir)){
	    position = position.relative(direction);
	    forward(); 
	    lookaround();
	}else {
	    throw new WalkWallException("Ich laufe nicht gegen Wnde!");
	}
    }
    
    /**
     *  Luft zum nchsten fr ihn intreresanten Feld,  
     * 
     *  @return true falls er eins gefunden hat, false falls nicht 
     *  
     */
    public boolean walkNextInterestingField(){
	Path path = (new NextIntrestingField(this)).findPath();
	if(path == null){
	    return false;
	}else {
	    walk(path.getMoves());
	    return true;
	}
    }

    /*
     * Sucht noch nach mglicherweise gnstigen Kombinationen
     * (Macht im allgemeinen aber weniger Punkte
     *  als die einfache Methode ?!%*grr&%$&!!!
     */
    /**
     * Describe <code>walkNextInterestingFieldOnPath</code> method here.
     *
     * @return a <code>boolean</code> value
     */
    public boolean walkNextInterestingFieldOnPath(){

	Path pathhome = (new ShortestPathHomeFrom(this, position)
			 ).findPath();

	// ist ntig, weil nicht immer ein Heimweg zur Verfgung steht. 
	int homelength;
	if(pathhome != null)
	    homelength = pathhome.length();
	else homelength = 0; //ich bin mal optimistisch ;o)
	
	BinMap visitedPositions = new BinMap();
	visitedPositions.setExplored(position);
	Path path = (new NextIntrestingFieldFrom(this, position, 0, 
						 homelength,
						 visitedPositions)).findPath();
	if(path == null){
	    return false;
	}else {
	    walk(path.getMoves());
	    return true;
	}
    }


    
    /**
     *  gehe auf dem schnellsten Weg nach Hause
     *  und lege dort das gesammelt Korn ab
     * 
     *  bleibe stehn, wenn du keinen Heimweg findest
     *  oder wenn doch, nicht zu Hause angekommen bist.
     *
     */
    public void goHome(){
	if(verbose())logln("Ich gehe erst mal nach Hause.");
	
	lookaround();
		
	Path home = null;
	while(home == null){ // kein Weg nach Hause
	    if(DEBUG)log("suche..");
	    home = (new ShortestPathHome(this)).findPath() ;
	    if((home == null) && !explore()) throw new WalkException();	
	    if(DEBUG)logln("home: " + home + "");
	}

	//kann nicht null werden, den irgendwie muss er ja hergekommen sein
	Path hometopos = (new ShortestPathFromTo(this, 
						new Position(0,0),
						position)).findPath();
	if(home.length() < hometopos.length()){
	    if(verbose())logln("wende die Klippenstrategie an.\n"
			       + "homt->pos length:" + hometopos.length() + "\n"
			       + "pos->home length:" + home.length() + "\n");
	    if(doKlippenStrategie(home))
		return;
	    else 
		goStraightHome(); // sicher ist sicher 
	}else
	    walk(home);
 	if(atHome()){
 	    dropHere(getCarriedCorn());
 	}else{ 
 	    throw new WalkPathException(home); 
 	}
    }
    
    /**
     * Describe <code>goStraightHome</code> method here.
     *
     */
    public void goStraightHome(){
	if(verbose())logln("Ich gehe ohne Umwege nach Hause.");
	
	lookaround();
		
	Path home = null;
	while(home == null){ // kein Weg nach Hause
	    if(DEBUG)log("suche..");
	    home = (new ShortestPathHome(this)).findPath() ;
	    if((home == null) && !explore()) throw new WalkException();	
	    if(DEBUG)logln("home: " + home + "");
	}

	walk(home);
	if(atHome()){
	    dropHere(getCarriedCorn());
	}else{ 
	    throw new WalkPathException(home); 
	}
    }



    /**
     *  Wenn auf dem Path eine Klippe vorkommt, dann wirft er sein Korn
     *  herunter und versucht lieber noch Korn "oben" zu bleiben
     *
     * @param home a <code>Path</code> value
     * @return a <code>boolean</code> value
     */
    public boolean doKlippenStrategie(Path home){
	
	Stack stack = home.getMoves();
	int dir = direction ;
	Position dropzone;
	//bis zur Klippe laufen
	while(!stack.empty()){
	    dir = ((Integer) stack.pop()).intValue();
	    if(!map.getField(position).isPassableViceVera(dir)){
		break;
	    }else{ 
		walk(dir);
	    }
	}
	dropzone=position.relative(dir);
	if(verbose())logln("dropzone:" + dropzone);

	//alles runterwerfen
	turn_dir(dir);	
	int cornamount = getCarriedCorn();
	dropForward(cornamount);

	//aktualisieren
	 map.getField(position.relative(direction)).corn += cornamount ;
	 map.getField(position).corn=getAvailableCorn();

	//und weiter suchen

	 //Der Paramerter scheint nicht so interessant zu sein... aber
	 if(walkOnLevel(10))
	     return true;
	 return false; 
    }

    /**
     * vesuche, zum nchsten Feld interessanten Feld zu gehen fr
     *  das du keine Klippe herunterspringen msstest
     *
     * @param maxsteps kann das Feld entfernt sein. 
     * @return false, wenn kein Feld gefunden wurde
     */
    public boolean walkOnLevel(int maxsteps){
	Path path = (new NextIntrestingFieldOnLevel(this)).findPath() ;
	if(verbose())logln("OnLevel:" + path);
	if((path != null)){ //&&(path.length() <= maxsteps)
	    walk(path);
	    return true;
	}else {
	    return false;
	}
	
	
    }



    
    /**
     *  Gehe zum nchsten unbekannten Feld
     * 
     *  @return false, wenn kein Feld gefunden wurde 
     *
     */
    public boolean explore(){
	ExplorePath e = new ExplorePath(this);
	Path path = e.findPath();
	if(path==null)
	    return false;
	else{ 
	    if(verbose())log("explore: " + path.toString());
	    walk(path);
	    return true;
	}
    }
    
    /**
     *  Schau dich um und merke dir was du siehst 
     *  (kostet ja nichts!)
     */
    private void lookaround(){
	//Eigentlich kostet es nichts sich zu oft umzuschauen
	//aber ein eleganter hamster sollte sich nicht stndig im Kreis
	//drehen, davon wird einem doch schlecht
	
	if(!(map.getField(position) != null &&  // drfte nicht vorkommen
	     map.getField(position).lookedaround)){ 
	    int save_direction = direction;
	    int looks[]=new int[Position.DIRECTIONS];
	    
	    // einmal im Kreis drehen 
	    Field f;
	    do{
		// merke dir was du siehst 
		looks[direction]=lookForward();
		//falls Feld vor dir noch unbekannt
		if(map.getField(position.relative(direction)) == null){
		    //wenn das Feld erreichbar ist 
		    if(Field.isPassable(looks,direction)){
			//schaue ob Corn darauf liegen
			f = new Field
			    (((looks[direction] & CORNMASK) == CORN) ||
			     !Field.isCornvisible(looks,direction) ? 
			     Field.UNKNOWN_CORN : 0);
			map.setField(f, position.relative(direction));
		    }
		};
		turn_right();
		//bis du wieder gerade aus siehst
	    }while(direction!=save_direction);
	    // merke dier was du gesehn hast
	    map.setField(new Field(getAvailableCorn(),looks), position); 
	}else{
	    // die Kornanzahl kann sich ja ndern 
	    map.getField(position).corn=getAvailableCorn();
	}
	
    }

    /**
     * Gibt alle Informationen, ber alle Felder die er kennt aus.
     * (dass knnen sehr sehr viele sein)
     *
     */
    public void printStatus(){
	FieldMapStatusTraver status = new FieldMapStatusTraver(this);
	status.findPath();
	logln(status.getStatus());

    }
    
    /**
     * 
     * @return a <code>String</code> value
     */
    public String getHamsterAuthor() { return "Jens Lincke"; }
    
    /**
     *
     * @return a <code>String</code> value
     */
    public String getHamsterDate() { return "25.04.2002"; }
    
    /**
     *
     * @return a <code>String</code> value
     */
     public String getHamsterVersion() { return "0.5"; }
    
    
}







