package scrat;

import java.util.*;


public class simpleSet implements Cloneable{
  
  protected int[] content;
  //protected boolean empty;
    
  protected int diffsize;
  
  protected int size;
    
  simpleSet(){
    this(10);
  }
  
  simpleSet(int ds){
    if (ds > 0) {
      diffsize = ds;
    }               
    content = new int[diffsize];
    size = 0;
  }

  simpleSet(int[] elements){
    this.content=elements;
    size = content.length;
  }

  public Object clone(){
    try {
      simpleSet o = (simpleSet) super.clone();
      o.diffsize = this.diffsize;
      o.size = this.size;
      o.content = (int[]) this.content.clone();
      return o;
    }
    catch (CloneNotSupportedException e) {
      // this shouldn't happen because Stack is Cloneable
      throw new InternalError();
    }
    
  }

  public boolean isEmpty(){
    return (size == 0);
  }

  public int get(int index) throws NoSuchElementException{
    if ((index >= 0) && (index < size)) {
      return content[index];
    }
    throw new NoSuchElementException(); // nicht gefunden
  }

  public int popLast() throws NoSuchElementException{
    if (size > 0) {
      return content[--size];
    }
    throw new NoSuchElementException(); // nicht gefunden
  }

  public int getSize(){
    return size;
  }

  /**
   * Aendert Array-Groesse um diff (kann auch negativ sein)
   * Die einzelnen Elemente des Arrays muessen extra initialisiert werden, da sonst 
   * ArrayNullPointerException beim Zuweisen auftritt
   **/                                                       
  protected void resize(int diff){
    int j;
    int[] buffer = (int[]) content.clone();
    content = new int[buffer.length + diff]; // Array vergroessern
    System.arraycopy(buffer, 0, content, 0, Math.min(content.length, buffer.length) ); 
  }
    
  public boolean contains(int element){
    return (getIndexOf(element) >= 0);
  }

  private int getIndexOf(int element){
    int i = 0;
    while (i < size) {
      if (content[i] == element) {
        return i; // gefunden
      }
      i++;
    }
    return -1;
  }

  public void insert(int element){
    if (!contains(element)) { // schon enthalten???
 // FEHLERQUELLE
    if ((content.length <= size)) { // kein platz mehr
        //System.out.println("\n "+content.length+ " < "+ size);
        //System.out.println("!!!!!!!!!!!!    ADD -> resize   !!!!!!!!!!!!!!!");
        resize(diffsize); // array vergroessern
      }
      content[size++] = element;
    } 
  }

  public void removeAll(){
    content = new int[diffsize];
    size = 0;
  }

  public String toString(){
    String s = "Werte :";
    for (int i = 0; i < size; i++) {
      s=s+content[i]+", ";
    }
    return s;
  }

  public boolean remove(int element){
    int i = getIndexOf(element);
    //System.out.println("removeNode("+element+") -> Index = "+i);
    if (i < 0) { // nicht gefunden
      //System.out.println("nicht gefunden");
      return false;
    }
    //System.out.println("check resize.");
    //System.out.println("vorm Loeschen : "+this);
    
    size--;
    while (i < size) {
      //System.out.println("kopiere ["+(i+1)+"] nach ["+i+"]");
      content[i] = content[i+1];
      i++;
    }
    //System.out.println("check resize.");

    // ueberpruefen, ob resize notwendig
    if (size < (content.length - diffsize)) {
      resize(-diffsize); // feld verkleinern
    }        
    //System.out.println("node removed.");
    return true;
  }


  
}// Ende simpleSet
