//****************************************************************************
//
//					Hamster TICO (urspr. TICONDEROGA)
//
//	 ein Beitrag zum Hamsterwettbewerb 2002 der Fakultt fr Informatik
//		       der Otto-von-Guericke-Universitt Magdeburg
//
//			 entwickelt und programmiert von:  Andreas Strehl
//
//                       HILFSKLASSE "Feld"
//****************************************************************************

//****************************************************************************
// Funktionsaufbau dieser Klasse:
// Diese Klasse definiert einen Abstrakten Datentyp mit neun Instanzvariablen
// die die Koordinaten des Feldes, die Richtung zum Heimatfeld, die Entfernung
// zum Heimatfeld, die Richtung fr verkrzten Korntransport, die Entfernung
// auf dem verkrzten Korntransport zum Heimatfeld, die Richtung fr die
// Rckkehr zum Ausgangsfeld fr den verkrzten Korntransport sowie den Wert
// ob das Feld bereits betreten wurde und ob bereits alles erkundet wurde
// speichern. 
// Die Klasse stellt daher die Grundlagen fr die interne Karte bereit.
//**************************************************************************** 

package tico;

public class Feld{

	//Instanzvariablen die zur Navigation betigt werden
	private int posX;
	private int posY;
	private boolean bereitsBetreten;
	private boolean allesErkundet;
	private int entfernungHeimatfeld;
	private int wegHeim;
	private int kuerzesterKorntransportRichtung;
	private int kuerzesterKorntransportEntfernung;
	private int rueckweg;
		
	//Konstruktoren
	public Feld(int x, int y){
		posX=x;
		posY=y;
		wegHeim=-1;
	}

	//Selektoren
	public boolean getBereitsBetreten(){
		return bereitsBetreten;
	}
	
	public boolean getAllesErkundet(){
		return allesErkundet;
	}
	
	public int getPosX(){
		return posX;
	}
	
	public int getPosY(){
		return posY;
	}
	
	public int getEntfernungHeimatfeld(){
		return entfernungHeimatfeld;
	}
	
	public int getWegHeim(){
		return wegHeim;
	}
	
	public int getKuerzesterKorntransportRichtung(){
		return kuerzesterKorntransportRichtung;
	}
	
	public int getKuerzesterKorntransportEntfernung(){
		return kuerzesterKorntransportEntfernung;
	}
	
	public int getRueckweg(){
		return rueckweg;
	}
	
	//Modifikatoren
	public void setBereitsBetreten(boolean wert){
		bereitsBetreten=wert;
	}
	
	public void setAllesErkundet(boolean wert){
		allesErkundet=wert;
	}	
	
	public void setEntfernungHeimatfeld(int wert){
		entfernungHeimatfeld=wert;
	}
	
	public void setWegHeim(int wert){
		wegHeim=wert;
	}

	public void setKuerzesterKorntransportRichtung(int wert){
		kuerzesterKorntransportRichtung=wert;
	}
	
	public void setKuerzesterKorntransportEntfernung(int wert){
		kuerzesterKorntransportEntfernung=wert;
	}
	
	public void setRueckweg(int wert){
		rueckweg=wert;
	}
}	