package timtombob;
import algds.c2002.Hamster;
import java.util.LinkedList;

public class Map{
	
	static int Richtung = 0; // Richtung in die der Hamster guckt

	static int pos[] = {0,0}; // Position auf der Karte und vorletzte
	static int virtPos = 0; // virtuelle Position auf der Karte, vorletzte und vorvorletzte
	static LinkedList circle = new LinkedList(); // Die bisherigen Positionen, um Kreiswege zu bemerken.
	static LinkedList wayHome = new LinkedList(); // Die bisherigen Positionen fr den Rckweg.
	
	/**
		Felder[pos[0]][0] : schon mal da gewesen.
		Felder[pos[0]][1] : macht keinen Sinn dort lang zu gehen
		Felder[pos[0]][2] : Richtung == 0 geht
		Felder[pos[0]][3] : Richtung == 1 geht
		Felder[pos[0]][4] : Richtung == 2 geht
		Felder[pos[0]][5] : Richtung == 3 geht
		Felder[pos[0]][6] : Richtung == 4 geht
		Felder[pos[0]][7] : Richtung == 5 geht
	*/

	//maximale Anzahl Felder bei Kantenlnge 30 + 31. Ebene, wird fr setSenselessIfNecessary() bentigt.
	static boolean[][] Felder = new boolean[2791][8];
	
	public Map(){
	}
	
	public static void setPos(int dir, boolean virreal){
		/**
			Positionsermittlungsalgorithmus, der
			durch die Richtung und die alte Position
			herausfindet, welche Postion danach erreicht ist.
		*/
		if (virreal){
			pos[1] = pos[0];
			circle.addFirst(new Integer(pos[0]));
		}
		int lowNiv = 0;
		boolean ebeneErreicht = false;
		int ebene = 0;
		for (int i = 0; !ebeneErreicht ; i++){ // Ebenenberechnung
			lowNiv = lowNiv + (i * 6);
			if (lowNiv >= virtPos){
				ebene = i;
				ebeneErreicht = true;
			}
		}
		
		lowNiv = lowNiv - (6 * ebene); // Anzahl Felder der unteren Ebenen ohne Home
		
		if (virtPos == 0){
			virtPos = dir + 1;
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (1 * ebene) + 1 && virtPos - lowNiv > (0 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 6); break;
			case 1: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 5); break;
			case 2: virtPos += 1; break;
			case 3: virtPos = lowNiv  - ((6 * ebene) - (virtPos - lowNiv) - 6); break;
			case 4: virtPos = lowNiv  - ((6 * ebene) - (virtPos - lowNiv) - 5); break;
			case 5: virtPos -= 1; break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (2 * ebene) + 1 && virtPos - lowNiv > (1 * ebene) + 1){
			switch (dir){
			case 0: virtPos -= 1; break;
			case 1: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 5); break;
			case 2: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 4); break;
			case 3: virtPos += 1; break;
			case 4: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 5); break;
			case 5: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 4); break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (3 * ebene) + 1 && virtPos - lowNiv > (2 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 3); break;
			case 1: virtPos -= 1; break;
			case 2: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 4); break;
			case 3: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 3); break;
			case 4: virtPos += 1; break;
			case 5: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 4); break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (4 * ebene) + 1 && virtPos - lowNiv > (3 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 3); break;
			case 1: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 2); break;
			case 2: virtPos -= 1; break;
			case 3: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 3); break;
			case 4: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 2); break;
			case 5: virtPos += 1; break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (5 * ebene) + 1 && virtPos - lowNiv > (4 * ebene) + 1){
			switch (dir){
			case 0: virtPos += 1; break;
			case 1: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 2); break;
			case 2: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 1); break;
			case 3: virtPos -= 1; break;
			case 4: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 2); break;
			case 5: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 1); break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv < (6 * ebene) + 1 && virtPos - lowNiv > (5 * ebene) + 1){
			switch (dir){
			case 0:	virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv)); break;
			case 1: if (virtPos - lowNiv == 6 * ebene){
						virtPos = lowNiv + 1; break;
					}
					else virtPos +=1; break;
			case 2: if (virtPos - lowNiv == 6 * ebene){
						virtPos = lowNiv - (6 * (ebene - 1) - 1); break;
					}
					else virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv) - 1); break;
			case 3: virtPos = lowNiv - ((6 * ebene) - (virtPos - lowNiv)); break;
			case 4: virtPos -= 1; break;
			case 5: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)) - ((6 * ebene) - (virtPos - lowNiv) + 1); break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (0 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv + (6 * ebene) + 1; break;
			case 1: virtPos = lowNiv + (6 * ebene) + 2; break;
			case 2: virtPos += 1; break;
			case 3: if (virtPos == 1) virtPos = 0;
					else virtPos = lowNiv - (6 * (ebene - 1)) + 1; break;
			case 4: virtPos = lowNiv + (6 * ebene); break;
			case 5: virtPos = lowNiv + (6 * ebene) + (6 * (ebene + 1)); break;			
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (1 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv + (6 * ebene) + ebene + 1; break;
			case 1: virtPos = lowNiv + (6 * ebene) + ebene + 2; break;
			case 2: virtPos = lowNiv + (6 * ebene) + ebene + 3; break;
			case 3: virtPos += 1; break;
			case 4: if (virtPos == 2) virtPos = 0;
					else virtPos = lowNiv - (5 * (ebene - 1)) + 1; break;
			case 5: virtPos -= 1; break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (2 * ebene) + 1){
			switch (dir){
			case 0: virtPos -= 1; break;
			case 1: virtPos = lowNiv + (6 * ebene) + (2 * (ebene + 1)); break;
			case 2: virtPos = lowNiv + (6 * ebene) + (2 * (ebene + 1)) + 1; break;
			case 3: virtPos = lowNiv + (6 * ebene) + (2 * (ebene + 1)) + 2; break;
			case 4: virtPos += 1; break;
			case 5: if (virtPos == 3) virtPos = 0;
					else virtPos = lowNiv - (4 * (ebene - 1)) + 1; break;
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (3 * ebene) + 1){
			switch (dir){
			case 0: if (virtPos == 4) virtPos = 0;
					else virtPos = lowNiv - (3 * (ebene - 1)) + 1; break;
			case 1: virtPos -= 1; break;
			case 2: virtPos = lowNiv + (6 * ebene) + (3 * (ebene + 1)); break;
			case 3: virtPos = lowNiv + (6 * ebene) + (3 * (ebene + 1)) + 1; break;
			case 4: virtPos = lowNiv + (6 * ebene) + (3 * (ebene + 1)) + 2; break;
			case 5: virtPos += 1; break;			
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (4 * ebene) + 1){
			switch (dir){
			case 0: virtPos += 1; break;
			case 1: if (virtPos == 5) virtPos = 0;
					else virtPos = lowNiv - (2 * (ebene - 1)) + 1; break;
			case 2: virtPos -= 1; break;
			case 3: virtPos = lowNiv + (6 * ebene) + (4 * (ebene + 1)); break;
			case 4: virtPos = lowNiv + (6 * ebene) + (4 * (ebene + 1)) + 1; break;
			case 5: virtPos = lowNiv + (6 * ebene) + (4 * (ebene + 1)) + 2; break;			
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
		if (virtPos - lowNiv == (5 * ebene) + 1){
			switch (dir){
			case 0: virtPos = lowNiv + (6 * ebene) + (5 * (ebene + 1)) + 2; break;
			case 1: if (virtPos == 6) virtPos = 1;
					else virtPos += 1; break;
			case 2: if (virtPos == 6) virtPos = 0;
					else virtPos = lowNiv - (ebene - 1) + 1; break;
			case 3: virtPos -= 1; break;
			case 4: virtPos = lowNiv + (6 * ebene) + (5 * (ebene + 1)); break;
			case 5: virtPos = lowNiv + (6 * ebene) + (5 * (ebene + 1)) + 1; break;			
			}
			if (virreal) pos[0] = virtPos;
			return;
		}
	} //setPos()
	
	public boolean wasThere(){ //fragt ob der Hamster das Feld kennt
		return Felder[pos[0]][0];
	}

	public void setField(){ // der Hamster kennt ab jetzt dieses Feld
		Felder[pos[0]][0] = true;
	}

	public static void setSenseless(int posi){ // setzt das "macht keinen Sinn" Attribut auf true
		Felder[posi][1] = true;
	}

	public static void setAvailable(int dir){ // markiert Richtung, die zulssig ist
		Felder[pos[0]][dir + 2] = true;
	}

	public static void setUnavailable(int posi, int dir){ //markiert unzulssige Richtung
		Felder[posi][dir + 2] = false;
	}

	public static void setDirection(char a){ // ndert Richtungsvariable
		if (a == 'l'){
			Richtung -= 1;
			if (Richtung < 0){
				Richtung = 5;
			}
		}
		if (a == 'r'){
			Richtung += 1;
			if (Richtung > 5){
				Richtung = 0;
			}
		}
	}

	public static int howManyFieldsAvailable(int posi){ // errechnet wieviele Felder mit Sinn erreichbar sind
		int anzahl = 0;
		for (int i = 0; i < 6; i++){
			virtPos = posi;
			virtualSetPos(i, false);
			if (Felder[posi][i + 2] && !Felder[virtPos][1]){
				anzahl += 1;
			}
		}
		return anzahl;
	}

	public static void virtualSetPos(int dir, boolean virt){
		if (virt) virtPos = pos[0];
		setPos(dir, false);
	}

	public static void realSetPos(){
		setPos(Richtung, true);
	}

	public static int bestDirection(){
		for (int i = 0; i < 6; i++){
			virtualSetPos(i, true);
			if (!Felder[virtPos][1] && Felder[pos[0]][i + 2] && !Felder[virtPos][0]) return i;
		}
		for (int i = 0; i < 6; i++){
			virtualSetPos(i, true);
			if (!Felder[virtPos][1] && Felder[pos[0]][i + 2] && virtPos != pos[1]) return i;
		}
		return ((Richtung >= 3)?(Richtung - 3):(Richtung + 3));
	}

	public static void setSenselessIfNecessary(int availableCorn, boolean home){
		if (howManyFieldsAvailable(pos[0]) == 1 && availableCorn == 0 && !home){	// setzt das Feld auf Sinnlos, wenn nur ein Weg
			setSenseless(pos[0]);// hinfhrt und kein Corn mehr drauf ist
			return;
		}
	}

	public static void destroyCircle(){
		if (circle.get(0) == circle.get(circle.indexOf(new Integer(pos[0])) - 1)){
			circle.removeFirst();
			if (circle.get(0) == circle.get(circle.indexOf(new Integer(pos[0])))){
				circle.removeFirst();
			}
		}
		else if (circle.get(0) != circle.get(circle.indexOf(new Integer(pos[0])) - 1)){
			setUnavailable(pos[0], (Richtung >= 3)?(Richtung - 3):(Richtung + 3));
			setUnavailable(((Integer) circle.removeFirst()).intValue(), Richtung);
			circle.clear();
		}
	}
	public static boolean wasThereWithoutSense(){
		int a = circle.indexOf(new Integer(pos[0]));
		if (a != -1){
			return true;
		}
		else return false;
	}
	public static int directionFor(int Feld){
		for (int i = 0; i < 6; i++){
			virtualSetPos(i, true);
			if (virtPos == Feld) return i;
		}
		return -1;
	}
}