package timtombob;
import algds.c2002.Hamster;

/**
 * TimTomBob.
 * @author Andre Naujoks
 */

public class TimTomBob extends Hamster {

/**
 * Markierung, ob der Lauf beendet werden soll oder nicht.
 * Karte wird angelegt.
 */
boolean finished = false;
Map Karte = new Map();

/**
 * Hauptmethode.
 * Geht sammeln, kehrt nach Hause zurueck und legt allen Mais ab,
 * bis er der Meinung ist alles abgesucht zu haben.
 */
public void run() {
	finished = false;
	while (!finished) {
		getCorn();
		goHome();
		dropAll();
	}
}

/**
 * Geht Mais sammeln bis das Maul voll ist und erweitert dabei die interne Karte.
 */
private void getCorn() {
	setField();
	boolean full = false;
	while (!full) {
		if (getCarriedCorn() == CORNCARRY_MAX) {
			full = true;
			return;
		}
		Karte.wayHome.addFirst(new Integer(Karte.pos[0]));
		if (atHome() && Karte.howManyFieldsAvailable(Karte.pos[0]) == 0) {
			finished = true;
			if (verbose()) logln("Any further step is senseless.");
			return;
		}
		turnDirection(Karte.bestDirection());
		makeStep();
		
		if (Karte.wasThereWithoutSense()){
			Karte.destroyCircle();
		}
		if (atHome()){
			Karte.wayHome.clear();
			Karte.wayHome.addFirst(new Integer(0));
		}
		if (getAvailableCorn() > 0) take(CORNCARRY_MAX);
	}
}    

/**
 * geht auf dem gleichen Weg nach Hause, allerdings ohne
 * Schleifen, die vom Hauptweg abweichen.
 */
private void goHome(){
	Integer pos = new Integer(1);
	while(!atHome()){
		pos = new Integer(Karte.pos[0]);
		if(Karte.wayHome.indexOf(pos) == -1){
			turnDirection(Karte.directionFor(((Integer) Karte.wayHome.removeFirst()).intValue()));
			makeStep();
		}
		if (Karte.wayHome.indexOf(pos) != -1){
			while (Karte.wayHome.indexOf(pos) != -1){
				Karte.wayHome.removeFirst();
			}
			turnDirection(Karte.directionFor(((Integer) Karte.wayHome.removeFirst()).intValue()));
			makeStep();
		}
	}
}

/**
 * Legt alles ab, was er an Mais hat.
 */
public void dropAll() {
	int dropped = dropHere(CORNCARRY_MAX);
	if (verbose()) log(dropped + " corn dropped.\n");
	Karte.circle.clear();
}

public void turnLeft(){ //linksdrehen
	turn(TURN_LEFT);
	Karte.setDirection('l');
}

public void turnRight(){ //rechtsdrehen
	turn(TURN_RIGHT);
	Karte.setDirection('r');
}

public void setField(){ //Feld auf dem der Hamster steht kenntlich machen und Attribute setzen.
	if (!Karte.wasThere()){
		for (int i = 0; i < 6; i++){
			if (((lookForward() & WALLMASK) != WALL) && !Karte.Felder[Karte.pos[0]][Karte.Richtung + 2]){
				Karte.setAvailable(Karte.Richtung);
			}
			else if (((lookForward() & WALLMASK) != WALL) && Karte.Felder[Karte.pos[0]][Karte.Richtung + 2]){
				Karte.setUnavailable(Karte.pos[0], Karte.Richtung);
			}
			if (Karte.pos[0] % 2 == 0){
				turnLeft();
			}
			else turnRight();
		}
		Karte.setField();
	}
}

public void makeStep(){ //Schritt machen und alle erforderlichen Parameter setzten.
	Karte.setSenselessIfNecessary(getAvailableCorn(), atHome());
	forward();
	Karte.virtPos = Karte.pos[0];
	Karte.realSetPos();
	setField();
}

public void turnDirection(int dir){ // in die angegebene Richtung drehen
	switch (Karte.Richtung){
	case 0: if (dir <= 3){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	case 1: if (dir <= 4 && dir >= 1){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	case 2: if (dir <= 5 && dir >= 2){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	case 3: if (dir <= 5 && dir >= 3){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	case 4: if ((dir <= 5 && dir >= 4) || dir == 0){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	case 5: if (dir <= 2){while (dir != Karte.Richtung) turnRight(); return;}
			else{while (dir != Karte.Richtung) turnLeft(); return;}
	}
}

/** Autor(en) des Hamsters. */
public String getHamsterAuthor() { return "Andre Naujoks"; }

/** Datum der Hamsterversion. */
public String getHamsterDate() { return "29.04.2002"; }

/** Hamsterversion. */
public String getHamsterVersion() { return "0.6"; }

} // TimTomBob
