package trok;
import algds.c2002.Hamster;

/**
Der Hamster tr{ok
*/

public class Trok extends Hamster {

/**
Variablen
*/

final int M=30;	//Mittelpunkt des Koordinatenkreuzes
final int WAND=1;	//Konstanten zur Beschreibung der Zellen	
final int KEINE_WAND=2;
final int UNBEKANNT=0;
final int UNGUELTIG=9;

Zelle labyrinth[][]=new Zelle [60][60];	//Array in dem Zelle-Objekte abgelegt werden
Zelle aktuelleZelle;	//Zelle auf der sich der Hamster befindet

Koordinaten standpunkt=new Koordinaten(M,M);	//aktueller Standpunkt
Koordinaten standpunktAlt=new Koordinaten(M,M);	//alter Standpunkt
Koordinaten abbruchStandpunkt;	//Ort an dem der Hamster seine Suche abgebrochen hat

int blickrichtung =0;	//Blickrichtung
int distanz=0;	//Distanz zum Heimatfeld
int anzahlUnbekannte=0; //Anzahl der Zellenseiten an denen unebaknnte Zellen liegen
int richtungen[]={0,1,5,2,4,3};	//gibt die Reihenfolge der Himmelsrichtungen vor, in denen
						//nach unbekannte Zellen gesucht wird

boolean fertig = false;	//Markierung, ob der Lauf beendet werden soll oder nicht.
boolean vorgaengerZellenSpeichern=true; //Markiert ob der Hamster neue Zellen betritt (true)
							//oder sich auf bekanntem Terrain bewegt  
boolean maisLiegengelassen=false;	//Markiert, ob der Hamster Mais auf einem Feld
							//zurcklassen musste


//__________________________________________________________________________________

/**
run()
Die Hauptmethode, die in einer while-Schleife die Suche des Hamsters ausfhrt bis keine
Unbekannten Zellen mehr im Labyrinth existieren. Sie ruft dabei einmal die Methode
esGehtLos() auf und dann, solange noch Felder zu erkunden sind,  nacheinander die Methoden
geheSammeln(), geheNachHause(), dropMais() und geheZumAbbruch().
*/

public void run() {
	fertig = false;
		esGehtLos();
		while (!fertig) {
		geheSammeln();
		geheNachHause();
		dropMais();
		if(anzahlUnbekannte==0){
			fertig=true;
			break;
		}
		geheZumAbbruch();
		
	}
}

//__________________________________________________________________________________

/*
esGehtLos()
Legt die Heimatzelle mit den Koordinaten des Mittelpunktes des Koordinatenkreuzes an,
die Distanz zum Heimatfeld ist null. Die gerade angelegte Zelle ist auch die aktuelle
Zelle, d.h. der Standpunkt des Hamsters.
**/

public void esGehtLos(){
	labyrinth[standpunkt.xWert()][standpunkt.yWert()]=new Zelle(standpunkt,blickrichtung,0);
	aktuelleZelle=labyrinth[standpunkt.xWert()][standpunkt.yWert()];
}

/**
geheSammeln()
Fhrt die Suche des Hamsters nach Mais durch.Die Suche ist beendet, wenn der Hamster voll
mit Mais ist (wird in der sucheAbbrechen() Methode entschieden) oder es keine weiteren
Zellen des Labyrinths zu erkunden gibt. In diesem Fall ist die anzahlUnbekannte gleich null.
Auf der Suche nach Mais ruft geheSammeln() die Methoden erkunden(), maisSammeln(),
naechsterSchritt() und vorwaerts() nacheinander auf.
*/

private void geheSammeln() {
	boolean abbrechen;
	abbrechen=false;
	while (abbrechen==false) {
		
		//Der Hamster erkundet die aktuelle Zelle
		erkunden();
		
		//Der Hamster sammelt den Mais der aktuellen Zelle auf
		if (!atHome()) maisSammeln();
		
		//Sollte der Hamster auf der Suche ber das Heimatfeld kommen, legt er den Mais ab
		if (atHome()) dropMais();
		
		//Der Hamster knnte voll sein und die Suche msste abgebrochen werden
		if (sucheAbbrechen()||anzahlUnbekannte==0){
			abbrechen=sucheAbbrechen();
			abbruchStandpunkt=standpunkt;
			break;
		}
			
		//Der Hamster bestimmt den nchsten Schritt
		naechsterSchritt();
		
		//Der Hamster macht den nchsten Schritt
		vorwaerts();
		if(getCollisions()!=0) abbrechen=true;	
		}
}
    

/**
geheNachHause()
Fhrt den Hamster nach Hause. Dabei richtet der Hamster sich nach den in den umliegenden 
Zellen gespeicherten Distanzen zum Heimatfeld. Um diese Distanzen zu optimieren ruft
geheNachHause die Methode distanzenOptimieren() auf. Die Richtung der jeweils am nchsten
zur Heimatzelle gelegene Nachbarzelle wird von der Methode distanzenKontrolle() zurckgegeben.
Die Methode setzt die globale Boolesche Variable vorgaengerZellenSpeichern gleich "false"
und legt in den betretenen Zellen die Richtung zur Stelle ab, an dem die Suche abgebrochen
wurde (richtungAbbruch).
*/

private void geheNachHause() {
	vorgaengerZellenSpeichern=false; //Der Hamster betritt auf dem Rckweg kein Neuland
	distanzenOptimieren();
	while(!atHome()){
		drehenInHR(distanzenKontrolle(standpunkt));		
		vorwaerts();
		aktuelleZelle.richtungAbbruch=umgekehrteBlickrichtung(blickrichtung);
	}
}


/**
dropMais()
Der Hamster legt allen Mais ab.
*/

public void dropMais() {
	int dropped = dropHere(CORNCARRY_MAX);
}

/**
geheZumAbbruch()
Fhrt den Hamster zu der Stelle, an der er die Suche abgebrochen hat. Wenn dort allerdings
nichts mehr zu erkunden ist wird der Hamster stattdessen unterwegs dorthin die Spur zur 
nchsten unbekannten Zelle aufnehmen und dann dieser Spur folgen. Dazu wird die 
unbekannteFinden() Methode aufgerufen.
*/

public void geheZumAbbruch(){
	unbekannteFinden(abbruchStandpunkt);
	
	//der Hamster folgt den Zeigern richtungAbbruch in den Zellen, falls er Mais auf dem
	//Feld hat liegen lassen, auf dem er die Suche abgebrochen hat. Falls er keinen Mais
	//zurckgelassen hat, folgt er den Zeigern nur solange sie nicht in der Nhe einer durch
	//unbekannteFinden gefunden Zelle liegen. Dann wre die Distanz zur Unbekannten ungleich
	//null.
	while ((aktuelleZelle.distanzZurUnbekannten==0&&!maisLiegengelassen)||maisLiegengelassen){
		if (standpunkt.xWert()!=abbruchStandpunkt.xWert()||
				standpunkt.yWert()!=abbruchStandpunkt.yWert()){
			drehenInHR(aktuelleZelle.richtungAbbruch);
			vorwaerts();
		}
		if (standpunkt.xWert()==abbruchStandpunkt.xWert()&&
				standpunkt.yWert()==abbruchStandpunkt.yWert()){
					break;
		}
	}
	if(!(standpunkt.xWert()==abbruchStandpunkt.xWert()&&
				standpunkt.yWert()==abbruchStandpunkt.yWert())){
					vorgaengerZellenSpeichern=false;
				}
	else{
		vorgaengerZellenSpeichern=true;
	}
	maisLiegengelassen=false;
}

//__________________________________________________________________________________

/**
erkunden()	
Der Hamster dreht sich sechs mal nach rechts und merkt sich in der aktuellen Zelle die
Beschaffenheit der sechs Seiten der Zelle und ob er die Nachbarzellen kennt und ob Mais auf
ihnen liegt.
*/

public void erkunden(){
	//so wird keine Zelle zweimal erkundet, wichtig wegen des Zhlers "anzahlUnbekannte"
	if(vorgaengerZellenSpeichern&&!aktuelleZelle.zelleErkundet){
		
	//die Beschaffenheit der sechs Seiten der Zelle werden untersucht
		for(int i=0;i<6;i++){
			if ((lookForward() & WALLMASK) == WALL){
				aktuelleZelle.setzeWand(blickrichtung);
				lohntZelle(blickrichtung);
			}
			else{
				aktuelleZelle.setzeKeineWand(blickrichtung);				
				if(zelleBekannt(koordinatenBlickrichtung(standpunkt,blickrichtung))){
					aktuelleZelle.setzeZelleBekannt(blickrichtung,standpunkt);
					--anzahlUnbekannte;
				}
				else{
					if((lookForward() & CORNMASK) == CORN){
						aktuelleZelle.erreichbarerMais[blickrichtung]=true;
					}
					
					if (lohntZelle(blickrichtung)) ++anzahlUnbekannte;
					}
					
				if((lookForward() & CORNMASK) == CORN){
					aktuelleZelle.erreichbarerMais[blickrichtung]=true;
				}	 	
			}
			rechtsDrehen();
		}
	}
	aktuelleZelle.zelleErkundet=true;
	
	//die Distanz zur Heimatzelle wird kontrolliert
	distanzenKontrolle(standpunkt);
	
}

/*
naechsterSchritt()
Falls eine Nachbarzelle unbekannt ist und erreichbar, dreht der Hamster sich in ihre Richtung.
Dabei whlt whlt er zuerst die nrdlichste mgliche unbekannte Zelle. Falls es keine
umliegende nbekannte Zelle geben soltte, wird die globale Variable	vorgaengerZellenSpeichern
gleich "false" gesetzt.
**/

public void naechsterSchritt(){
	
	int i=0;
	
	//in der durch den richtungen[]-Array festgelegten Reihenfolge werden die Zellen in
	//verschiedenen Himmelsrichtungen ausprobiert. Ist eine Zelle unbekannt und erreichbar
	//betritt der Hamster sie.
		for (; i<6; i++){
			if(!aktuelleZelle.umgebungBekannt[richtungen[i]]
				&&(aktuelleZelle.waende[richtungen[i]]==KEINE_WAND)){
				if(!((vorgaengerZellenSpeichern==false)
					&&(aktuelleZelle.gesuchteUnbekannte==false))){
					drehenInHR(richtungen[i]);
					vorgaengerZellenSpeichern=true; //man betritt neues Gebiet
					distanz=aktuelleZelle.distanzHeimat; //der Distanz Zhler wird korrigiert
					i=UNGUELTIG-1;	
				}
				
			}
		
		}
	
	//falls alle Seiten bekannt sind, wird eine die zuletzt entdeckte unbekannte Zelle gesucht
	//(unebekannteFinden()) und der Hamster auf kurzem Weg zu ihr gefhrt
	//(wegZurUnbekannten())
	if(i==6&&vorgaengerZellenSpeichern){
		unbekannteFinden(standpunkt);
		drehenInHR(wegZurUnbekannten(standpunkt));
		vorgaengerZellenSpeichern=false;
	}
	
	if(i==6&&!vorgaengerZellenSpeichern){
	drehenInHR(wegZurUnbekannten(standpunkt));

	}
		
}

/**
vorwaerts()
Der Hamster geht vorwrts (forward()) und legt Zellen in "labyrinth" an. Dabei werden die 
Variablen standpunktAlt und standpunkt, sowie distanz und aktuelleZelle aktualisiert.
*/
	
public void vorwaerts(){
	
	if(!super.forward()){
		 if (verbose()) log("Kollision!!!\n");
	}
		
	standpunktAlt=standpunkt;
	standpunkt=koordinatenBlickrichtung(standpunktAlt,blickrichtung);
	
	if (vorgaengerZellenSpeichern){
			distanz=distanz+1; //Die Distanz wird nur erhht wenn man neues Gebiet betritt

	}
		
	//wenn in "labyrinth" zum aktuellen Standpunkt nochkeine Zelle existiert, wird sie
	//angelegt
	if(labyrinth[standpunkt.xWert()][standpunkt.yWert()]==null){
		labyrinth[standpunkt.xWert()][standpunkt.yWert()]
						=new Zelle(standpunkt,umgekehrteBlickrichtung(blickrichtung),distanz);
	}
						//der Konstruktor mu mit umgekehrter Blickrichtung
						//aufgerufen werden, um die Herkunftsrichtung festzuhalten
						
	//die aktuelle Zelle existiert einmal im Speicher "labyrinth" und zum einfacheren
	//Zugrriff in der Variablen "aktuelle Zelle" 
	aktuelleZelle=labyrinth[standpunkt.xWert()][standpunkt.yWert()];
	
}

/**
maisSammeln()
Der Hamster hebt den Mais auf der aktuellen Zelle auf. Sind mehr Krner in der Zelle als der
Hamster tragen kann, wird die Anzahl der brig gelassenen Krnern gespeichert, aber das
Maximum mitgenommen
*/

public void maisSammeln(){
	if (getAvailableCorn()>(CORNCARRY_MAX-getCarriedCorn())){
				aktuelleZelle.leftCorn=(getAvailableCorn()-(CORNCARRY_MAX-getCarriedCorn()));
	}
	take(CORNCARRY_MAX);
}

/**
sucheAbbrechen()
Liefert "true" zurck, wenn der Hamster die Backen voll hat oder die Anzahl der getragenen
Krner grer als die Distanz zur Heimat ist. Wurde Mais zurckgelassen, wird dies nur in
der maisLiegengelasen Variable vermerkt, falls das achtfache der Anzahl der zurckgelassenen
Krner die Distanz zur Heimat bersteigt.  
*/

public boolean sucheAbbrechen(){
	distanzenOptimieren();
	if (getCarriedCorn()<CORNCARRY_MAX&&(getCarriedCorn()>aktuelleZelle.distanzHeimat)){
		if (!aktuelleZelle.maisAngrenzend()){
			maisLiegengelassen=false;
			return true;
		}
	}
	if (getCarriedCorn() == CORNCARRY_MAX) {
			if (getAvailableCorn()>=20&&getAvailableCorn()*5>aktuelleZelle.distanzHeimat)
				maisLiegengelassen=true;
			if (getAvailableCorn()<20&&getAvailableCorn()*10>=aktuelleZelle.distanzHeimat)
				maisLiegengelassen=true;
			return true;
		}
	else return false;
}

//__________________________________________________________________________________

/**
rechtsDrehen() und linksDrehen()
Kompassfunktionen, die turn() aufrufen und gleichzeitig die blickrichtung-Variable korrigieren
*/

public void rechtsDrehen(){		
	turn(TURN_RIGHT);
	if (blickrichtung == 5) blickrichtung=0;
	else blickrichtung=blickrichtung+1;
}

public void linksDrehen(){
	turn(TURN_LEFT);
	if (blickrichtung==0) blickrichtung=5;
	else blickrichtung=blickrichtung-1;
}

/**
koordinatenBlickrichtungen()
Gibt die Koordinaten der Zelle in Blickrichtung zurck, wobei die Koordinaten des
aktuellen Standpunktes bergeben werden.
*/

public Koordinaten koordinatenBlickrichtung(Koordinaten aktStandp, int blickR){
	switch(blickR){
		case 0 : return new Koordinaten(aktStandp.xWert()+1,aktStandp.yWert()+1) ;
			
		case 1 : return new Koordinaten(aktStandp.xWert()+1,aktStandp.yWert());
			
		case 2 : return new Koordinaten(aktStandp.xWert(),aktStandp.yWert()-1);
			
		case 3 : return new Koordinaten(aktStandp.xWert()-1,aktStandp.yWert()-1);
			
		case 4 : return new Koordinaten(aktStandp.xWert()-1,aktStandp.yWert());
			
		case 5 : return new Koordinaten(aktStandp.xWert(),aktStandp.yWert()+1);
			
		default: return new Koordinaten(aktStandp.xWert(),aktStandp.yWert()); 

	}
}

/**
zelleBekannt()
berprft anhand der Koordinaten einer Zelle, ob sie bekannt ist bzw. angelegt wurde
*/

public boolean zelleBekannt(Koordinaten koodZelle){
		Zelle eineZelle;
		eineZelle=labyrinth[koodZelle.xWert()][koodZelle.yWert()];
		if(eineZelle!=null)	return true;
		else return false;
	}

/**
umgekehrteBlickrichtung()
Gibt die entgegengesetzte Blickrichtung zurck.
*/

public int umgekehrteBlickrichtung(int blickR){
	if (blickR<3) return blickR+3;
	else return blickR-3;
}

/**
drehenInHR()
Dreht den Hamster in eine gegebene Himmelsrichtung
*/

public void drehenInHR(int hr){
	while(blickrichtung!=hr){
	rechtsDrehen();
	}
}

/**
distanzenKontrolle()
Die Distanz zur Heimat in der Zelle deren Koordinaten bergeben werden, wird mit den Werten in
den umliegenden Zellen abgeglichen.
*/

public int distanzenKontrolle(Koordinaten koodKZelle){
	Zelle kontrollierteZelle=labyrinth[koodKZelle.xWert()][koodKZelle.yWert()];
	int i=0;
	int j=0;
	int besteRichtung=UNGUELTIG;
	int kleinsteDistanz=kontrollierteZelle.distanzHeimat; //diese Distanz gilt es zu schlagen
	
	for (; i<6; i++){
		if(kontrollierteZelle.umgebungBekannt[i]){ //nur bekannte Zellen knnen berprft
											//werden				
			if((kleinsteDistanz>
				(labyrinth[koordinatenBlickrichtung(koodKZelle,i).xWert()]
				[(koordinatenBlickrichtung(koodKZelle,i)).yWert()])
				.distanzHeimat)
				&&(aktuelleZelle.waende[i]==KEINE_WAND)){//fr den Blick in die
								//Nachbarzelle und den Vergleich der Distanzen,
								//falls keine Wand dazwischen ist
							
					besteRichtung=i; //die momentan beste Zelle liegt bei i
											
					kleinsteDistanz=(labyrinth[koordinatenBlickrichtung
						(koodKZelle,i).xWert()] [(koordinatenBlickrichtung
						(koodKZelle,i)).yWert()]).distanzHeimat;
				}
		}
	}

	//Falls die gnstigste benachbarte Zelle um mehr als einen Schritt nher zum
	//Heimatfeld liegt, werden die Distanzen der umliegenden Felder korrigiert:	
	if ((kontrollierteZelle.distanzHeimat-kleinsteDistanz)>1){
		kontrollierteZelle.distanzHeimat=kleinsteDistanz+1;
	}
	
	for (; j<6; j++){
		if (j!=besteRichtung&&kontrollierteZelle.umgebungBekannt[j]){
			//..allerdings nur wenn die Distanz grer als die der aktuellen Zelle ist
			//(bei Gleichheit geschieht nichts!)
			if(kontrollierteZelle.distanzHeimat<
				((labyrinth[koordinatenBlickrichtung(koodKZelle,j).xWert()]
			[(koordinatenBlickrichtung(koodKZelle,j)).yWert()])
			.distanzHeimat)-1){
							
				(labyrinth[koordinatenBlickrichtung(koodKZelle,j).xWert()]
				[(koordinatenBlickrichtung(koodKZelle,j)).yWert()])
				.distanzHeimat=kleinsteDistanz+2;
			}					
		}
	}

	
	if (besteRichtung!=UNGUELTIG) return besteRichtung;
	else {
		return 12; //der Hamster dreht sich zweimal um die eigene Achse, dieser Zustand
				//solte eigentlich nicht erreicht werden.
		}
}

/*
distanzenOptimieren()
Die Methode distanzenKontrolle() Wird fr alle gespeicherten Zellen aufgerufen.
*/

public void distanzenOptimieren(){
	Koordinaten koodOZelle;
	int i=0;
	int j=0;
	
	for(int l=0;l<10;l++){
		for (;i<60;i++){
			for (int k=0;k<60;k++){
				j=k;
				if (labyrinth[i][j]!=null){
					koodOZelle=new Koordinaten(i,j);
					distanzenKontrolle(koodOZelle);
				}
			}
		}
	}
}

/**
unbekannteFinden()
Virtuell wird den Zeigern zur letzten
unbekannten Zelle gefolgt und die Distanzen hnlich der Wegoptimierung nach Hause
eingetragen. Unterschied: es wird die Distanz vom Ausgangspunkt zur unbekannten Zelle
gezhlt. Das bedeutet, da tr{ok die Zelle, mit der jeweils hchsten Distanz betreten sollte,
sie ist mit Sicherheit nher zur unbekannten Zelle.
*/

public void unbekannteFinden(Koordinaten standpunktV){
	Zelle aktuelleZ;
	Koordinaten aktuelleK=standpunktV;
	int wegZaehler=1; //1 damit man betrachtete Zellen von unangetasteten unterscheiden kann
	int i;
		
	labyrinthBereinigen();
	aktuelleZ=labyrinth[aktuelleK.xWert()][aktuelleK.yWert()];
	aktuelleZ.distanzZurUnbekannten=wegZaehler;
	
	//solange in den virtuell besuchten Zellen nichts mehr zu erkunden gibt, wird
	//die Distanz, die vom bergebenen Standpunkt virtuell zurckgelegt wurde, in
	//den Zellen eingetragen (distanzZurUnbekannten)
	while(!aktuelleZ.mehrErkundbar()){
		i=0;
		
		//wie forward() auf dem richtigen Labyrinth:
		aktuelleK=koordinatenBlickrichtung(aktuelleK,aktuelleZ.richtungHerkunft);
		aktuelleZ=labyrinth[aktuelleK.xWert()][aktuelleK.yWert()];
		
		wegZaehler++;
		aktuelleZ.distanzZurUnbekannten=wegZaehler;
		
		//die Distanz distanzZurUnbekannten wird mit den in den umliegenden Zellen
		//gespeicherten Distanzen zur 
		//unbekannten Zelle verglichen. Sind die Distanzen um mehr als eins geringer, werden
		//werden sie korrigiert.
		for (; i<6; i++){
			if (aktuelleZ.umgebungBekannt[i]){
				if(aktuelleZ.distanzZurUnbekannten-1>
					((labyrinth[koordinatenBlickrichtung(aktuelleK,i).xWert()]
					[(koordinatenBlickrichtung(aktuelleK,i)).yWert()])
					.distanzZurUnbekannten)){
			
					(labyrinth[koordinatenBlickrichtung(aktuelleK,i).xWert()]
					[(koordinatenBlickrichtung(aktuelleK,i)).yWert()])
					.distanzZurUnbekannten=aktuelleZ.distanzZurUnbekannten-1;
				}					
			}
		}			
	}
	if (aktuelleZ.mehrErkundbar()) aktuelleZ.gesuchteUnbekannte=true;	
}

/**
wegZurUnbekannten()
Gibt in Abhngigkeit von einer bergebenen Koordinate die Himmelsrichtung zurck, in die der
Hamster gedreht werden mu, um auf kurzem Weg zur unbekannten Zelle zu gelangen. 
*/

public int wegZurUnbekannten(Koordinaten standpunktV){
	Zelle aktuelleZ;
	Koordinaten aktuelleK=standpunktV;
	int besteRichtung=0;
	int groessteDistanz=0;
	int i=0;
	
	aktuelleZ=labyrinth[aktuelleK.xWert()][aktuelleK.yWert()];
	
	//die in den umliegenden Zellen gesdpeicherten distanzZurHeimat-Werte werden berprft
	//und die Himmelsrichtung der Zelle mit der grten Distanz unter der Variable
	//besteRichtung gespeichert, die dann zurckgegeben wird.
	for(; i<6; i++){
		if (aktuelleZ.umgebungBekannt[i]){
			if((labyrinth[koordinatenBlickrichtung(aktuelleK,i).xWert()]
					[(koordinatenBlickrichtung(aktuelleK,i)).yWert()]).distanzZurUnbekannten
				>groessteDistanz){
				
				groessteDistanz=(labyrinth[koordinatenBlickrichtung(aktuelleK,i).xWert()]
					[(koordinatenBlickrichtung(aktuelleK,i)).yWert()]).distanzZurUnbekannten;
					
				besteRichtung=i;
			}
		}
	}
	return besteRichtung;
}

/**
labyrinthBereinigen()
Da die Informationen, die zur Suche der unbekannten Zellen in den Zellobjekten gespeichert
werden (distanzZurUnbekannten und gesuchteUnbekannte), nur von temporrer Natur sind, mssen
sie nach der Suche gelscht bzw. zurckgesetzt werden.
*/

public void labyrinthBereinigen(){
	int i=0;
	int j=0;
	for (;i<60;i++){
		for (int k=0;k<60;k++){
			j=k;
			if (labyrinth[i][j]!=null){
				(labyrinth[i][j]).distanzZurUnbekannten=0;
				(labyrinth[i][j]).gesuchteUnbekannte=false;
			}
		}
	}
}

/**
lohntZelle()
Falls die gesamte Umgebung einer unbekannten Zelle bekannt ist und diese Zelle keinen Mais
enthlt, kann sie trotzdem in labyrinth[][] angelegt werden und mu nicht mehr erkundet
werden. Ist dies der Fall, gib lohntZelle() "false" zurck und legt die Zelle an.
*/

public boolean lohntZelle(int blickR){
	Koordinaten virtK=koordinatenBlickrichtung(standpunkt,blickR);
	Koordinaten nachbarK;
	Zelle nachbarZ;
	Zelle neueZ;
	int zaehler=0;
	
	//berprft ob die Umgebung der zu berprfenden Zelle schon bekannt ist.
	for(int i=0;i<6;i++){
		nachbarK=koordinatenBlickrichtung(virtK,i);
		if(!((nachbarK.yWert()>59||nachbarK.yWert()<0)||
			((nachbarK.xWert()>59||nachbarK.xWert()<0)))
			&&(labyrinth[nachbarK.xWert()][nachbarK.yWert()]!=null)){
				
			nachbarZ=labyrinth[nachbarK.xWert()]
					[nachbarK.yWert()];
			if(!nachbarZ.erreichbarerMais[umgekehrteBlickrichtung(i)]){
				zaehler++;
			}
		}
	}
	
	//ist die Umgebung bekannt und verweist keine der umliegenden Zellen auf Mais in der
	//zu berprfenden Zelle, wird sie angelegt und die Informationen aus den umliegenden
	//Zellen werden in die gerade angelegte Zelle bertragen.
	if (zaehler==6&&labyrinth[virtK.xWert()][virtK.yWert()]==null){
		labyrinth[virtK.xWert()][virtK.yWert()]
						=new Zelle(virtK,umgekehrteBlickrichtung(blickR),distanz+1);
					
		neueZ=labyrinth[virtK.xWert()][virtK.yWert()];
		
		for(int j=0;j<6;j++){
			nachbarK=koordinatenBlickrichtung(virtK,j);
			nachbarZ=labyrinth[nachbarK.xWert()]
					[nachbarK.yWert()];
			neueZ.waende[j]=nachbarZ.waende[umgekehrteBlickrichtung(j)];
			
			if (neueZ.waende[j]==KEINE_WAND){
				neueZ.setzeZelleBekannt(j,virtK);				
				if (j!=umgekehrteBlickrichtung(blickR)){
							anzahlUnbekannte--;
				}
			}
			
			neueZ.erreichbarerMais[j]=false;
			
		}
			
		
	neueZ.zelleErkundet=true;
	distanzenKontrolle(virtK);
		
		return false;
	}
	return true;
}
						
			
			
		
		
	
//__________________________________________________________________________________

/* Die Klasse Zelle. Ihr Zellobjekte werden in labyrinth[][] gespeichert. Sie enthlt
Methoden, die Informationen ber die Zelle selbst und angrenzende Zellen zurckgeben.
Auerdem -falls ntig-  Methoden, mit denen sich die Eigenschaften der Zelle modifizieren
lassen. Beschrieben wird jede Zelle durch drei Arrays in denen Informationen ber die
Nachbarzellen in den sechs Himmelsrichtungen gespeichert werden. Auerdem enthlt sie
Variablen, die Charakteristika, wie Entfernung zur Heimatzelle usw. speichern. Zum Teil
werden diese Werte durch den Aufruf des Zelle-Konstruktors belegt. 
*/

public class Zelle {		//Zellen, die in labyrinth[][] gespeichert werden.
		
	Koordinaten k = new Koordinaten(M,M);
	int richtungHerkunft;
	int richtungAbbruch;
	int distanzHeimat=0;
	int distanzZurUnbekannten=0; //Distanz, die auf dem virtuellen Weg  
								//zur Unbekannten Zelle zruckgelegt wird
	int leftCorn=0;	//nicht aufgenommene Krner
	int waende[]={UNBEKANNT,UNBEKANNT,UNBEKANNT,UNBEKANNT,UNBEKANNT,UNBEKANNT};
		//Wnde der 6 Himmelsrichtungen
	boolean erreichbarerMais[]=new boolean[6]; //ist in dieser Richtung Mais erreichbar? 
	boolean umgebungBekannt[]=new boolean[6]; //Status angrenzender Zellen
	boolean zelleErkundet=false;
	boolean gesuchteUnbekannte=false;
		
	public Zelle() {	//einfacher Konstruktor
	}
	
	public Zelle(Koordinaten aktuelleK, int herkR,  //richtiger Konstruktor
										int uebergDH) {	
										
		Koordinaten k = aktuelleK;
		richtungHerkunft = herkR;
		distanzHeimat=uebergDH;
	}
	
	public void setzeWand(int hRichtung){
		waende[hRichtung]=WAND;	
	}
	
	public void setzeKeineWand(int hRichtung){
		waende[hRichtung]=KEINE_WAND;
	}
	
	//setzt den Speicher der aktuellen Zelle, so, da die in Blickrichtung angrenzende Zelle 
	//als bekannt gesetzt wird
	public void setzeZelleBekannt(int blickZelle, Koordinaten Standpunkt){
		umgebungBekannt[blickZelle]=true;
		(labyrinth[koordinatenBlickrichtung(Standpunkt,blickZelle).xWert()]
			[(koordinatenBlickrichtung(Standpunkt,blickZelle)).yWert()])
				.umgebungBekannt[umgekehrteBlickrichtung(blickZelle)]=true;
						//Dies greift auf die benachbarte Zelle zu um die erkundete
						//Zelle auch in der Nachbarzelle als "bekannt" zu setzen
		
	}
	
	public boolean mehrErkundbar(){
		int i=0;
		for (;i<6;i++){
			if(!umgebungBekannt[i]&&(waende[i]==KEINE_WAND)) return true;
		}
		return false;
	}
	
	public int anzahlWaende(){
		int i=0;
		int anzahlWaende=0;
		for (;i<6;i++){
			if (waende[i]==WAND) anzahlWaende++;
		}
		return anzahlWaende;
	}
	
	public boolean maisAngrenzend(){
		for(int i=0;i<6;i++){
			if(erreichbarerMais[i]) return true;
		}
		return false;
	}
		
		
}
	
//__________________________________________________________________________________

/**
Die Klasse Koordinaten. Sie enthlt nur die x- und y-Koordinate sowie zwei Methoden,
die deren Werte zurck gibt.
*/

public class Koordinaten{
	
	int x;
	int y;
	
	public Koordinaten(){	//einfacher Konstruktor, Koordinaten des Mittelpinktes werden
							//zugewiesen
		x=M;
		y=M;
		}
	
	public Koordinaten(int ueX, int ueY){		//richtiger Konstruktor Koordinatenpaar
		x=ueX;
		y=ueY;
	}
	
	public int xWert(){		//Abruf der Werte der Koordinaten
		return x;
	}
			
	public int yWert(){
		return y;
	}
	
}

//__________________________________________________________________________________

/**
Autor(en) des Hamsters.
*/

public String getHamsterAuthor() { return "Timo Heinrich"; }

/**
Datum der Hamsterversion.
*/

public String getHamsterDate() { return "30.4.02"; }

/**
Hamsterversion.
*/

public String getHamsterVersion() { return "1.0"; }

}
