package warhamster;
import algds.c2002.*;
import java.awt.Point;
/**
Erweiterung der Kaspelung eines punktes um hilfskonstruktoren.
*/
class Hexpoint
extends Point
implements Constants,Hexfield_Constants{
    //**********************Constructors**********************
    /**Standardkonstruktor.*/
    public Hexpoint(){
        super();
    }
    /**Standardkonstruktor.*/
    public Hexpoint(int x, int y){
        super(x,y);
    }
    /**Standardkonstruktor.*/
    public Hexpoint(Point p){
        super(p);
    }
    /**Hilfskonstruktor, um neuen punkt aus Quellpunkt und gegangener richtung zu kontruieren.*/
    public Hexpoint(Point Origin,byte Direction){
        switch (Direction){
            case NORTH  : {x=Origin.x  ;y=Origin.y+2;break;}
            case NEAST  : {x=Origin.x+1;y=Origin.y+1;break;}
            case SEAST  : {x=Origin.x+1;y=Origin.y-1;break;}
            case SOUTH  : {x=Origin.x  ;y=Origin.y-2;break;}
            case SWEST  : {x=Origin.x-1;y=Origin.y-1;break;}
            case NWEST  : {x=Origin.x-1;y=Origin.y+1;break;}
            default     : throw (new IllegalArgumentException("Direction out of range: "+Direction));
        }
    }
    /**Hilfskonstruktor, um neuen punkt aus Quellfeld und gegangener richtung zu kontruieren.*/
    public Hexpoint(Hexfield Origin,byte Direction){
        switch (Direction){
            case NORTH  : {x=Origin.Position.x  ;y=Origin.Position.y+2;break;}
            case NEAST  : {x=Origin.Position.x+1;y=Origin.Position.y+1;break;}
            case SEAST  : {x=Origin.Position.x+1;y=Origin.Position.y-1;break;}
            case SOUTH  : {x=Origin.Position.x  ;y=Origin.Position.y-2;break;}
            case SWEST  : {x=Origin.Position.x-1;y=Origin.Position.y-1;break;}
            case NWEST  : {x=Origin.Position.x-1;y=Origin.Position.y+1;break;}
            default     : throw (new IllegalArgumentException("Direction out of range."));
        }
    }
    //********************MemberFunctions*********************
    /**Selbsterklaerend*/
    public String toString(){
        return "Hexpoint("+x+","+y+")";
    }
}