package warhamster;
import algds.c2002.*;
import java.awt.*;
import java.util.*;
/**
Strategie:<br>
*Der Hamster bewertet alle felder, die er betritt, wobei gilt, je groesser der wert eines feldes,
*desto wahrscheunlicher ist es, dass er es betritt.<br>
*Die bewertungsfunktion {@link warhamster.Hexfield#value() Hexfield.value()} befindet sich
*dabei in der klasse Hexfield, also fordert der Hamster theoretisch jedes hexfeld auf sich selbst zu bewerten.
*Dies geschah aus wiederverwendungsgruenden.<br>
*Um zu entscheiden, auf welches feld er zugeht, Summiert der wahamster die werte aller umliegenden
*erreichbaren felder zu einer summe s, wobei er im norden anfaengt, und dann im uhrzeigersinn summiert.
*Sodann errechnet er einen zufalsswert r, wobei glt: 0&lt=r&lts. Dann beginnt warhamster eine neue summe t
*aller umliegenden erreichbahren felder zu bilden, wobei er wieder im Uhrzeigersinn vorgeht. Jetzt testet
*er aber immer, nachdem er den Wert eines Feldes beruecksichtigt hat, ob gilt: r&ltt. ist dies der Fall,
*so hoert er auf die summe weiter zu bilden, merkt sich die richtung in welche das zuleztt beruecksichtigte
*feld lag, und geht ind diese, betritt also das feld, was zuletzt zur summe beigetragen hat. Je hoeher
*der wert des feldes war, desto mehr hatt es zur summe beigetragen, und desto hoeher ist die wahrscheinlichkeit,
*dass es betreten wird.<br>
*Jedes hexfeld bis auf das Heimatfeld besitzt eine variable {@link warhamster.Hexfield#Homepath}
*in der das anliegende Feld mit dem kleinsten heimatweg gespeichert wird, sowie eine variable 
*{@link warhamster.Hexfield#Pathlength} in welcher die entfernung zum heimatfeld gespeichert ist. 
*Betritt der hamster ein feld, merkt er sich die kleinste heimpfadlaenge (w) und tested dann, ob die laenge 
*des heimpfads des aktuellen hexfelds w+1 ist. Ist dies nicht der fall,so veraendert er 
*{@link warhamster.Hexfield#Homepath} und {@link warhamster.Hexfield#Pathlength} so, dass dies wieder der fall
*ist und, da dies auswirkungen auf die angrenzenden felder haben koennte ,fuert er dies fuer jedes 
*bekannte angrenzende feld ebenfalls aus, was zu einer rekursiven optimierung der heimatwege jedes
*bekannten feldes fuehrt.<br>
*Findet er korn, so nimmte er so viel auf wie er tragen kann. Er geht nach hause,
*sobald er die backen voll hat. Kommt er zufaellig am heimatfeld vorbei, legt er alles ab.<br>
*Sobald warhamster solange herumgelaufen ist ohne korn zu finden, dass seine schrittanzahl +
*haimatweglaenge 199 uebersteigt, geht er davon aus, das es sich nicht mehr lohnt, das labyrinth weiter zu
*erkunden, und geht nach hause und stoppt.
*/
public class	Warhamster
extends 	Hamster2
implements 	Constants,Hexfield_Constants{
    //********************MemberFunctions*********************
    /**
    *Verbesserte forward methode von Hamster.
    *Schliesst erst eine kollision aus, ruft dann super.forward() auf, erhoet die Schrittzahl um eins,
    *speichert das neu betretene feld und fordert es auf sich mit hilfe des hamsters zu erkunden.<br>
    *Unteraufrufe:<ul>
    <li>{@link warhamster.Hexfield#get(byte Direction)} - zum erhalten des in direction liegenden Felds</li>
    <li>{@link warhamster.Hexfield#explore()} - fordert {@link #Current} auf sich selbst mit hilfe von warhamster zu erkunden</li>
    </ul>
    */
    public boolean  forward(){
        if ((Current.Border[Looking]==WALL)||
            (Current.Border[Looking]==CLIFFUP)||
            ((Current.Border[Looking]==CLIFFDOWN)&&!GoHome&&(!Current.get(Looking).Visited)
            ))
            return false;
        if (verbose()&&(Current.Border[Looking]==CLIFFDOWN))
            logln("Jumped to death.");

//ChS
        if (!super.forward()) throw new RuntimeException("Forward buggy!");
// Wegen sowas wirft man keinen Error!!
//      if (!super.forward()) throw new Error("Forward buggy!");
//ChS

        Steps++;
        //if (verbose()) logln("Stepped forward towards: "+Current);
        Current=Current.get(Looking).explore();
        return true;
    }
    /**Selbsterklaerend.*/
    public String   getHamsterAuthor() {return "HerbaCasipulensisGigantis und des Pudels Kern";}
    /**Selbsterklaerend.*/
    public String   getHamsterVersion(){return "0.000000... RC1";}
    /**
    *Sorgt dafuer, dass der hamster auf den kuerzesten weg nach hause geht. Wird i.a von
    *{@link warhamster.Hexfield#explore()} aufgerufen, wenn die backen voll sind.<br>
    *Unteraufrufe:<ul>
    <li>{@link #stepTowards(Hexfield toGoTo)} - um zum Feld zu gehen, welches das naechste auf dem heimatpfad ist</li>
    </ul>
    */
    public boolean  goHome(){
        if (Stop) GoHome=true;
        logln("Going home.");
        if (Stop) logln("Stopping!");
        while (GoHome) stepTowards(Current.Homepath);
        logln("Reached home.");
        return true;
    }
    /**
      Herzstueck des hamsters. Initialiesiert alle wichtigen noch nicht initialisierten variablen,
      welche nicht bei instanziierung initialisiert werden.Arbeitsweise der haptnachrichtenschleife in
      Strategieerklaerung erlaeutert.<br>
      Unteraufrufe:<ul>
        <li>{@link warhamster.Hexfield#get(byte Direction)} - zum erhalten der anliegenden felder in eine richtung</li>
        <li>{@link warhamster.Hexfield#invert(byte Direction)} - um Direction zu invertieren</li>
        <li>{@link #stepTowards(Hexfield toGoTo)} - um zum feld zu gehen, fuer das sich entschieden wurde</li>
        <li>{@link #goHome()} - um nach hause zu gehen</li>
        </ul>
    */
    public void     run(){
    try{
        Hexfield.Map    = new HexfieldHash(3000,.95f);
        Hexfield.Home   = new Hexfield();
        Hexfield.Soldier= this;
        Current         = Hexfield.Home;
        Home            = Hexfield.Home;
        Map             = Current.Map;
        Current.explore();
        
        byte NextField=0;
        double Valuesum=0;
        double Decision=0;
        do{
            Valuesum=0;
            //Sum up all fields
            for (byte i=0;i<6;i++){
                if ((Current.get(i)==null)||
                    (Current.Border[i]==WALL)||
                    (Current.Border[i]==CLIFFUP)||
                    ((Current.Border[i]==CLIFFDOWN)&&!Current.get(i).Visited)||
                    (i==Current.invert(Looking)))
                    continue;
                Valuesum+=Current.get(i).Value;
            }
            Decision=CEO.nextDouble()*Valuesum;
            Valuesum=0;
            //Decide where to go
            for (NextField=0;NextField<6;NextField++){
                if ((Current.get(NextField)==null)||
                    (Current.Border[NextField]==WALL)||
                    (Current.Border[NextField]==CLIFFUP)||
                    ((Current.Border[NextField]==CLIFFDOWN)&&!Current.get(NextField).Visited)||
                    (NextField==Current.invert(Looking)))
                    continue;
                Valuesum+=Current.get(NextField).Value;
                if (Valuesum>Decision) break;
            }
            NextField = (NextField<6)?(NextField):(Current.invert(Looking));
            if (verbose()) logln("Attempting to go to :"+Current.get(NextField));
            if (!stepTowards(Current.get(NextField)))
//ChS
                throw new RuntimeException("Basic Decision buggy!");
// Wegen sowas wirft man keinen Error!!
//              throw new Error("Basic Decision buggy!");
//ChS
            if (GoHome||Stop) goHome();
        }while(!Stop);
        //while ((Current!=Home));
    }
    catch (Throwable X){
       logln("\nRun :"+X.getClass()+" thrown. ->"+X.getMessage());
       X.printStackTrace();
       Stop=true;goHome();
    }
    }

    /**
    Routine um hamster nach toGoTo gehen zu lassen. Parameter muss an derzeitigen aufenthaltsort des hamsters
    grenzen und erreichbar sein.<br>
    Unteraufrufe:<ul>
    <li>{@link #forward()} -  um hamster nach ausrichtung auf richtiges feld zu schicken</li>
    </ul>
    */
    public boolean  stepTowards(Hexfield toGoTo){
        for (byte i=0;i<6;i++){
            if (Current.get(i)==toGoTo) break;
            if (i==5) return false;
        }
        for (byte i=0;i<6;i++){
            turn(TURN_RIGHT);
            if (Current.get(Looking)==toGoTo) break;
        }
        if (!forward()){
            logln("Bug occured while going towards: "+toGoTo);
            return false;
        }
        return true;
    }
    /**
    An unsere beduerfnisse angepasste turn() - methode. Veraendert je nach drehung variable, die anzeigt,
    in welche richtung hamster schaut.
    */
    public void     turn(int Direction){
        //if (verbose()) logln("Turning towards: "+Direction+"\nLooking before turn: "+Looking);
        switch(Looking){
        case NORTH:
            if (Direction==TURN_LEFT) Looking=6;
            break;
        case NWEST:
            if (Direction==TURN_RIGHT) Looking=-1;
            break;
        }
        if (Direction==TURN_LEFT) --Looking;
        else ++Looking;
        super.turn(Direction);
        //if (verbose()) logln("Looking after  turn: "+Looking);
    }

    //*************************Fields*************************
    /**Speichert himmelsrichtung, in welche hamster gerade schaut.*/
    public byte         Looking = NORTH;
    /**Zaehlt gelaufene schritte seit hamster das letzte mal korn aufgehoben, oder heimatfeld besucht hat.*/
    public long         Steps   = 0;
    /**Chief Executive Officer. Zufallsgenerator, der darueber entscheidet, welches feld warhamster betritt.*/
    public Random       CEO     = new Random();
    /**Flagge die gesetzt wird, um warhamster nach hause zu schicken.*/
    public boolean      GoHome  = false;
    /**Flagge die gesetzt wird, um warhamster zu stoppen.*/
    public boolean      Stop    = false;
    /**Speichert hexfeld, auf dem sich der hamster gerade befindet.*/
    public Hexfield     Current =null;
    /**Speichert heimatfeld.*/
    public Hexfield     Home    =null;
    /**Hash, in dem sich alle hexfelder befinden, von denen gewiss ist, dass sie existieren.
    Als schluessel werden punkte mit Koordinaten des Hexfelds benutzt.*/
    public HexfieldHash Map     =null;
}
/*
int Turns=CEO.nextInt(3);
boolean LeftRight= CEO.nextBoolean();
for (int i=0;i<Turns;i++)
    turn((LeftRight)?(TURN_RIGHT):(TURN_LEFT));
if (GoHome){
            GoHome=!atHome();
            if (GoHome) while(Current.get(Looking)!=Current.Homepath) turn(TURN_RIGHT);
        }
*/